#|
	This is a collection of goodies that I've put together, including
many to support my mathematical mission: math in the public domain.

	I've received much support from the community, and learned everything I
know from other folks' code: I've stolen some of the nice graphical tools from
ViSta, by Forrest Young; Frederic Udina provided the Gnuplot code, based on an
earlier work by Jan de Leew; I'd like to incorporate some more of the sapaclisp
stuff, but I've had a conflict with other things (in particular, a problem with
macros not working right after compiling).

	Anyway, here goes. This file is loaded from the original distribution
workspace, and should then be saved as another workspace. Then you'll have
added the calculus contingent to xlisp-stat. Good luck! I'm having fun; hope
you are!

								Andy Long
								Spring, 1997
|#

(def where-am-i-anyway (get-working-directory))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                   Save the old readtable:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(def *old-readtable* (copy-vector *readtable*))
;; Save these old eyes:
(def *PRINT-CASE* :downcase)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                         Load in help:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(help 'help)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; 			Gotta set this variable:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(def *symbol-list* nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; 			Set the andy directory to
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#+unix (def separator "/")
#+macintosh (def separator ":")
#+msdos (def separator "\\")
#+msdos (def *default-path* "c:\\xlispsta\\") ;; note 8 characters only!

(def *andy-default-path* 
     (concatenate 'string *default-path* separator "calculus" separator))
(def *gnuplot-default-path*
     (concatenate 'string *andy-default-path*
		  "gnuplot" separator "-xlisp-stat" separator))
(def *data-path*
     (list
      (concatenate 'string *default-path* "Data" separator)
      (concatenate 'string *andy-default-path* "examples" separator)
      ;; You can add more directories to this data path, if your data lives in
      ;; some other standard area....
      ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				New plot protos
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Now I create the proto which will assume all the weird new properties of a
;; scatterplot-proto that I want to provide:
(let ((new-slots '(plot-item lines-to-kill andy-options text)))
  (mapcar
   (lambda(x)
     (mapcar (lambda(y) (send x :add-slot y)) new-slots)
     (send x :slot-value 'instance-slots
	   (combine (send x :slot-value 'instance-slots) new-slots)))
   (list graph-proto scatterplot-proto spin-proto)))

(defproto andyplot-proto nil nil scatterplot-proto)
(defproto andyspin-proto nil nil spin-proto)

(defmacro normal-assessor (key slot prototype)
  `(defmeth ,prototype ,key (&optional (content nil set))
     (when set (setf (slot-value ',slot) content))
     (slot-value ',slot)))
;; I think that I should only need to create this accessor method for
;; graph-proto, and all the rest should be able to use it:
(normal-assessor :lines-to-kill lines-to-kill graph-proto)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				General Stuff: etc
;;
(set-working-directory
 (concatenate 'string *andy-default-path* "etc" separator))
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(load "backcomp.fsl")
;; Having loaded in back-compatibility, I can now begin to use strcat, instead
;; of that clunky concatenate command....

					; utilities (where do I put these?)
(load "utility.fsl")
(load "utility2.fsl")
(load "postscri.fsl")
					; for reading in data
(load "readfile.fsl")
					; obvious help 
(load "help.fsl")
(load "helpful.fsl")
(load "uber-pro.fsl")
(load "geoeas.fsl")
(load "inspect.fsl")
(load "readtab.fsl")
;; this didn't work well anyway! It's now an example...
;; (load "sheet.fsl")
(load "dialogs.fsl")
(load "tstamp.fsl")
(load "bitmap.fsl")
#+msdos (load "dos.lsp")
#+unix (load "unix.lsp")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				tutorials
;;
(set-working-directory (strcat *andy-default-path* "tutorial" separator))
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(load "tutorial.fsl")
(load "book.fsl")
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				Contributed: contrib
;;
;;(set-working-directory
;; (strcat *andy-default-path* "contrib" separator "sapaclisp" separator))
;; (load "all.lsp")
(set-working-directory (strcat *andy-default-path* "contrib" separator))
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(load "barchart.fsl")
(load "gnuplot.fsl")
(load "clmath.fsl")
(load "lisp3.fsl")
(load "f2cl_mac.fsl")
(load "eigen.fsl")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				Hulp
;;
(set-working-directory (strcat *andy-default-path* "hulp" separator))
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(load "manual.fsl")
(load "helper.fsl")
(load "hulp.fsl")
;;(load "machulp.fsl") ; already loaded by hulp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				Math Stuff:
;;
(set-working-directory (strcat *andy-default-path* "math" separator))
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; contains plot:
;;    plots lots of different structures (e.g. matrix, list, vector ...)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(load "plot.fsl")
;; If plotit takes too long to compile, or if it doesn't happen, replace the
;; load of the .fsl file below with the .lsp file:
(load "plotit.fsl")
;; (load "plotit.lsp")
(load "hidden.fsl")
(load "plotmeth.fsl")
(load "andyplot.fsl")
(load "obmeth.fsl")
(load "scatover.fsl")
(load "statplot.fsl")
;; and from 
;;************************************************************************
;; graphics.lsp 
;; contains code for new and revised graphics methods
;; copyright (c) 1991-94 by Forrest W. Young
;;************************************************************************
(load "vista.fsl")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				Linear Algebra
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Some lin-alg functions, and matrix-plot and matrix-plot-points
(load "matrix.fsl")
(load "linalg.fsl")

;; and some other math stuff:
(load "spline.fsl")
(load "regress.fsl")
(load "math.fsl")
(load "multivar.fsl")
(load "stats.fsl")
(load "power.fsl")
(load "probfuns.fsl")
(load "ucla.fsl")
(load "aliases.fsl")
(load "complex.fsl")
(load "data.fsl")
(load "specfunc.fsl")
(load "diffeq.fsl")
(load "pde.fsl")
(load "geostats.fsl")
(load "roots.fsl")
(load "steepest.fsl")
(load "taylor.fsl")
(load "fourier.fsl")
(load "bezier.fsl")
(load "menus.fsl")
(load "splus.fsl")
(load "nonlin.fsl")
(load "muller.fsl")
(load "histo.fsl")
(load "epidemio.fsl")
(load "inverse.fsl")
(load "compprob.lsp")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Integration and Differentiation
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; this is cool: differentiation of (fairly arbitrary functions)
(load "deriv.fsl")
(load "jacobian.fsl")
(load "newfuncs.fsl") ;; this is my list of new functions, especially derivs

;; integration of (fairly arbitrary functions)
(load "integrat.fsl") ;; which relies on these.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                Parsing:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; I worked long and hard on this: parsing so that I can use more reasonable
;; (infix) function notation to define functions:
(load "parser.fsl")
(load "func.fsl")
;; When I've want to see what an infix function looks like, I'll back-parse it:
(load "backpars.fsl")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				Differential equations
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(load "euler.fsl")
(load "rk-4.fsl")
(load "orbitals.fsl")
;; not ready yet; too specialized. 
;; (load "euler-delay.fsl")
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                Animation (rough)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(load "animate.fsl")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                Labels for plots:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(load "labels.fsl")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				Some nice looping constructs:
;;
(set-working-directory (strcat *andy-default-path* "loop" separator))
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(load "auxmacs.fsl")
(load "auxfns.lsp") ;; rats, this causes problems too when compiled. The
		    ;; problem is that some of the functions use loop, which is
		    ;; a macro. It's harder to compile over a macro.
(load "loop.fsl")
(load "norvig.fsl") ;; November, 1997
(load "patmatch.fsl") ;; macsyma stuff from Peter's book
(load "macsyma.fsl") ;; 		"
(load "macrules.fsl") ;; 		"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(set-working-directory *andy-default-path*)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                      Compile unfriendly functions...
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(compile 'remove-missing)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                            Initialize history
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(def history '((size *) (plot *)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                       Initialize the plotting stuff:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(new-plot)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                Set some read characters that are amusing...
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(reset-question-mark)		;; ? is help
(reset-exclamation-mark)	;; ! is a system call
(reset-dollar)			;; $ is calc

;; A bunch of others are set in the file readtab, without the reset and unset
;; functions being defined. These change the readtable:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                   Save the new readtable:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(def *new-readtable* (copy-vector *readtable*))

(set-working-directory where-am-i-anyway)
