#!/bin/sh

dir=/data/xlispstat/xlispstat-3-52-9/calculus
cd $dir

#############################################################################
# 	This file is intended to provide an updated xlisp.hlp file. This adds
# my own documentation to that of the original. I create the file 
# xlisp.hlp.new, and this should be moved to xlisp.hlp (in the directory of
# xlispstat):

# 		mv xlisp.hlp.new xlisp.hlp

#							Andy Long, 11/2/97
#############################################################################
# 				go to the help dir:
cd Help

# 				clean up
/bin/rm -f *~ .*~ core \#*.*\#

# 				get a list of the files:
files=`ls`

# 				create our temp file:
temp=../xlisp.hlp.new
/bin/rm -f $temp
# ../doc/xlisp.hlp.1 and ../doc/xlisp.hlp.2 are the original xlisp.hlp file:
# you can recreate the original by catting those two together. The first part
# is variable and other documentation; the second part is function doc.
zcat ../doc/xlisp.hlp.1 > $temp

# 				now cat all the files, changing 
for i in $files
do
	echo "$i" | sed s/\%/\:/g >> $temp
	echo \" >> $temp
	file="$i"
	echo $i
	cat $file \
	    | sed s/\"/\\\\\"/g \
	    | sed s/\\\\0/\\\\\\0/g \
	    | sed s/\\\\1/\\\\\\\\1/g \
	    | sed s/\\\\2/\\\\\\\\2/g \
	    | sed s/\\\\3/\\\\\\\\3/g \
	    | sed s/\\\\4/\\\\\\\\4/g \
	    | sed s/\\\\5/\\\\\\\\5/g \
	    | sed s/\\\\6/\\\\\\\\6/g \
	    | sed s/\\\\7/\\\\\\\\7/g \
	    | sed s/\\\\8/\\\\\\\\8/g \
	    | sed s/\\\\9/\\\\\\\\9/g \
    	    >> $temp
	echo \" >> $temp
done
# These are also function definitions, but many have been superceded by my own
# (improved, I hope) help files. Thus I want my files to be the first help a
# user sees (but I've certainly missed a few tricks, so these will be provided
# by ../doc/xlisp.hlp.2):
zcat ../doc/xlisp.hlp.2 >> $temp
