;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 ArcViewWrite
;;
(defun ArcViewWrite(file fileout &key (format "~g"))
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                          ArcViewWrite Doc:
;;
;; Author: Andy Long
;; Created: 1/12/2000
;;
;; Description/Arguments:

       (ArcViewWrite filein fileout &key (format \"~g\"))
  
	Reads in a flat ASCII file containing a row of variable names (no
 spaces!), followed by rows of data; all data separated by white space.
 Exports a file appropriate for loading into ArcView.

;; Notes:

;; See Also:

;; Examples:

"
  (let (
	(a (read-matrix-data file))
	)
    )
  (write-matrix-to-file (but-rows a 0) fileout :separator "," :format format)
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
(defun csv-import(file)
  "
;; Usage: (csv-import file)

	Returns a matrix of a csv (comma-separated value) file.

;; Examples:
 ;; Note: this creates the file csv-import-test in the current directory:
 (with-open-file
  (f \"csv-import-test\" :direction :output)
  (format f \"~d,~d~%\" 1 2)
  (format f \"~d,~d~%\" 3 5)
  )
 (csv-import \"csv-import-test\")
"
  (with-open-file
   (f file :direction :input)
   (let* (
	  (mat (read-matrix-data file))
	  )
     (matrix (size mat)
	     (combine
	      (mapcar
	       (lambda(x)
		 (mapcar
		  (lambda(x) (if (listp x) (second x) x))
		  x
		  )
		 )
	       (row-lists mat)
	       )
	      )
	     )
     )
   )
  )
