#|
	Stole this from Luke's examples directory, and made a few modifications,
including adding the choose-inspect-method method

						Andy Long, March  1996

Why do I waste my time?
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                Now a year later...March 1997
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
This has turned out to be my ideal history mechanism! I guess that's why I
waste my time!

ael
|#
(provide "inspect")
;;;
;;;
;;; Inspect Dialog Prototype
;;;
;;;
(defproto inspect-dialog-proto '(data editable) () dialog-proto)

;; This'n's mine; ael
(defmeth inspect-dialog-proto :choose-inspect-method ()
  (let* (
	 (types '("Edit" "Inspect" "Evaluate"))
	 (i (choose-item-dialog "Type of Inspection" types))
	 )
    (if i
	(cond
	 ((= i 0) (send self :edit-selection))
	 ((= i 1) (send self :inspect-selection))
	 (t (send self :evaluate-selection))
	 )
      )
    )
  )
;; ael added this general method:
(defmeth inspect-dialog-proto :evaluate-selection ()
  (let ((data (slot-value 'data))(list-item (slot-value 'list-item)))
    (print (eval 
	    (cond
	     ((matrixp data)
	      (apply #'aref data (send list-item :selection)))
	     ((or (vectorp data) (listp data))
	      (elt data (send list-item :selection)))
	     (t
	      (send list-item :selection))
	     )
	    )
	   )
    (terpri)
    )
  )

(defmeth inspect-dialog-proto :isnew (d &key (title "Inspect") edit)
  (setf (slot-value 'data) d)
  (setf (slot-value 'editable) edit)
  (let ((items (append (send self :make-items)
                       (if edit 
                           (list (send button-item-proto :new "Edit" 
                                       :action
                                       #'(lambda () 
                                           (send self :edit-selection))))))))
    (call-next-method items :title title :type 'modeless :go-away t)))

(defmeth inspect-dialog-proto :make-items ()
  (let ((data (slot-value 'data)))
    (list (send text-item-proto :new (format nil "type:  ~s" (type-of data)))
          (send text-item-proto :new (format nil "value: ~s" data)))))

(defmeth inspect-dialog-proto :edit-selection () (sysbeep))
;;;
;;;
;;; Inspect Symbol Dialog Proto
;;;
;;;
(defproto inspect-symbol-dialog-proto '(list-item) () inspect-dialog-proto)

(defmeth inspect-symbol-dialog-proto :isnew (d &key (title "Inspect") edit)
  (if (not (symbolp d)) (error "not a symbol"))
  (call-next-method d :title title :editable edit))

(defmeth inspect-symbol-dialog-proto :make-items ()
  (let* ((data (slot-value 'data))
         (strings (list (format nil "name:      ~s" (symbol-name data))
                        (format nil "value:      ~s" 
				(if (boundp data) 
				    (symbol-value data) '*unbound*))
                        (format nil "function: ~s" 
                                (if (fboundp data)
                                    (symbol-function data) '*unbound*))
                        (format nil "plist:        ~s" (symbol-plist data)))))
    (setf (slot-value 'list-item)
          (send list-item-proto :new strings 
                :action	(let ((d self))
                          #'(lambda (double) 
			      (if double (send d :choose-inspect-method))))))
    (list (send text-item-proto :new (format nil "type:  ~s" (type-of data)))
          (slot-value 'list-item))))

(defmeth inspect-symbol-dialog-proto :inspect-selection ()
  (let ((data (slot-value 'data))
        (editable (slot-value 'editable)))
    (case (send (slot-value 'list-item) :selection)
          (0 (inspect (symbol-name data)))
          (1 (if (boundp data) 
                 (inspect (symbol-value data) :editable editable)))
          (2 (if (fboundp data) 
                 (inspect (symbol-function data) :editable editable)))
          (3 (if (symbol-plist data) 
                 (inspect (symbol-plist data) :editable editable))))))

(defmeth inspect-symbol-dialog-proto :edit-selection ()
  (let ((data (slot-value 'data))(list-item (slot-value 'list-item)))
    (case (send list-item :selection)
          (1 (let ((v (get-value-dialog "New symbol-value")))
               (when v 
                     (setf (symbol-value data) (car v))
                     (send list-item :set-text 1 
                           (format nil "value:      ~s"  
                                   (symbol-value data))))))
          (2 (let ((v (get-value-dialog "New symbol-function")))
               (when v 
                     (setf (symbol-function data) (car v))
                     (send list-item :set-text 2 
                           (format nil "function: ~s" 
                                   (symbol-function data))))))
          (3 (let ((v (get-value-dialog "New symbol-plist")))
               (when v
                     (setf (symbol-plist data) (car v))
                     (send list-item :set-text 3 
                           (format nil "plist:        ~s"
                                   (symbol-plist data)))))))))
;;;
;;;
;;; Inspect Matrix Dialog Proto
;;;
;;;
(defproto inspect-matrix-dialog-proto 
  '(list-item columns) () inspect-dialog-proto)

(defmeth inspect-matrix-dialog-proto :isnew (d &key (title "Inspect") edit)
  (if (not (matrixp d)) (error "not a matrix"))
  (setf (slot-value 'columns) (min 3 (array-dimension d 1)))
  (call-next-method d :title title :editable edit))

(defmeth inspect-matrix-dialog-proto :make-items ()
  (let* ((data (slot-value 'data))
         (columns (slot-value 'columns))
         (strings (map-elements #'(lambda (x) (format nil "~s" x)) data)))
    (setf (slot-value 'list-item) 
          (send list-item-proto :new strings :columns columns
                :action	#'(lambda (double) 
                            (if double (send self :choose-inspect-method)))))
    (list (send text-item-proto :new
                (format nil "type:    ~s" (type-of data)))
          (send text-item-proto :new
                (format nil "dimensions:  ~s" (array-dimensions data)))
          (slot-value 'list-item))))

(defmeth inspect-matrix-dialog-proto :inspect-selection ()
  (let ((data (slot-value 'data))
        (columns (slot-value 'columns)))
    (inspect (apply #'aref data (send (slot-value 'list-item) :selection)) 
             :editable (slot-value 'editable))))

(defmeth inspect-matrix-dialog-proto :edit-selection ()
  (let* ((data (slot-value 'data))(list-item (slot-value 'list-item))
         (i (send list-item :selection))
         (v (get-value-dialog "New value for element")))
    (when v 
          (setf (aref data (car i) (cadr i)) (car v))
          (send list-item :set-text i 
                (format nil "~s" (aref data (car i) (cadr i)))))))

;;;
;;;
;;; Inspect Sequence Dialog proto
;;;
;;;
(defproto inspect-sequence-dialog-proto '(list-item action-mode) ()
  inspect-dialog-proto) 

(defmeth inspect-sequence-dialog-proto :isnew 
  (d &key (title "Inspect") (edit t))
  (if (not (or (consp d) (vectorp d))) (error "not a sequence"))
  (call-next-method d :title title :editable edit))

(defmeth inspect-sequence-dialog-proto :make-items ()
  (let* ((data (slot-value 'data))
         (strings (map-elements #'(lambda (x) (format nil "~s" x)) data))
	 )
    (setf (slot-value 'list-item)
          (send list-item-proto :new strings 
                :action	(let ((d self))
                          #'(lambda (double) 
			      (if double 
				  (send d :choose-inspect-method)
				)))))
    (list (send text-item-proto :new 
                (format nil "type:    ~s" (type-of data)))
          (send text-item-proto :new
                (format nil "length:  ~s" (length data)))
          (slot-value 'list-item))))

(defmeth inspect-sequence-dialog-proto :inspect-selection ()
  (let ((data (slot-value 'data))
        (editable (slot-value 'editable))
        (list-item (slot-value 'list-item)))
    (inspect (elt data (send list-item :selection)) :editable editable)))

(defmeth inspect-sequence-dialog-proto :edit-selection ()
  (let* ((data (slot-value 'data))
	 (list-item (slot-value 'list-item))
         (i (send list-item :selection))
         (v (get-value-dialog "New value for element")))
    (when v 
          (setf (elt data i) (car v))
          (send list-item
		:set-text i (format nil "~s" (elt data i))))))

;;;
;;;
;;; Inspect Function
;;;
;;;
(defun inspect (x &rest args)
  "
;; Description: (inspect data)

	Provides a means for looking at and editting data. Double click on a
cell to edit it.

;; See also: history

;; Examples:

 (def happy (vector 23 4 5 65))
 (inspect happy)

 ;; You could edit a grade book!
 (def happy (bind-rows '(June April May February) (vector 23 4 5 65)))
 (inspect happy)
"
  (apply
   #'send
   (cond
    ((symbolp x) inspect-symbol-dialog-proto)
    ((or (consp x) (vectorp x)) inspect-sequence-dialog-proto)
    ((matrixp x) inspect-matrix-dialog-proto)
    (t inspect-dialog-proto)
    )
   :new x
   args)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                       History mechanism
;;
;;
;;	Based this on the inspect-sequence-dialog-proto above.
;;							ael, March 1997.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defproto inspect-history-dialog-proto
  '(list-item action-mode instances)
  ()
  inspect-dialog-proto) 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:isnew
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth inspect-history-dialog-proto :isnew 
  (d &key (title "History") (edit t))
  (if (not (or (consp d) (vectorp d))) (error "not a history"))
  (call-next-method d :title title :editable edit))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:store
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth inspect-history-dialog-proto :store (instance) 
  (send inspect-history-dialog-proto :slot-value 'instances
	(append (send inspect-history-dialog-proto :slot-value 'instances)
		(list instance))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:close
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth inspect-history-dialog-proto :close () 
  (send inspect-history-dialog-proto :slot-value 'instances nil)
  (send self :dispose))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:make-items
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth inspect-history-dialog-proto :make-items ()
  (let* (
	 (data (slot-value 'data))
         (strings (map-elements #'(lambda (x) (format nil "~s" x)) data))
	 )
    (setf (slot-value 'list-item)
          (send list-item-proto :new strings 
                :action	(let ((d self))
                          #'(lambda (double) 
			      (if double (send d :evaluate-selection))))))
    (list 
     (send button-item-proto :new "Add new command" :action
	   (lambda()
	     (let (
		   (location (send self :location))
		   (new (get-string-dialog "New command:"))
		   )
	       (if new
		   (let ()
		     (send self :close)
		     (eval-string new)
		     (def history (append history (string-to-list new)))
		     (apply #'send (history) :location location)
		     )
		 )
	       )
	     )
	   )
     (send button-item-proto :new "Add Most Recent Command" :action
	   (lambda()
	     (let ((location (send self :location)))
	       (send self :close)
	       (def history (append history (list -)))
	       (apply #'send (history) :location location)
	       )
	     )
	   )
     (send button-item-proto :new "Remove Items" :action
	   (lambda()
	     (let ((location (send self :location)))
	       (apply #'send (send trim-history-dialog-proto :new self)
		      :location location)
	       )
	     )
	   )
     (slot-value 'list-item)
     (send button-item-proto :new "Done" :action (lambda() (send self :close)))
     )))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:evaluate-selection
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth inspect-history-dialog-proto :evaluate-selection ()
  (let ((data (slot-value 'data))(list-item (slot-value 'list-item)))
    (format t "~s~%> " (eval (nth (send list-item :selection) history)))
    (force-output)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 history
;;
(defun history(&rest args)
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; history Doc:    Creation Date:3/17/97        Author: Andy Long
;;
;; Description/Arguments:

       (history)
  
	History is window-oriented mechanism for re-issuing commands. You can
add commands, trim your history list, and point and click to re-issue commands.

;; Notes:
	Unfortunately macros are converted to functions before history gets
them, so something like (plot sin) comes out as (PLOTTER #<Closure: #217b50>):
not nearly so intuitive!

;; See Also: Defined in inspect.lsp.

;; Examples:
 (history)
"
  (let ((already (send inspect-history-dialog-proto :slot-value 'instances)))
    (if already (send (first already) :show-window)
      (send inspect-history-dialog-proto :store
	    (apply #'send inspect-history-dialog-proto :new history args))
      )
    )
  (first (send inspect-history-dialog-proto :slot-value 'instances))
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun his()
  "
;; Description: 

	His adds the most recent command to the history list. You can access
the history using the history function:

;; Examples:
 (setq a 3)
 (his)
 (history)
"
  (def history (append history (list +))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                trim-history stuff
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defproto trim-history-dialog-proto
  '(list-item action-mode hist)
  ()
  inspect-dialog-proto) 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:isnew
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth trim-history-dialog-proto :isnew (d &key (title "Trim") (edit t))
  (setf (slot-value 'hist) d)
  (call-next-method history :title title :editable edit))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:make-items
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth trim-history-dialog-proto :make-items ()
  (let* (
	 (hist (slot-value 'hist))
	 (data (slot-value 'data))
         (strings (map-elements #'(lambda (x) (format nil "~s" x)) data))
	 (location (send hist :location))
	 )
    (setf (slot-value 'list-item)
          (send list-item-proto :new strings 
                :action	#'(lambda (double) 
			    (if double 
				(send self :trim-selection)
			      ))))
    (list 
     (send text-item-proto :new "Double click to remove")
     (slot-value 'list-item)
     (send button-item-proto :new "Done"
	   :action
	   (lambda()
	     (send self :close)
	     (def history (remove-if 'null history))
	     (send hist :close)
	     (apply #'send (history) :location location)
	     )))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				:trim-selection
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth trim-history-dialog-proto :trim-selection ()
  (let ((data (slot-value 'data))(list-item (slot-value 'list-item)))
    (setf (elt history (send list-item :selection)) nil)))
