;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                 Trying to follow the exposition in
;;              Statistical Methods in Epidemiology, by Kahn
;;                         and Sempos, p. 138:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(def sbp (+ 110 (* 20 (rand.n 100))))
(def bmi (+ 22 (* 5 (rand.n 100))))
(def age (sample (iseq 18 45) 100 t))

(def both (regression-model (list bmi age) sbp))
(def params (send both :coef-estimates))
(def bmi-alone (regression-model (list bmi) sbp))
(def age-alone (regression-model (list age) sbp))
 
(def bmi-on-age (regression-model (list age) bmi))
 
(def primes (send age-alone :coef-estimates))
(def double-primes (send bmi-on-age :coef-estimates))
 
(def yhat (send age-alone :estimates))
(def xhat (send bmi-on-age :estimates))
 
(def adjusted-reg (regression-model (- bmi xhat) (- sbp yhat)))
(def triple-primes (send adjusted-reg :coef-estimates))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;           plot should look like a teeter-totter about the mean:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(plot (column 2 (send both :x)) (- (send both :adjust 1) (send both :y)))
(mean (column 2 (send both :x)))
