#|
Sun Oct 31 00:53:39 EDT 1999
Working a problem from Cliff and Ord's "Spatial Processes", involving Moran's I
calculations.
|#
(defun tracer(x) (sum (diagonal x)))

(defun another-matrix-moran-i(list matrix)
  "
;; Examples:
 (another-matrix-moran-i
 (list 4 4 4 4 4 -2 -1 5 4 -1 -2 5 5 5 5 5)
 (matrix '(16 16) '(  0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0
		      0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0
		      0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0
		      0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0
		      0 0 0 0 0 1 0 0 0 1 0 0 0 0 0 0
		      1 1 1 0 1 0 0 0 1 0 0 0 0 0 0 0
		      0 1 1 1 0 0 0 1 0 0 0 1 0 0 0 0
		      0 0 0 0 0 0 1 0 0 0 1 0 0 0 0 0
		      0 0 0 0 0 1 0 0 0 1 0 0 0 0 0 0
		      0 0 0 0 1 0 0 0 1 0 0 0 1 1 1 0
		      0 0 0 0 0 0 0 1 0 0 0 1 0 1 1 1
		      0 0 0 0 0 0 1 0 0 0 1 0 0 0 0 0
		      0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0
		      0 0 0 0 0 0 0 0 0 1 1 0 0 0 0 0
		      0 0 0 0 0 0 0 0 0 1 1 0 0 0 0 0
		      0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0
		      )))
 (def tmpmat
   #2a(
    (0     1     0     0     0     0     0     0     0    )
    (1     0     1     0     0     0     0     0     0    )
    (0     1     0     1     0     0     0     0     0    )
    (0     0     1     0     1     0     0     0     0    )
    (0     0     0     1     0     1     0     0     0    )
    (0     0     0     0     1     0     1     0     0    )
    (0     0     0     0     0     1     0     1     0    )
    (0     0     0     0     0     0     1     0     1    )
    (0     0     0     0     0     0     0     1     0    )
   ))
 (another-matrix-moran-i
   (list 145.5 152.25 156.5 169.3 175 182.25 168.5 160.2 147.6)
   tmpmat
   )
 (another-matrix-moran-i
   (list 1 3 4 7 8 9 6 5 2)
   tmpmat
   )
"
  (let* (
	 (z (- list (mean list)))
	 (n (length z))
	 (w (sum matrix))
	 (a (half w))

	 (L (mapcar #'sum (column-list matrix)))
	 (D (half (sum (* L (1- L)))))
	 
	 (i (/ (* n (matmult z matrix z)) w (sum (* z z))))
	 (outer (outer-product z z #'-))
	 (c (/ (* (1- n) (sum (* matrix outer outer)))
	       (* 2 w (sum (* z z)))))
	 (ones (combine (repeat 1 n)))
	 (s1 (half
	      (sum 
	       (square 
		(+ matrix (transpose matrix))))))
	 (s2 (sum 
	      (square 
	       (+ 
		(mapcar #'sum (column-list matrix))
		(mapcar #'sum (row-list matrix))
		))))

	 (w2 (* w w))
	 (a2 (* a a))
	 (b2 (/
	      (mean (^ z 4))
	      (square (mean (* z z)))))

	 (en (- (/ 1.0 (1- n))))
	 (n2 (* n n))
	 (en2
	  (/ 
	   (- (* n2 s1) (* n s2) (* -3 w2))
	   (* (1- n2) w2)))
	 (en22
	  (/ 
	   (+ (* 4 a n2) (* -8 (+ a d) n) (* 12 a2))
	   (* 4 a2 (1- n2))
	   )
	  )

	 (er2
	  (/
	   (- (* n (+
		    (* (+ n2 (* -3 n) 3) s1)
		    (* (- n) s2)
		    (* 3 w2)))
	      (* b2 (+
		     (* (- n2 n) s1)
		     (* -2 n s2)
		     (* 6 w2)
		     )
		 )
	      )
	   (* (- n 1) (- n 2) (- n 3) w2)
	   )
	  )

	 (er22
	  (/
	   (- (* n (+
		    (* 4  a (+ n2 (* -3 n) 3))
		    (* -8 (+ a d) n)
		    (* 12 a2)))
	      (* b2 (+
		     (* 4 a (- n2 n))
		     (* -16 (+ a d) n)
		     (* 24 a2)
		     )
		 )
	      )
	   (* (- n 1) (- n 2) (- n 3) 4 a2)
	   )
	  )

	 (er222
	  (calc (n*((n*n - 3*n +(3))*s1 - n*s2+3*w2)
		 -
		 b2*(n*(n-1)*s1 - 2*n*s2+6*w2))
		/
		((n-1)*(n-2)*(n-3)*w2)))

	 (varnc
	  (/ 
	   (- (* (+ (* 2 s1) s2) (1- n)) (* 4 w2))
	   (* 2 (1+ n) w2)))

	 (varnc
	  (/ 
	   (- (* (+ (* 2 a) d) (1- n)) (* 2 a2))
	   (* (1+ n) a2)))

	 (varrc
	  (/ 
	   (+
	    (* 2 a2 (+ (* (- (square (1- n))) b2) (- n2 3)))
	    (* 2 a (1- n) (+ (* (- (1- n)) b2) n2 (* -3 n) 3))
	    (* (+ a d) (1- n) (- (* (+ n2 (- n) 2) b2) (+ n2 (* 3 n) -6)))
	    )
	   (* n (- n 2) (- n 3) 2 a2)
	   ))
	 (signi (sqrt (- en22 (square en))))
	 (sigri (sqrt (- er22 (square en))))
	 (signc (sqrt varnc))
	 (sigrc (sqrt varrc))
	 )
    (andy-print
     (list i en (- er2 (square en)) er222 (square en))
     (list er2 er22 er222)
     (list w s1 s2)
     (list n a i c)
     (list sigri signi sigrc signc)
     )
    (format t "
I	= ~f
E(I)	= ~f
V_N(I)	= ~f
V_R(I)	= ~f
z_{I_N}	= ~f
z_{I_R}	= ~f
z_{c_N}	= ~f
z_{c_R}	= ~f
" i en (square signi) (square sigri)
	(/ (- i en) signi)
	(/ (- i en) sigri)
	(/ (- 1 c) signc)
	(/ (- 1 c) sigrc)
	)
    (list
     (/ (- i en) signi)
     (/ (- i en) sigri)
     (/ (- 1 c) signc)
     (/ (- 1 c) sigrc)
     )
    )
  )


(defun another-matrix-moran-i-reg(reg matrix)
  "
I've checked Cliff and Ord's work with Robert Haining's GMC statistic
computed in this function, and it appears that I'm okay. I can only think of
two reasons for why my answers don't agree with Cliff and Ord's: they've made
an error (they've made several in this book!), or I've misapplied/misunderstood
their variables or formulas, or my connection matrix is not the same as
theirs. Even so, the differences are dramatic.

Their results were calculated by a student for his undergraduate dissertation,
according to their SA book (p. 120).

;; Examples:
 (pprint (mapcar (lambda(x) (another-matrix-moran-i-reg x mat)) regressions))
 (pprint (mapcar (lambda(x) (another-matrix-moran-i-reg x nigmat)) nigregressions))
"
  (let* (
	 (w matrix)
	 (s0 (sum w))
	 (s1 (half
	      (sum 
	       (square 
		(+ w (transpose w))))))
	 (s2 (sum 
	      (square 
	       (+ 
		(mapcar #'sum (column-list w))
		(mapcar #'sum (row-list w))
		))))
	 (s02 (* s0 s0))


	 (z (send reg :residuals))
	 (z (- z (mean z)))
	 (n (length z))
	 (n2 (* n n))

	 (xtxinv (send reg :xtxinv))
	 (x (send reg :x-matrix))

	 (U (half (+ w (transpose w))))
	 (ZZ (matmult U X))
	 (C1 (matmult (transpose X) ZZ))
	 (C2 (matmult (transpose ZZ) ZZ))
	 (amat (matmult xtxinv C1))
	 ;; looks like an error: in 8.27 there's a 4, missing in section 8.3.3:
	 (b (* 4 (matmult xtxinv (transpose x) U U x)))
	 ;; (b (matmult xtxinv C2))

	 ;; I defined M, and calculated ei, vari the hard way; it turns out
	 ;; that for consistency, we need the 4 in the definition of b above. 
	 (M (- (id (first (size w))) (matmult x xtxinv (transpose x))))

	 (xs
	  (let* (
		 (xs (copy-list z))
		 (neg (where z 0 #'<))
		 (pos (where z 0 #'>))
		 )
	    (setf
	     (select xs neg) (repeat 0 (length neg))
	     (select xs pos) (repeat 1 (length pos))
	     )
	    xs
	    )
	  )

	 (n1 (sum xs))
	 (p (/ n1 n))
	 (q (- 1 p))
	 (bb (half (sum (matmult xs w xs))))
	 (outer (outer-product xs xs #'-))
	 (bw (half (sum (* w outer outer))))
	 ;; free:
	 (ebb (half (* s0 p p)))
	 (varbb (/
		 (* p p q (+ (* s1 q) (* s2 p)))
		 4)
		)
	 (ebw (half (* s0 p q)))
	 (varbw (/
		 (+
		  (* 4 s1 p q)
		  (* s2 p q (- 1 (* 4 p q))))
		 4)
		)
	 (ebbr (half (* s0 (/ n1 n) (/ (1- n1) (1- n)))))
	 (varbbr (/
		 (* p p q (+ (* s1 q) (* s2 p) (/ (* -4 s02 p) n)))
		 4)
		)

	 (k (first (size amat)))
	 (i (/ (* n (matmult z w z)) s0 (inner-product z z)))

	 (GW (* n (/ w (sum w))))
	 (GMC (/ (matmult z GW z) (inner-product z z)))
	 (EGMC (/
		(- (tracer (matmult x xtxinv (transpose x) GW)))
		(- n k)))
	 (EGMC2 (/
		 (+ 
		  (* 2 (tracer (matmult M GW M GW)))
		  (square (tracer (matmult M GW))))
		 (* (- n k) (- n k -2))
		 ))

	 (b2 (/
	      (mean (^ z 4))
	      (square (mean (* z z)))))

	 (trA (tracer amat))
	 (trA2 (tracer (matmult amat amat)))
	 (trB (tracer B))

	 (einew (* (/ n s0) (/ (- trA) (- n k))))
	 (ei2new (* (square (/ n s0)) 
		    (/ 
		     (+ 
		      (square (tracer (matmult U M)))
		      (* 2 (tracer (matmult U M U M))))
		     (* (- n k) (- n k -2)))))
	 (newsig (sqrt (- ei2new (square einew))))

	 (ei (- (/ (* n trA) (* (- n k) s0))))
	 (vari
	  (* (/ 
	      n2
	      (* s02 (- n k) (- n k -2)))
	     (+ s1 
		(* 2 trA2)
		(- trB)
		(- (/ 
		    (* 2 (square trA))
		    (- n k))))
	     )
	  )
	 (sigi (sqrt vari))

	 (en (/ -1.0 (1- n)))
	 (er2
	  (/
	   (- (* n (+
		    (* (+ n2 (* -3 n) 3) s1)
		    (* (- n) s2)
		    (* 3 s02)))
	      (* b2 (+
		     (* (- n2 n) s1)
		     (* -2 n s2)
		     (* 6 s02)
		     )
		 )
	      )
	   (* (- n 1) (- n 2) (- n 3) s02)
	   )
	  )
	 (sigri (sqrt (- er2 (square en))))

	 )

    (format t "
k	= ~d
I	= ~f
E_N(I)	= ~f
E_R(I)	= ~f
V_N(I)	= ~f
V_R(I)	= ~f
z_{I_N}	= ~f
z_{I_R}	= ~f
E_new(I)= ~f
V_new(I)= ~f
z_new(I)= ~f
GMC	= ~f
VGMC	= ~f
z_GMC(I)= ~f
" k i ei en (square sigi) (square sigri)
	(/ (- i ei
	      ) sigi)
	(/ (- i en
	      ) sigri)
	einew newsig (/ (- i einew) newsig)
	GMC (- EGMC2 (square EGMC)) (/ (- GMC EGMC) (sqrt (- EGMC2 (square EGMC))))
	)
    (list (/ (- i ei) sigi) 
	  (/ (- i en) sigri) 
	  (/ (- bb ebb) (sqrt varbb))
	  (/ (- bw ebw) (sqrt varbw))
	  (/ (- bb ebbr) (sqrt varbbr))
	  )	  
    )
  )

(def ghana '(
1              Accra                       284            225                     92                     21             Kumasi1-2                  259             157                     39
2              Axim                        168            74                      151                   22             Kumasi3                    205             70                      81
3              Sekondi                     140            106                     37                     23             Kumasi4                    287             84                      395
4              Akwapimc                    115            114                     40                     24             Kumasi5                    139             65                      76
5              Kibi                        286            219                     225                    25             MampongE.                  83              13                      460
6              MpraesoN.                  16             6                       200                    26             MampongW.                  262             90                      236
7              MpraesoS.                  129            73                      82                     27             Wenchi                      359             73                      681
8              Oda                         162            72                      94                     28             Sunyani                     238             109                     248
9              CapeCoast                  435            269                     208                    29             DagombaE.                  424             121                     672
10             Dunkwa                      103            40                      93                     30             DagombaW.                  308             104                     289
11             Winneba                     333            187                     92                     31             GonjaE.                    226             52                      578
12             Ho                          432            173                     246                    32             GonjaW.                    307             33                      869
13             Keta                        205            190                     116                    33             Krachi                      194             32                      338
14             Ada                         90             114                     80                     34             FraFra                     132             164                     79
15             Sefwi                       146            65                      270                    35             Gambaga                     239             78                      279
16             VoltaRiver                 201            165                     146                    36             Kusasi                      266             148                     124
17             Enchi                       52             10                      125                    37             Navrongo                    178             142                     155
18             Tarkwa                      256            121                     346                    38             Lawra                       169             89                      110
19             Bekwai                      247            91                      128                    39             Tumu                        214             30                      273
20             Obuasi                      169            67                      94                     40             Wa                          333             85                      340
))
(def nigeria '(
1              Adamawa                      545            799                    1856                 26             Kontagora                   534           251                     1322
2              Muff                         444            260                    1101                 27             Minna                       289           142                     576
3              Numan                        131            121                    221                  28             Emaad                       390           417                     396
4              Bauchi                       680            512                    1452                 29             Lowland                     129           194                     480
5              Gombe                        402            477                    648                  30             Pankshin                    192           279                     380
6              Katagum                      385            434                    512                  31             Argungu                     213           171                     336
7              Idoma                        204            319                    375                  32             Gwandu                      375           489                     751
8              Lafia                        144            132                    395                  33             Sokoto                      1059          2021                    2561
9              Nasarawa                     251           162                    556                  34             Zaria                       780           806                     1649
10             Tiv                          491            719                    986                  35             Abeokuta                    448           630                     427
11             Wukafi                       107            137                    622                  36             Benin                       772           901                     846
12             Bedde-Potiskum               111            160                    367                  37             Colony                      101           510                     135
13             Bornu                        1339           1006                   3299                 38             Delta                       315           590                     644
14             Dikwa                        330            265                    515                  39             lbadan                      617           1661                    452
15             Biu                          210            164                    392                  40             Ijebu                       211           348                     247
16             Borgu                        312            100                    1091                 41             Ondo                        695           946                     816
17             Ilorin                       339            460                    265                  42             Oyo                         644           783                     970
18             Lafiaga                      170            70                     416                  43             Bamenda                     252           429                     693
19             Igala                        353            361                    498                  44             Calabar                     730           1841                    625
20             Kabbac                       310            303                    497                  45             Kumba-Victoria              211           224                     532
21             Katsina                      823            1483                   947                  46             Mamfe                       136           100                     432
22             Kano                         1135           2933                   1293                 47             Ogoja                       571           1082                    749
23             Northern                     302            424                    370                  48             Onitsha                     770           1768                    489
24             Abuja                        189            101                    395                  49             Owerri                      860           2080                    387
25             Bida                         299            221                    574                  50             Rivers                      207           747                     701
))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(def ghana (transpose (split-list ghana 5)))
(def nigeria (transpose (split-list nigeria 5)))

(def ghana (mapcar (lambda(x) (select x (order (first ghana)))) ghana))
(def nigeria (mapcar (lambda(x) (select x (order (first nigeria)))) nigeria))

(setq
 y (elt ghana 2)
 x1 (elt ghana 3)
 x2 (elt ghana 4)
 regressions (list 
	      (regress (list x1) y)
	      (regress (list (log x1 10)) (log y 10))
	      (regress (list x2) y)
	      (regress (list (log x2 10)) (log y 10))
	      (regress (list (log x1 10) (log x2 10)) (log y 10))
	      )
 residuals (mapcar (lambda(x) (send x :residuals)) regressions)
 )
(mprint (apply #'bind-columns residuals))


(def connections
     '(
       (1 4 5 11 14 16)
       (2 3 18 17)
;;       (3 18 10 9) ; queen
       (3 18 9) ; rook
       (4 5 16)
       (5 6 7 8 11 16)
       (6 7 24 25 12 16)
       (7 8 24)
       (8 9 20 24 11)
       (9 10 11 20)
       (10 18 15 19 20)
;       (11)
       (12 13 14 16 25 33)
       (13 14)
       (14 16)
       (15 17 18 19 23 28)
;       (16 
       (17 18)
;       (18        
       (19 20 24 23)
       (20 24)
       (21 22 23 24 26)
       (22 23 28 27 26)
       (23 28)
       (24 25 26)
       (25 26 31 30)
       (26 27 31)
       (27 28 31 32)
;       (28 
       (29 30 31 33 35)
       (30 31 32 35)
       (31 32 33)
       (32 35 40)
;       (33
       (34 35 36 37)
;;       (35 36 37 39 40) ; queen
       (35 36 37 40) ; rook
;       (36 
;;       (37 39 40) ; queen
       (37 39) ; rook
       (38 39 40)
       (39 40)
       )
     )
(def mat (matrix '(40 40) (repeat 0 (* 40 40))))
(mapcar 
 (lambda(x) 
   (let (
	 (first (1- (first x)))
	 (rest (1- (rest x)))
	 )
     (dolist
      (i rest)
      (setf
       (aref mat first i) 1
       (aref mat i first) 1
       )
      )
     )
   )
 connections)
(pprint (mapcar (lambda(x) (another-matrix-moran-i x mat)) residuals))
(pprint (mapcar (lambda(x) (another-matrix-moran-i-reg x mat)) regressions))

(setq
 y (elt nigeria 2)
 x1 (elt nigeria 3)
 x2 (elt nigeria 4)
 nigregressions (list 
	      (regress (list x1) y)
	      (regress (list (log x1 10)) (log y 10))
	      (regress (list x2) y)
	      (regress (list (log x2 10)) (log y 10))
	      (regress (list x1 x2) y)
	      (regress (list (log x1 10) (log x2 10)) (log y 10))
	      )
 nigresiduals (mapcar (lambda(x) (send x :residuals)) nigregressions)
 )
(mprint (apply #'bind-columns nigresiduals))

(def connections
     '(
       (1 2 3 11 43 15 13 14)
       (2 3 4 5 29 11)
       (3 5 15)
       (4 5 12 6 22 34 28 29 30)
       (5 12 13 15)
       (6 12 22 23)
       (7 8 9 10 19 47 48) ;; queen!
       (8 9 10 11 28 29 30)
       (9 10 19 20 24 34 28) ;; queen!
       (10 11 43 46 47)
       (11 43 46 29) ;; queen
       (12 13 23)
       (13 14 15 23)
;       (14
;       (15
       (16 17 25 26 32 42)
       (17 18 20 25 39 41 42)
       (18 20 25)
       (19 20 36 48)
       (20 24 25 36 41)
       (21 22 23 33 34)
       (22 23 34)
;       (23 
       (24 25 27 34)
       (25 26 27)
       (26 27 32 33 34)
       (27 34)
       (28 30 34)
       (29 30)
;       (30
       (31 32 33)
       (32 33)
       (33 34)
;       (34
       (35 37 39 40 42)
;       (36
       (37 40)
       (38 41 48 49 50)
       (39 40 41 42)
       (40 41)
;       (41
;       (42 
       (43 46)
       (44 45 46 47 49 50)
       (45 46)
       (46 47)
       (48 49)
       (49 50)
       )
     )
(def nigmat (matrix '(50 50) (repeat 0 (* 50 50))))
(mapcar 
 (lambda(x) 
   (let (
	 (first (1- (first x)))
	 (rest (1- (rest x)))
	 )
     (dolist
      (i rest)
      (setf
       (aref nigmat first i) 1
       (aref nigmat i first) 1
       )
      )
     )
   )
 connections)

(pprint (mapcar (lambda(x) (another-matrix-moran-i x nigmat)) nigresiduals))
(pprint (mapcar (lambda(x) (another-matrix-moran-i-reg x nigmat)) nigregressions))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 point-placer
;;
(defun point-placer(pts matrix)
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                          point-placer Doc:
;;
;; Author: Andy Long
;; Created: //1997
;;
;; Description/Arguments:

       (point-placer points matrix)
  
;; Notes:

;; See Also:

;; Examples:
 (point-placer '((0 0) (2 4) (2 2)) 
		(matrix '(3 3) '(1 1 -1 1 1 -1 -1 -1 1))
   )
"
  (let* (
	 (mrf
	  (lambda(y) 
	    (let* (
		   (points (split-list y 2))
		   (n (length points))
		   (bunch
		    (list
		     (inner-product (first points) (first points))
		     (mapcar
		      (lambda(i)
			(let ((p (elt points i)))
			  (mapcar 
			   (lambda(j)
			     (^ 
			      (norm (- (elt points j) p))
			      (aref matrix i j)))
			   (iseq (1+ i))
			   )
			  )
			)
		      (iseq n)
		      )
		     )
		    )		    
		   )
	      (sum (combine bunch))
	      )
	    )
	  )
	 (val (funcall mrf (combine pts)))
	 )
    (plotter (mapcar #'first pts) (mapcar #'second pts))
    (print val)
    (dotimes
     (i 100)
     (let* (
	    (newpoints (mapcar (lambda(x) (+ (/ (rand.u 2) (1+ i)) x)) pts))
	    (newval  (funcall mrf (combine newpoints)))
	    )
       (printall newpoints newval)
       (if (< newval val)
	   (let ()
	     (print 'yet)
	     (setq 
	      val newval
	      pts newpoints))
	 )
       )
     )
    (plotter (mapcar #'first pts) (mapcar #'second pts))
    pts
    )
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;             Creating the input matrices for Stat!
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(mapcar
 (lambda(x i)
   (let (
	 (where (where x 0 #'>))
	 )
     (format t "~d ~d ~d ~{~d ~}~%" (1+ i) 1 (length where) (1+ where))
     )
   )   
 (row-lists mat) (iseq (first (size mat)))
 )
(mapcar
 (lambda(x i)
   (let (
	 (where (where x 0 #'>))
	 )
     (format t "~d ~d ~d ~{~d ~}~%" (1+ i) 1 (length where) (1+ where))
     )
   )   
 (row-lists nigmat) (iseq (first (size nigmat)))
 )

(mapcar
 (lambda(i)
   (write-matrix-to-file
    (bind-columns (elt residuals i))
    (strcat "ghana." (num-to-string i))
    )
   )
 (iseq 5)
 )
(mapcar
 (lambda(i)
   (write-matrix-to-file
    (bind-columns (elt nigresiduals i))
    (strcat "nigeria." (num-to-string i))
    )
   )
 (iseq 6)
 )
