(send dialog-proto :new  (list (send modal-button-proto :new "OK")))


;; I'm trying to figure out who's fundamental, and who's a derivative:
;; text-item-proto is fundamental:
(defproto edit-text-item-proto () () text-item-proto)
;; edit-text-item-proto is derivative.
(send edit-text-item-proto :slot-value 'editable t)
(send edit-text-item-proto :slot-value 'size '(400 300))
(send edit-text-item-proto :default-button nil)

;; ok-or-cancel-dialog-proto is based on modal-dialog-proto, which is defined
;; in objects, derived as dialog-proto
(defproto string-dialog-proto () () dialog-proto)
(defmeth string-dialog-proto
  :isnew (s &rest args &key (initial nil has-init))
  (let* ((prompt-item (send text-item-proto :new s))
         (edit-item (send edit-text-item-proto :new 
                          (if has-init initial "")
                          :text-length 10))
	 (ok-button (send modal-button-proto :new "OK" :action 
			  #'(lambda () (send edit-item :text))))
	 (cancel-button (send modal-button-proto :new "Cancel"
			      :action #'(lambda () nil)
			      ))
	 )

    (send self :DEFAULT-BUTTON 'cancel-button)
    (apply #'call-next-method 
           (list prompt-item edit-item (list ok-button cancel-button))
           :ok-action #'(lambda () (send edit-item :text))
	   :default-button nil
           args)))

(defun string-dialog (&rest args)
  "Args: (s &key initial)
Opens a modal dialog with prompt S, a text field and OK, Cancel buttons.
INITIAL is converted to a string with ~A format directive. Returns string
of text field content on OK, NIL on cancel.
;; Examples:
 (string-dialog \"hi\" :text-length 10)
 (string-dialog \"hi\"
    :initial \"hidklskjfaplskdfalksdjfaksdlfaksdlkaskdf sksld fkl\")
 (string-dialog \"hi\"
    :initial \"
hidklskjfaplskdfalksdjfaksdlfaksdlkaskdf sksld fkl
sksl
\")
"
  (let ((d (apply #'send string-dialog-proto :new args)))
    (send d :modal-dialog)))
