;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                
;;			Practice/Test Files
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(load-calc f2cl)
(defun f2cl-file(file) 
  (f2cl file "f2clout.lsp")(load "f2clout.lsp") 
  (test)
  )

(set-working-directory (strcat *andy-default-path* "examples/f2cl/validation"))

(f2cl-file "fileio.for")
(f2cl-file "dotest2.for")
(f2cl-file "trial.f")
(f2cl-file "trial2.f")    ;; writes file stuff.out
(f2cl-file "trial3.f")    ;; uses include file
(f2cl-file "trial4.f")    ;; declarations - check variable 
(f2cl-file "formattest.f")
(f2cl-file "subprogtest.f")
(f2cl-file "arithIFtest.f")
(f2cl-file "stmtfntest.for")
;;
;; (f2cl "commontest.for" "f2clout.lsp")
;; doesn't currently do anything!
(f2cl "common.for" "f2clout.lsp")
;; 3.14 3.1415 
;; 9 

(set-working-directory "/home/ael/tmp/numrec")
(let () (f2cl "julian.f" "f2clout.lsp") (load "f2clout") (badluk) (test))
(let () (f2cl "rk.f" "f2clout.lsp") (load "f2clout") (D15R4))
;; (let () (f2cl "special.f" "f2clout.lsp") (load "f2clout"))

(let () (f2cl "sfroid.f" "f2clout.lsp") (load "f2clout") (sfroid))
2 2 .1 1 999
;; (sfroid) 2 2 .1 1 999

#| - Sun Feb 15 16:27:46 1998
(let () (load "numrec") (load "drivers") (d9r1) 
     ;; (d10r13)
     )
|#

(let () (f2cl "simplex.f" "f2clout.lsp") (load "f2clout") (D10R12))
(let () (f2cl "simpler.f" "f2clout.lsp") (load "f2clout") (D10R12))
#| - Sun Feb 8 11:56:02 1998
	Trying to get this working, I discovered two problems:
1) 
c ael - caused nasty problem:      character txt(nm1m2)*2,alpha(np)*2
      character txt*2,alpha*2
      dimension txt(nm1m2)
      dimension alpha(np)
c lea

which now works, but this is sensitive (can't lump the dimension statements on
the same line, for example).

      character*2 alpha
      character*2 txt
      dimension alpha(np)
      dimension txt(nm1m2)

2) that the matrix A, initialized in a data statement, is created in the
opposite sense from lisp (that is, columns first, then rows). I added this
right after the (setq A ....) in the program:

    (mprint a)
    (setq a (transpose (matrix (reverse (size a)) (combine a))))
    (mprint a)

3) I removed an "extraneous" () in a write statement:

            write(*,'(1x,a3,(5f10.2))') alpha(1),
became
            write(*,'(1x,a3,5f10.2)') alpha(1),

and this worked, although badly (printing a list where a bunch of numbers was
more appropriate).

|#


(set-working-directory "/home/ael/tmp/numanal")
(f2cl-file "f2clout.f") ;; this is file dalg051.f with a couple of fixes, noted in
		     ;; the "Are these standard?" section
"y" .0 2.0 10 1 1
(f2cl "dalg051.f" "dalg051.lsp")
(load "dalg051.lsp")
(*main*)
"y" .0 2.0 10 1 1
"y" .0 2.0 10 1 2 "stuff.out"
(f2cl "dalg052.f" "dalg052.lsp")
(load "dalg052.lsp")
(*main*)
"y" .0 2.0 10 1 1
"y" .0 2.0 10 1 2 "stuff.out"

(f2cl "dalg053.f" "dalg053.lsp")
(load "dalg053.lsp")
(*main*)
"y" 0.0 2.0 1 1e-6 1e-6 .1 1
"y" 0.0 2.0 1 1e-6 1e-6 .1 2 "stuff.out"

(f2cl "alg021new.f" "alg021new.lsp")
(load "alg021new.lsp")
(*main*)
-10 10 1e-6 100 n

;; This one needs to be linked with other stuff:
;; (f2cl "stuff.f" "stuff.lsp")
;; (f2cl "dalg022.f" "dalg022.lsp")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                /home/ael/tmp/dos_fortran
;;
;; This is Burden and Faires software. Basically it's pretty shoddy stuff -
;; poor hints as to initial conditions, no one took credit for it (explains
;; some of the crumminess, or vice versa), there are array indexing problems
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(set-working-directory "/home/ael/tmp/dos_fortran")
(defun comment-out-opens(file &optional (outfile "f2clout.f"))
  "
;; For the following files I was obliged to comment out the lines where one
;; opens the console for read/write: e.g.,

;; ccael      OPEN(UNIT=5,FILE='CON',ACCESS='SEQUENTIAL')
;; ccael      OPEN(UNIT=6,FILE='CON',ACCESS='SEQUENTIAL')
"
  (let ((lines (read-file file)))
    (setq
     lines
     (mapcar
      (lambda(x)
	(cond
	 ((grep "OPEN(UNIT=5,FILE='CON',ACCESS='SEQUENTIAL')" x)
	  (grep-replace "      OPEN(UNIT=5,FILE='CON',ACCESS='SEQUENTIAL')"
			"ccael OPEN(UNIT=5,FILE='CON',ACCESS='SEQUENTIAL')"
			x))
	 ((grep "OPEN(UNIT=6,FILE='CON',ACCESS='SEQUENTIAL')" x)
	  (grep-replace "      OPEN(UNIT=6,FILE='CON',ACCESS='SEQUENTIAL')"
			"ccael OPEN(UNIT=6,FILE='CON',ACCESS='SEQUENTIAL')"
			x))
	 (t x)
	 ))
      lines))
    (with-open-file 
     (f outfile :direction :output)
     (mapcar
      (lambda(x) (format f "~a~%" x))
      lines)
     )
    nil
    ))

(defun f2cl-bf (file)
  (comment-out-opens file)
  (f2cl "f2clout.f" "f2clout.lsp")
  (load "f2clout.lsp")
  (*main*)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                      Chapter 1: contains no algorithms
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;         Chapter 2:  Solutions of Equations in One Variable
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(f2cl-bf "alg021.for")
"y"
1 2
1e-4
13
1
2

(f2cl-bf "alg022.for")
"y" 1.5 1e-12 30 1 2

(f2cl-bf "alg023.for")
"y" 1.5 1e-12 30 1 2

(f2cl-bf "alg024.for")
"y" .5 0.7853981633974483 1e-12 30 1 2

(f2cl-bf "alg025.for")
"y" .5 0.7853981633974483 1e-12 30 1 2

(f2cl-bf "alg026.for")
"y" 1.5 1e-12 30 1 2
;; both codes (fortran and lisp) had problems: fortran gave nans, while
;; lisp gave a zero divide after 3 its.

(f2cl-bf "alg027.for")
4
4 3 -3 0 2
-1.796
;; gives the same incorrect answer as the fortran code.

(f2cl-bf "alg028.for")
1 4 6 20 5 -40 16 1e-5 10 .5 0 -.5 1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;         Chapter 3: Interpolation and Polynomial Approximation
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(f2cl-bf "alg031.for")
1
4
1.0 .7651977
1.3 .6200860
1.6 .4554022
1.9 .2818186
2.2 .1103623
1.5
1
#|
Does the calculation, but we have another format problem:

       (TAGBODY  
        (FFORMAT I/O OUP 
         (QUOTE 
          (
           ;; ael: ("~{~1@T~7{~3@T~15,8,2,0,,'*E~}~}")
	   ("~a")
	   ("~a")
            "~%")
          )

|#

(f2cl-bf "alg032.for")
1
4
1.0 .7651977
1.3 .6200860
1.6 .4554022
1.9 .2818186
2.2 .1103623
1

(f2cl-bf "alg033.for")
1
2
1.3 .6200860 -.5220232
1.6 .4554022 -.5698959
1.9 .2818186 -.5811571
1

;; same ~{ format error as we saw in alg031 above:
(f2cl-bf "alg034.for")
1
4
1.0 .7651977
1.3 .6200860
1.6 .4554022
1.9 .2818186
2.2 .1103623
1

(f2cl-bf "alg035.for")
1
4
1.0 .7651977
1.3 .6200860
1.6 .4554022
1.9 .2818186
2.2 .1103623
0 0
1

(f2cl-bf "alg036.for")
1 1
0 0 .25 .25
1 0 .75 .25
1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;         Chapter 4: Numerical Differentiation and Integration
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(f2cl-bf "alg041.for")
"y" 0 3.1415926 20

;; problem number 9)
(f2cl-bf "alg042.for")
"y" 1 3 1e-4 100

;; Problem number 10)
(f2cl-bf "alg043.for")
"y"
0 3.1415926
6

(f2cl-bf "alg044.for")
"y"
.1 .5
5 5

(f2cl-bf "alg045.for")
"y" .1 .5 5 5

(f2cl-bf "alg046.for")
"y" -2 2 5 5 5 
;; Gives the same answer as the fortran code, but not as the book!

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                        Chapter 5: IVPs for ODEs
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(f2cl-bf "alg051.for")
"y" 0 2 10 .5 1

(f2cl-bf "alg052.for")
"y" 0 .5 5 .5 1

(f2cl-bf "alg053.for")
"y" 0 2 .5 1e-5 .01 .25 1

;; created bug 25, which is now solved....
(f2cl-bf "alg054.for")
"y" 0 2 10 .5 1
#|
I had another problem with this, which is bug 26) in f2cl.lsp:
|#

(f2cl-bf "alg055.for")
"y" 0 2 .5 1e-5 .01 .25 1
;; Not the same problem 10)! That's because if a whole array is passed, all is
;; well: above, a whole array is not passed, only elements of an array...

(f2cl-bf "alg056.for")
"y" 0 2 .5 1e-5 .01 .25 1

(f2cl-bf "alg057.for")
"y" 0 .5 5 0 0 1

(f2cl-bf "alg058.for")
"y" 0 1 5 -1 1e-6 10 1
(*MAIN*)
"y" 0 1 4 -1 1e-6 10 1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                       Chapter 8: Approximation Theory
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Pade' Approximation:
(f2cl-bf "alg081.for")
;; This one had array indexing problems, which I fixed with a goto. Crummy
;; stuff, this!
2 3 ;; m and n
1 
1 -1 1/2 -1/6 1/24 -1/120
1

(f2cl-bf "alg082.for")
;; This one has the same array indexing problems!
2 3 ;; m and n
1 
1.266066 -1.130318 .271495 -.044337 .005474 -.000543
1
;; same results as the fortran code, but I can't make sense of the book's
;; values: we agree on some and disagree on others.

(f2cl-bf "alg083.for")
(*main*)
1
4
.2644
.84081
1.3615
1.61282
1.36672
.71697
.07909
-.14576
1
#|
	doesn't give the correct answers (that is, the fortran answers)
|#

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                Approximating Eigenvalues
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(f2cl-bf "alg091.for")
"y" "alg091.dat" 2 1e-6 100 1
;; agrees with fortran output, although the unit vector isn't!


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                     Chapter 10: Non-linear systems
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Newton's Method for Systems:
(f2cl-bf "alg101.for")
"y" 3 1e-6 100 .1 .1 -.1 1

;; Broyden
(f2cl-bf "alg102.for")
"y" 3 1e-6 100 .1 .1 -.1 1

;; Steepest Descent
(f2cl-bf "alg103.for")
(*main*)
"y" 3 .05 10 0 0 0 1
;; gave answers off from the books, almost (but not exactly the same as) those
;; of the fortran code.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                     Chapter 11: Boundary value problems
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(f2cl-bf "alg111.for")
"y" 1 2 1 2 10 1

(f2cl-bf "alg112.for")
"y" 1 3 17 43/3 20 1e-5 100 1

(f2cl-bf "alg113.for")
"y" 1 2 1 2 9 1

(f2cl-bf "alg114.for")
"y" 1 3 17 43/3 19 1e-8 100 1

(f2cl-bf "alg115.for")
"y" 9 1 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1

;; This one isn't working - a problem in the translation, as the same input
;; works for the fortran code (although there is a compilation error....)
;; (f2cl-bf "alg116.for")
;; "y" 9 62.01255336059963 -62.01255336059963 0 0 0 0 1
;; (func f(x) 2*pi^2*(sin (pi*x)))(diff f x fp)(fp 0)(fp 1)
#|
!alg116
y
9
62.01255336059963 -62.01255336059963
0 0 
0 0 
1
|#

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                    Chapter 12: pdes
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(f2cl-bf "alg121.for")
"y" 0 2 0 1 6 5 1e-10 100 1

(f2cl-bf "alg122.for")
"y" 1 .5 1 10 50 1

(f2cl-bf "alg123.for")
"y" 1 .5 1 10 50 1

;; Wave equation finite difference
(f2cl-bf "alg124.for")
"y" 1 1 2 10 20 1

;; too complicated at the moment (until I need finite elements!)
;; (f2cl-bf "alg125.for")


(new-readtable)














#|
	Hacks that I once considered to the declare and proclaim
	functions/macros, to make them more useful:

(defmacro declare (&rest args)
  (if *displace-macros*
      (dolist (a args)
        (if (eq (first a) 'special)
	    (return (warn "special declarations are not supported"))))))

(defun proclaim (decl)
  (if (eq (first decl) 'special)
      (dolist (s (rest decl))
        (mark-as-special s))))

	Proclaim marks the variables as special, which can be verified with
function specialp.

Here's an example of how they're used (from sfroid): 

 (proclaim (quote (special anorm c2 n mm h x)))
 (declare (type single-float anorm))
 (declare (type single-float b))
 (declare (type single-float c2))
 (declare (type fixnum n))
 (declare (type fixnum mm))
 (declare (type single-float h))
 (declare (type (simple-array single-float (quote (n))) x))

What I'm doing now is simply replacing the declarations by setq and nil, or
whatever (an array in the case of x).

IT APPEARS THAT WE ONLY WANT TO PROCLAIM VARIABLES ONE TIME, AND ONLY DECLARE
THEM ONE TIME TOO (THAT IS, IN THE MAIN PROGRAM). 

	Okay, I've gone that route rather than the route suggested by the work
below. I've used the program-flag variable to tell me when I'm in the program,
and in that case I add an initialization if it's an array (in
make-special-var-decl).

	There might be some value in messing around with proclaim and declare,
however... 

(defmacro declare (&rest args)
  "
;; Examples:
 (proclaim (quote (special anorm c2 n mm h x)))
 (declare (type single-float anorm))
 (declare (type single-float b))
 (declare (type single-float c2))
 (declare (type fixnum n))
 (declare (type fixnum mm))
 (declare (type single-float h))
 (eval `(declare (type (simple-array single-float ,n ) x)))
"
  (if *displace-macros*
      (dolist
       (a args)
       (let ((type (first a)))
	 (cond
	  ((eq type 'special)
	   (return (warn "special declarations are not supported"))
	   )
	  ((eq type 'type)
	   (let (
		 (form (second a))
		 (name (third a))
		 )
	     (if (and (specialp name) (not (boundp name)))
		 (cond
		  ((listp form)
		   (let (
			 (type (first form))
			 (form (second form))
			 ;; of the form (quote (array-dims))
			 ;; (size (second (third form)))
			 (size (third form))
			 )
		     (print size)
		     (setq size (if (numberp size) (list size) size))
		     (print size)
		     (genvars (eval `(symbol-name ',name)) (make-array size))
		     (print size)
		     )
		   )		     
		  ((or
		    (eq form 'single-float)
		    (eq form 'double-float)
		    )	       
		   (eval `(genvars (symbol-name ',name) 1.0))
		   )
		  ((eq form 'fixnum)
		   (eval `(genvars (symbol-name ',name) 1))
		   )
		  ((eq form 'complex)
		   (eval `(genvars (symbol-name ',name) #c(0 1)))
		   )
		  ((eq form 'logical)
		   (eval `(genvars (symbol-name ',name) t))
		   )
		  (t
		   (break (format nil "Unknown form (~s) in declare." form))
		   )
		  )
	       )
	     )
	   )
	  )
	 )
       )
    )
  )

then we need to write array declarations as:
 (eval `(declare (type (simple-array single-float ,m ) x)))
or 
 (eval `(declare (type (simple-array single-float (list ,m ,n)) x)))
etc.
|#
