;; 				Flesh2.lsp:
#|
	I want to test the function mesh: my function will be a symmetric
function, to make my life easy.
|#
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Start with some function which generates a rank-three matrix A.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(def start 0)
(def end 2)
(func f(x y)
      ;; This piece is zero at x=start and y=start
      -ln(x+1)*sin(y)
      +
      ;; a piece that is zero at x=end and y=end
      -sin(end-x)*((y-1)* (y-end))
      + 
      ;; this last piece which is zero on the entire boundary, as the product
      ;; of the first two pieces:
      -ln(x+1)*sin(y)*sin(x-end)*(square (y-end))
      ;; 
      + 1
      )
(def m 2)

(title (format nil "Using ~d functions" m))
(def xs (rseq start end m))
(def ys xs)
(def A (outer-product xs ys #'f))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Now I'm going to create the interpolating function:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun G(x) (mapcar (lambda(y) (f x y)) ys))
(defun H(y) (mapcar (lambda(x) (f x y)) xs))
(def inv (pseudo-inverse A))
(mprint inv)
(defun skin(x y) (matmult (g x) inv (h y)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                     Now we'll look at some plots:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(spin-domain start end start end)
(spin-points 21)
(plot skin)
(plot f)
(plot f skin)
(defun diff(x y) (- (skin x y) (f x y)))
(plot diff)
(def plots (select (agw) (iseq 4)))
(mapcar (lambda (x) (send x :linked t)) plots)
(print
 (max (abs (outer-product (rseq start end 21) (rseq start end 21) #'diff))))
(print
 (max (abs (outer-product (rseq start end 21) (rseq start end 21) #'f))))
(tile plots :height 300 :width 300)

(def A 
     (matrix '(7 6)
	     '(0.0 0.0 0.0 0.0 0.0 0.0
		   3.6 7.2 10.8 14.4 18.0 21.6
		   11.2 22.4 33.6 200.0 56.0 67.2
		   14.8 29.6 44.4 59.2 74.0 88.8
		   24.4 48.8 73.2 97.6 122.0 146.4
		   30.0 60.0 90.0 120.0 150.0 180.0
		   49.6 99.2 148.8 198.4 248.0 297.6
		   )
	     ))
(latex-table (transpose A))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Now I'm going to create the interpolating function:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun G(x) (mapcar (lambda(y) (f x y)) ys))
(defun H(y) (mapcar (lambda(x) (f x y)) xs))
(def inv (pseudo-inverse A))
(mprint inv)
(defun skin(x y) (matmult (g x) inv (h y)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                     Now we'll look at some plots:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(spin-domain start end start end)
(spin-points 21)
(plot skin)
(plot f)
(plot f skin)
(defun diff(x y) (- (skin x y) (f x y)))
(plot diff)
(def plots (select (agw) (iseq 4)))
(mapcar (lambda (x) (send x :linked t)) plots)
(print
 (max (abs (outer-product (rseq start end 21) (rseq start end 21) #'diff))))
(print
 (max (abs (outer-product (rseq start end 21) (rseq start end 21) #'f))))
(tile plots :height 300 :width 300)
