;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                Fun quotes
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(def quotes
     (list
      "Je m'adresse \`a Dieu en espagnol, aux femmes en italien, aux hommes en
francais et en allemand \`a mon cheval. Charles QUINT."
      "Il m'a toujours paru que l'on pouvait recueillir plus d'instruction de
ce qui se re'p`ete que de ce qui ne recommence jamais. Andre' GIDE: Feuillets,
OEuvres X"
      )
     )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                   Fun phrases, which may prove useful:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(setq phrases
      (list
       "comme suit" ;; as follows: la solution se formalise donc comme suit:
		    ;; page 83.
       "en un temps" ;; in a time: en un temps o`u les changements de
		     ;; mate'riels tendent a s'acce'le'rer
       "e'tant le rangement du re'sultat de ce calcul dans une variable"
       "crit`ere d'arr^et" ;; stopping criterion
       "mettant en jeu" ;; putting into play
       "par de'faut" ;; by default
       "usant intrigue, ruses, et coups bas" ;; from Tam-Tam, 11/97
       "un homme capable de faire feu de tout bois" ;; from Tam-Tam
       ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;               Variables to help me keep genders straight:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(def feminine
     '(
       **ion aide boucle capacite\' cha\^ine chronologie classe complexite\'
contrainte convergence diffe\'rence dictionnaire discipline donne\'e
encyclope\'die entree\' e\'tape fa\,con fois forme formule grammaire halte
hypoth\`ese image ligne liste longueur machine maintenance me\'thode me\'moire
part phase primitive proce\'dure proprie\'te\' quantite\' recherche r\`egle
richesse se\'quence structure suite syntaxe table t\^ache taille valeur
validite\' variable vertue vision vue
       ))

(def masculin
     '(
       **ment agre\'gat algorithme bagage but calcul caract\`ere cas cerveau
clavier client code coeur compilateur compte conducteur corps courant degre\'
devoir domaine e\'diteur e\'le\'ment ensemble exemple exercice fichier
formalisme format groupe indice jeu laboratoire langage me\'chanisme niveau
nombre nume\'ro objet point probl\`eme processus produit programme raisonnement
re\'sultat saut sens signe symbole syst\`eme tableau temps terme test texte
type vecteur vocabulaire
       ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                To pack in new gender-specific nouns
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmacro masculin(&rest x)
  (dolist
   (i x)
   (if (not (search (list i) masculin))
       (setq masculin (append masculin (list i)))
     )
   )
  (values)
  )
(defmacro feminine(&rest x)
  (dolist
   (i x)
   (if (not (search (list i) feminine))
       (setq feminine (append feminine (list i)))
     )
   )
  (values)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                   Gender - to get at the gender of nouns
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmacro gender(x &key within)
  "
	gender(x &key within)

Gender expects part of the beginning of a word as an argument, and produces a
pair of lists, of feminine and masculine French words beginning with that.

	The within key lets you change that to matching any portion....

;; Examples:
 (gender c)
 (gender e\\\'tape)
 (gender elle :within t)
"
  (let* (
	 (f (sort (mapcar #'symbol-name feminine) 'string<))
	 (m (sort (mapcar #'symbol-name masculin) 'string<))
	 (x (symbol-name x))
	 (lenx (length x))
	 (within
	  (if within
	      #'(lambda(y) (if (grep x y) t))
	    #'(lambda(y) (equal (subseq y 0 (min (length y) lenx)) x))
	    ))
	 (ms (select m (which (mapcar within m))))
	 (fs (select f (which (mapcar within f))))
	 )
    (if ms (format t (strcat "Masculin: "
			     (apply #'strcat
				    (mapcar
				     #'(lambda(x)
					 (strcat (string-downcase x) " "))
				     ms))
			      "~%")))
	
    (if fs (format t (strcat "Feminine: "
			     (apply #'strcat
				    (mapcar
				     #'(lambda(x)
					 (strcat (string-downcase x) " "))
				     fs))
			      "~%")))
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                    Working list of additional words:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(feminine
 chimie erreur sortie variante re\'currence fin limite vitesse grappe zone
 somme norme diagonale inte\'grale corde courbe the\'orie 
 clarte\' ; clarity
 cours ; course
 lacune ; ??
 synth\`ese mesure fonctionnelle voie varie\'te\' note 
 )
(masculin
 chauve cheval chiffre cimeti\`ere param\`etres entier intervalle
 sche\'ma de\'but principe crit\`ere graphe rang ope\'rateur gain parcours
 de\'calage contr\^ole chapitre r\^ole mot 
 me\'moire sens usage traite\' ouvrage livre filtre article tome dual support
 passage peu espace 
 me\'chanisme formalisme **isme\?\? ;; and so a hypothesis presents itself!
 voisinage **age\?\?
 )

(def
 french-definitions
 (split-list
  (list
   "parcours" "m. distance covered; course, way, road, route."
   "de\'caler" "to unwedge; shift, alter; readjust"
   "grappe" "f. bunch, cluster"
   "toutefois" "however, yet, nevertheless"
   "par ailleurs" "incidently, otherwise, besides"
   "par dessous" "underneath, below"
   "par dessus" "over, above"
   "imbrique'es" "nested"
   "emboite'es" "nested"
   "sit^ot" "so soon, as soon"
   )
  2
  )       
 )

(def
 words-I-should-use-more-often      
 '(
   "tant que"
   "parfois"
   "toutefois"
   "par ailleurs"
   "sche'matiser"
   "postuler"
   "sit^ot"
   ))