#|
	This is from a paper by John J. Gart, The comparison of proportions: a
review of significance tests, confidence intervals, and adjustments for
stratification, Review of the International Statistical Institute, V. 79, #2,
1971.

|#
(message "Example 1, p. 152-154")

(setq n 95)
(setq e11 (/ (* 9 16) n))

(setq a 4)
(setq b 5)
(setq c 12)
(setq d 74)
(setq alpha 16)
(setq beta 79)
(setq gamma 9)
(setq delta 86)

(setq chi-sq (calc n*(a*d-b*c)^2/(alpha*beta*gamma*delta)))
(setq df 1)
(setq chi-prob (- 1 (chisq-cdf chi-sq df)))
(setq odds-ratio (calc a*d/(b*c)))
(setq corrected-odds-ratio (calc (a+.5)*(d+.5)/((b+.5)*(c+.5))))
(setq lambda-hat (ln corrected-odds-ratio))


