;; add to manual: rast2vec
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				rast2vec
;;
(defun rast2vec(a file)
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			rast2vec Doc:
;;
;; Author: Andy Long
;; Created: Fri Jan 15 23:19:08 1999
;;
;; Description/Arguments: rast2vec

	

;; Arguments: a, file

;; Returns: 

;; Notes: 

;; See Also: 

;; Key Functions:

;; Examples:
 (rast2vec 
  (matrix '(6 7)
   '(
	0 1 1 0 1 0 1
	1 0 0 1 0 1 0
	1 1 0 1 0 1 0
	1 0 0 0 1 0 0
	0 1 0 1 1 1 1
	0 1 1 1 0 1 1
    ))
  \"/dos/grass/data/class/PERMANENT/dig_ascii/stuff\"
  )
 (rast2vec 
  (matrix '(6 7)
   '(
	1 1 1 0 1 0 1
	1 1 1 1 0 1 0
	1 1 1 1 0 1 0
	1 0 0 0 1 0 0
	0 1 0 1 1 1 1
	0 1 1 1 0 1 1
    ))
  \"/dos/grass/data/class/PERMANENT/dig_ascii/stuff\"
  )
"
  (let* (
	 (size (size a))
	 (nrows-1 (1- (first size)))
	 (ncols-1 (1- (second size)))
	 ;; make it binary:
	 (a (matrix size (mapcar 
			  (lambda(x) (if (= x 0) 0 1))
			  (combine a))))
	 (a (remove-innards a))
	 )
    (with-open-file
     (f file :direction :output)
     (format f "ORGANIZATION: Andy's rast2vec brigade
DIGIT DATE:   
DIGIT NAME:   
MAP NAME:     
MAP DATE:     
MAP SCALE:    1
OTHER INFO:   
ZONE:         0
WEST EDGE:    0
EAST EDGE:    ~d
SOUTH EDGE:   0
NORTH EDGE:   ~d
MAP THRESH:   0
VERTI:" ncols-1 nrows-1)
     (let ((fileinfo (list f (first size))))
       (dotimes
	(i nrows-1)
	(dotimes
	 (j ncols-1)
	 (find-next fileinfo a i j)
	 )
	)
       (dotimes
	(i nrows-1)
	(find-vert fileinfo a i ncols-1))
       (dotimes
	(j ncols-1)
	(find-hori fileinfo a nrows-1 j))
       )
     )
    )
  )

(defun find-next (f a i j)
  (if (= 1 (aref a i j)) 
      (let ()
	;; if the one below is 1, link:
	(if (= 1 (aref a        (1+ i) j))
	    (write-out f i j    (1+ i) j))
	;; if the one to the right is 1, link:
	(if (= 1 (aref a        i (1+ j)))
	    (write-out f i j    i (1+ j)))
	;; if the diagonal is 1, link:
	(if (= 1 (aref a        (1+ i) (1+ j)))
	    (write-out f i j    (1+ i) (1+ j)))
	)
    )
  ;; if the one below  and the one to the right are 1, link:
  (if (and
       (= 1 (aref a (1+ i) j))
       (= 1 (aref a i (1+ j)))
       )
      (write-out f i (1+ j) (1+ i) j)
    )
  )  


(defun find-vert (f a i j)
  (if (and
       (= 1 (aref a (1+ i) j))
       (= 1 (aref a i j))
       )
      (write-out f i j (1+ i) j)
    )
  )  

(defun find-hori (f a i j)
  (if (and
       (= 1 (aref a i (1+ j)))
       (= 1 (aref a i j))
       )
      (write-out f i j i (1+ j))
    )
  )

(defun write-out (f ii jj i j)
  (let (
	(ni  (- (second f)  i))
	(nii (- (second f) ii))
	)
    (format (first f) "
A  2
 ~g ~g
 ~g ~g" ni j nii jj ni j nii jj)
    )
  )

(defun remove-innards (a)
  (let* (
	 (size (size a))
	 (nrows-2 (- (first size) 2))
	 (ncols-2 (- (second size) 2))
	 (tmp (make-array size :initial-element 0))
	 )
    (dolist
     (i (iseq 1 nrows-2))
     (dolist
      (j (iseq 1 ncols-2))
      (if (= 9 (check-pattern a i j))
	  (setf (aref tmp i j) 1))
      )
     )
    (mprint a)
    (mprint (- a tmp))
    (- a tmp)
    )
  )

(defun check-pattern (a i j)
  (sum (select a (iseq (1- i) (1+ i)) (iseq (1- j) (1+ j)))))
