#|
	I modified something that Frederic Udina produced: he says

"I attach my hack for gray-level plots, it do not fully does what you
need but it's close..."

Frederic Udina
_______________________________________________________________________
                                    |       voice: 34 - 3 - 542 17 56
Facultat de Ciencies Economiques    |         fax: 34 - 3 - 542 17 46
Universitat Pompeu Fabra            |      e-mail: udina@upf.es
       Ramon Trias Fargas, 25-27    |  WWWeb: http://libiya.upf.es/
       08005 Barcelona SPAIN        | or http://www.econ.upf.es/~udina
____________________________________-__________________________________
>> Please
>> DON'T include this e-mail address in any commercial mailing list << 
|#

(def gray-rgb
     (transpose
      (list
       '(GRAY0 GRAY5 GRAY10 GRAY15 GRAY20 GRAY25 GRAY30 GRAY35 GRAY40 GRAY45
	       GRAY50 GRAY55 GRAY60 GRAY65 GRAY70 GRAY75 GRAY80 GRAY85 GRAY90
	       GRAY95 GRAY100)
;;       (rseq .2 .8 21)
;;       (rseq .2 .8 21)
       (repeat 1 21)
       (repeat 1 21)
       (rseq .2 .8 21)
       )))

(mapcar #'(lambda (c4) (apply #'make-color c4)) gray-rgb)
(def *gray-colors* (reverse (first (transpose gray-rgb))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                         paint-gray-rects
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun paint-gray-rects (rects graph)
  "
    paint-gray-rects (rects graph)

where rects is a list of (xr yr n),  xr is a list (xmin xmax) in 'real'
coordinates, while graph is a graph-proto descendant.
"
  (let* (
	 (old-color (send graph :draw-color))
	 (values (third (transpose rects)))
	 (values (- values (min values)))
	 (imax (/ (1- (length *gray-colors*)) (max values)))
	 (colors (round (* values imax)))
	 left-top
	 right-bottom
	 )
    (map-elements
     #'(lambda (r3 c) 
	 (send graph :draw-color (select *gray-colors* c))
	 (setq
	  left-top (send graph :scaled-to-canvas 
			 (first (first r3)) 
			 (second (second r3)))
	  right-bottom (send graph :scaled-to-canvas 
			     (second (first r3)) 
			     (first (second r3))))
	 (send graph :paint-rect ;;LEFT TOP WIDTH HEIGHT
	       (first left-top) (second left-top)
	       (first (- right-bottom  left-top))
	       (second (- right-bottom  left-top))))
     rects
     colors
     )
    (send graph :draw-color old-color)
    )
  )

(defun gray-map-DEMO()
  (let ((plgray (plot-points '((0 2) (0 2)))))

    (defmeth plgray :redraw-content ()
      (let ((rectangles
	     (mapcar #'(lambda (i)
			 (list (+ (repeat (car (uniform-rand 1)) 2)
				  (cons 0 (uniform-rand 1)))
			       (+ (repeat (car (uniform-rand 1)) 2)
				  (cons 0 (uniform-rand 1)))
			       (floor (1+ (* 100 (car (uniform-rand 1)))))))
		     (iseq 20)))
	    )
	(call-next-method)
	(paint-gray-rects rectangles plgray)
	)
      )
    
    (dolist
     (gray *gray-colors*)
     (send plgray :draw-color gray)
     (send plgray :title (symbol-name gray))
     (apply #'send plgray :paint-rect (send plgray :content-rect)) 
     (pause 60)
     )
    )
  )

(gray-map-DEMO)