(def greek '(
    391
                      GREEK CAPITAL LETTER ALPHA

    392
                      GREEK CAPITAL LETTER BETA

    393
                     GREEK CAPITAL LETTER GAMMA

    394
                      GREEK CAPITAL LETTER DELTA

    395
                     GREEK CAPITAL LETTER EPSILON

    396
                       GREEK CAPITAL LETTER ZETA

    397
                       GREEK CAPITAL LETTER ETA

    398
                      GREEK CAPITAL LETTER THETA

    399
                       GREEK CAPITAL LETTER IOTA

    39A
                      GREEK CAPITAL LETTER KAPPA

    39B
                      GREEK CAPITAL LETTER LAMBDA

    39C
                       GREEK CAPITAL LETTER MU 

    39D
                       GREEK CAPITAL LETTER NU 

    39E
                        GREEK CAPITAL LETTER XI 

    39F
                     GREEK CAPITAL LETTER OMICRON

    3A0
                        GREEK CAPITAL LETTER PI 

    3A1
                       GREEK CAPITAL LETTER RHO

    3A3
                      GREEK CAPITAL LETTER SIGMA

    3A4
                       GREEK CAPITAL LETTER TAU

    3A5
                     GREEK CAPITAL LETTER UPSILON

    3A6
                       GREEK CAPITAL LETTER PHI

    3A7
                       GREEK CAPITAL LETTER CHI

    3A8
                       GREEK CAPITAL LETTER PSI

    3A9
                     GREEK CAPITAL LETTER OMEGA

    3B1
                       GREEK SMALL LETTER ALPHA

    3B2
                       GREEK SMALL LETTER BETA 

    3B3
                      GREEK SMALL LETTER GAMMA

    3B4
                       GREEK SMALL LETTER DELTA

    3B5
                      GREEK SMALL LETTER EPSILON

    3B6
                       GREEK SMALL LETTER ZETA 

    3B7
                        GREEK SMALL LETTER ETA 

    3B8
                       GREEK SMALL LETTER THETA

    3B9
                       GREEK SMALL LETTER IOTA 

    3BA
                       GREEK SMALL LETTER KAPPA

    3BB
                      GREEK SMALL LETTER LAMBDA

    3BC
                        GREEK SMALL LETTER MU 

    3BD
                        GREEK SMALL LETTER NU 

    3BE
                        GREEK SMALL LETTER XI 

    3BF
                     GREEK SMALL LETTER OMICRON

    3C0
                        GREEK SMALL LETTER PI 

    3C1
                       GREEK SMALL LETTER RHO 

;;    3C2
;;                    GREEK SMALL LETTER FINALSIGMA

    3C3
                       GREEK SMALL LETTER SIGMA

    3C4
                        GREEK SMALL LETTER TAU 

    3C5
                      GREEK SMALL LETTER UPSILON

    3C6
                        GREEK SMALL LETTER PHI 

    3C7
                        GREEK SMALL LETTER CHI 

    3C8
                        GREEK SMALL LETTER PSI 

    3C9
                      GREEK SMALL LETTER OMEGA
))

(mvsq '(hex lang size nappy name)
      (mapcar 
       (lambda(x) (coerce x 'vector))
       (transpose (split-list greek 5))
       )
      )
(defun hex-to-10(s)
  "
;; Examples:
  (hex-to-10 \"3a4\")
  (hex-to-10 \"3b1\")
"
  (let (
	;; (s (num-to-string n))
	(sum 0) (i 1) char
	)
    (dolist
     (s (reverse (coerce s 'list)))
     (setf 
      char (read-from-string (format nil "~a" s))
      char (cond
	    ((numberp char) char)
	    ((eq char 'a) 10)
	    ((eq char 'b) 11)
	    ((eq char 'c) 12)
	    ((eq char 'd) 13)
	    ((eq char 'e) 14)
	    ((eq char 'f) 15)
	    )
      sum (+ sum (* i char))
      i (* i 16)
      )
     )
    sum
    )
  )

(setq
 hex (coerce hex 'list)
 name (coerce name 'list)
 size (coerce size 'list)
 unicode (mapcar 
	  (lambda(x name)
	    (let* (
		   (s (format nil "~a" x))
		   (n (hex-to-10 s))
		   )
	      (strcat "&#" (num-to-string n) ";")))
	  hex
	  name
	  )
 i 0
 latex (mapcar
	  (lambda(name size unicode)
	    (format nil "
\"$\\~a$\",~a,~d,~a

" 
		    (if (eq size 'small)
			name 
		      (string-upcase (string-downcase name) :end 1)
		      )
		    unicode (incf i)
		    (if (eq size 'small)
			name 
		      (string-upcase (string-downcase name) :end 1)
		      )
		    )
	    )
	  name
	  size
	  unicode
	  )
 d nil
 )
(with-open-file
 (f "/afs/sph.umich.edu/user/a/aelon/web/geomed/statsreq/crapola.tex"
    :direction :output)
 (format f "
\\documentstyle[12pt,epsf,rotate]{article}
\\input usual_defs
\\begin{document}
 
")
 (mapcar (lambda(x) (format f "~a" x)) latex)
 (format f "\\end{document}
")
 )
 
