#|

	This is to look at the effect of integrating various functions over the
"relative risk". Jay did this, plotting relative risk for a function.

|#

(format t "an exponential risk=exp(x) gives an essentially linear RR:~%")
(new-plot)
(func g(x) (exp x))
(func f(x) ((exp x) - 1)/x/(((exp 1) - (exp x))/(1-x)))

(title "Exponential Risk over 0 1")
(plot g 0.01 .99)
(title "analytically for exp(x) over 0 1")
(plot f 0.01 .99)
(title "numerically for exp(x) over 0 1")
(plot (rseq .01 .99 100)
      (mapcar
       #'(lambda(x)
	   (/
	    (/ (gauss g 0 x 10) x)
	    (/ (gauss g x 1 10) (- 1 x))
	    )
	   )
       (rseq .01 .99 100)
       )
      )

(format t "a linear function risk=x gives x/(1+x) as categorized RR:~%")
(new-plot)
(func f(x) x/(1+x))
(func g(x) x)

(title "Risk over 0 1")
(plot g 0.01 .99)
(title "analytically for x over 0 1")
(plot f 0.01 .99)
(title "numerically for x over 0 1")
(plot (rseq .01 .99 100)
      (mapcar
       #'(lambda(x)
	   (/
	    (/ (gauss g 0 x 10) x)
	    (/ (gauss g x 1 10) (- 1 x))
	    )
	   )
       (rseq .01 .99 100)
       )
      )

(format t "a quadratic function risk=x^2 gives x^2/(1+x+x^2) as categorized RR:~%")
(new-plot)
(func f(x) x^2/(1+x+x^2))
(func g(x) x^2)

(title "Risk over 0 1")
(plot g 0.01 .99)
(title "analytically for x over 0 1")
(plot f 0.01 .99)
(title "numerically for x over 0 1")
(plot (rseq .01 .99 100)
      (mapcar
       #'(lambda(x)
	   (/
	    (/ (gauss g 0 x 10) x)
	    (/ (gauss g x 1 10) (- 1 x))
	    )
	   )
       (rseq .01 .99 100)
       )
      )


(format t "a cubic function risk=x^3 gives x^3/(1+x+x^2+x^3) as categorized RR:~%")
(new-plot)
(func f(x) x^3/(1+x+x^2+x^3))
(func g(x) x^3)

(title "Risk over 0 1")
(plot g 0.01 .99)
(title "analytically for x over 0 1")
(plot f 0.01 .99)
(title "numerically for x over 0 1")
(plot (rseq .01 .99 100)
      (mapcar
       #'(lambda(x)
	   (/
	    (/ (gauss g 0 x 10) x)
	    (/ (gauss g x 1 10) (- 1 x))
	    )
	   )
       (rseq .01 .99 100)
       )
      )

(format t "a ln function risk=ln(x+1) gives ? as categorized RR:~%")
(new-plot)
;;(func f(x) x^3/(1+x+x^2+x^3))
(func g(x) (ln (x+1)))

(title "Risk over 0 1")
(plot g 0.01 .99)
;;(title "analytically for x over 0 1")
;;(plot f 0.01 .99)
(title "numerically for x over 0 1")
(plot (rseq .01 .99 100)
      (mapcar
       #'(lambda(x)
	   (/
	    (/ (gauss g 0 x 10) x)
	    (/ (gauss g x 1 10) (- 1 x))
	    )
	   )
       (rseq .01 .99 100)
       )
      )

