#| - ael - Fri Jan 1 15:59:16 1999

Pages of interest on poisson processes:
	http://math.yorku.ca/SCS/Courses/grcat/grc1.html
http://apollo.wku.edu/Dept/Academic/Ogden/Math/instruct/statistics/stats.html

	The idea here is to create a simulation of an infectious process. I'm
going to follow the idea of the book "Spatial Processes", by Cliff and Ord, and
use one poisson process followed by a second. I.e., the first poisson process
distributes the disease based on the weighted underlying population structure,
while the second reflects the choice of a second poisson process that reflects
infections from the primary infecteds.

	In other words, the infecteds always spread out from the infected in a
poisson fashion.

 - lea - |#

(defun siminfect(lam1 lam2)
  "

	Now the points represent the positions of our initial infected.
They got together at a hotel, they all shared a disease, and now they're back
home again. They're about to share the disease again: we'll give them a random
number of close friends, and they'll distribute their diseases among them.

	We begin with a uniformly distributed population, in which case the
elements of a poisson are given by the uniform distribution.

;; Examples:
 (siminfect 10 5)
"
  (let* (
	 (initial (first (poisson-rand 1 lam1)))
	 (x (rand.u initial))
	 (y (rand.u initial))
	 (points (transpose (list x y)))
	 )

    (lines off)
    (plotter x y)

    (dolist 
     (inf points)
     (let* (
	    (friends (first (poisson-rand 1 lam2)))
	    (x (- 1 (* 2 (rand.u friends))))
	    (y (- 1 (* 2 (rand.u friends))))
	    (scale .1)
	    (points (* scale (transpose (list x y))))
	    (new-coords (mapcar (lambda(x) (+ x inf)) points))
	    )
       (send my-plot :add-plot-item
	     (list 'points (xs new-coords) (ys new-coords) 'red 'wedge1))
       )
     )
    (send my-plot :adjust-to-data)
    )
  )
