(defun matrix-function (a func)
  "
;; Examples:
 (setq a #2A((2 -1) (-1 2)))
 (matrix-function a #'sqrt)
 (matrix-function a (lambda(x) (^ x (/ 3))))
"
  (let* (
	 (ee (eigen a))
	 (ea (coerce (funcall func (first ee)) 'list))
	 (ey (second ee))
	 )
    (apply #'+ (mapcar #'(lambda (x z) (* z (outer-product x x))) ey ea))
    )
  )

(defun andy(a func)
  "
;; Examples:
 (setq a #2A((2 -1) (-1 2)))
 (andy a #'sqrt)
 (andy a (lambda(x) (^ x (/ 3))))
"
  (let* (
	 (svd (svd a))
	 (ea (coerce (funcall func (second svd)) 'list))
	 (ey (column-list (first svd)))
	 )
    (apply #'+ (mapcar #'(lambda (x z) (* z (outer-product x x))) ey ea))
    )
  )