;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 lecture
;;
(defun lecture(file output)
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                          lecture Doc:
;;
;; Author: Andy Long
;; Created: //1997
;;
;; Description/Arguments:

       (lecture)
  
;; Notes:

;; See Also:

;; Examples:
 (lecture \"crap\" \"stuff\")
"
  (let* (
	 (lines (read-file file))
	 (types '("<ol type=A>"
		  "<ol type=1>"
		  "<ol type=a>"
		  "<ol type=i>"))
	 (ntypes (length types))
	 (previous -1)
	 )
    (with-open-file
     (stream output :direction :output)
     (dolist
      (line lines)
      (if (> (length (space-trim line)) 0)
	  (let* (
		 (tmp (string-left-trim '(#\@) line))
		 (ntabs (- (length line) (length tmp)))
		 (line tmp)
		 (type (if (>= ntabs ntypes)
			   (list "<ul>" "</ul>")
			 (list (elt types ntabs) "</ol>")))
		 newtype
		 )
	    (cond 
	     ((= ntabs 0)
	      (format stream "~a~%" line))
	     ((= ntabs previous)
	      (format stream "~{~a~} <li>~a~%" (repeat #\Tab ntabs) line))
	     ((> ntabs previous)
	      (setq previous ntabs)
	      (format stream "~a~%<li>~a~%" (first type) line))
	     (t
	      (dolist
	       (i (iseq previous (1+ ntabs)))
	       (setq type (if (>= i ntypes)
			      (list "<ul>" "</ul>")
			    (list (elt types i) "</ol>")))
	       (format stream "~a~%" (second type) line))
	      (setq previous ntabs)
	      (format stream "<li>~a~%" line))
	     )
	    )
	)
      )
     (dolist
      (n (reverse (iseq previous)))
      (format stream "~a~%" (if (> n ntypes) "</ul>" "</ol>"))
      )
     )
    )
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
