#|
	This was a demonstration that I rigged up for Jay, to show him the
effect of varying the parameters in a logistic model.
|#

;; The logistic function:
(func f(p x) (1 / (1 + (exp ((- (first p)) - x * (second p))))))

(def parameters
     (weave 
      (matrix-to-list (outer-product (^ (- (ones 1 20)) (iseq 20))
				     (rseq -1 1 20)))
      (matrix-to-list (outer-product (rseq -1 1 20) (ones 1 20)))
      ))

(title "adjusting a and b simultaneously")
(animate f parameters -2pi 2pi :loops 1)

(def parameters (rseq -5 5 40))
(func f(p x) (1 / (1 + (exp (- p - x)))))
(func g(p x) (1 / (1 + (exp (p * x)))))
(range 0 1)
(title "adjusting constant a from -5 to 5")
(animate f parameters -10 10 :loops 2)
(title "adjusting multiplier b from -5 to 5")
(animate g parameters -2pi 2pi :loops 2)
