#|
Sat Sep 18 12:44:29 EDT 1999

This is a model of malarial resistance that Steve Meshnick is working on. I'm
back in the D.E. game!

Can't seem to match up with Steve's results for thailand.... I'm just going to
walk slowly through the equations.
|#

(defun quinine-thailand()
  ;; Parameters:
  (setq
   G .16
   H .8
   gamg 12
   gamh gamg
   gamr 26
   gam0 3
   squig .00091
   Cg .77
   a 2
   mu 26
   m 100
   b 1
   c 1
   )
  ;; Initial conditions:
  (setq ynot (list .1 0 0 0 .1 0))

  ;; Run length and duration
  (setq
   start 0
   end 40
   num 4000
   )
  )

(defun quinine-malawi()
  ;; Parameters:
  (setq
   G .001
   H .5
   gamg 12
   gamh gamg
   gamr 26
   gam0 3
   squig .00091
   Cg .77
   a 20
   mu 26
   m 100
   b 1
   c 1
   )
  ;; Initial conditions:
  ;; Steve claims that
  ;; (f (list .980976 0.00772895  0.00253125    8.62581e-05 0.431505 0.0011401))
  ;; is an equilibrium.
  ;; I get (f (list 0.990609 0.000789 0.000002 0.000000 0.432660 0.000001))

  (setq ynot 
;; 	(list .8 0 0 0 .1 0)
;; 	(list 0.980976        0.00772895     0.00253125    8.62581e-05 0.43350793531043447 0)
;;	(list 0 0 0.9913920134173728 0.0034327064379785833 0 0.43350793546434824)
;;	(list 0.990609 0.000789 0.000002 0.000000 0.432660 0.000001)
;;	(list 0.9906064356678189 7.888831078873672E-4 3.962735356556398E-6 2.743410892143008E-8 0.4326593449053519 1.7396655453839629E-6)
;;	(list 0.9906043109701855 7.888814048826378E-4 6.096940039085739E-6 3.4818521606563806E-8 0.43265841027330926 2.6740937015751297E-6)
;;	(list 0.9906018774348087 7.888795098468422E-4 8.472391939004278E-6 4.3037658776308537E-8 0.43265737093350237 3.7141484128285215E-6) 	
	(list 0.990599260557427 7.888773999659293E-4 1.1116361217547882E-5 5.218587183364085E-8 0.43265621285032235 4.871768953766356E-6)
	)

  ;; Run length and duration
  (setq
   start 0
   end 20
   num 4000
   )
  )

(defun mefloquine-thailand()
  ;; Parameters:
  (setq
   G .2
   H .8
   gamg 12
   gamh gamg
   gamr 26
   gam0 3
   squig .031
   Cg .95
   a 2
   mu 26
   m 100
   b 1
   c 1
   )
  ;; Initial conditions:
  (setq ynot (list .1 0 0 0 .1 0))

  ;; Run length and duration
  (setq
   start 0
   end 40
   num 4000
   )
  )

(defun mefloquine-thailand-mutate()
  ;; Parameters:
  (setq
   G .2
   H .8
   gamg 12
   gamh gamg
   gamr 26
   gam0 3
   squig .031
   Cg .95
   a 2
   mu 26
   m 100
   b 1
   c 1
   )
  ;; Initial conditions:
  (setq ynot (list .1 0 0.001 0 .1 0.001))

  ;; Run length and duration
  (setq
   start 0
   end 40
   num 4000
   )
  )

(defun artesunate+mefloquine+thailand()
  ;; Parameters:
  (setq
   G .36
   H .8
   gamg 12
   gamh gamg
   gamr 26
   gam0 3
   squig .000017
   Cg .95
   a 2
   mu 26
   m 100
   b 1
   c 1
   )
  ;; Initial conditions:
  (setq ynot (list .1 0 0 0 .1 0))

  ;; Run length and duration
  (setq
   start 0
   end 40
   num 4000
   )
  )

(defun atovaquone+mefloquine+thailand()
  ;; Parameters:
  (setq
   G .2
   H .8
   gamg 12
   gamh gamg
   gamr 26
   gam0 3
   squig .0085
   Cg .95
   a 2
   mu 26
   m 100
   b 1
   c 1
   )
  ;; Initial conditions:
  (setq ynot (list .1 0 0 0 .1 0))

  ;; Run length and duration
  (setq
   start 0
   end 40
   num 4000
   )
  )

;; put the appropriate setup last, and it will overrule the others:
(let ()
  (format t "Choose your simulation:~%
0 - quinine-thailand
1 - quinine-malawi
2 - mefloquine-thailand
3 - mefloquine-thailand-mutate
4 - artesunate+mefloquine+thailand
5 - atovaquone+mefloquine+thailand
")
  (setq reply (read))
  (case reply
	(0 (quinine-thailand)
	   (title "quinine-thailand")
	   )
	(1 (quinine-malawi)
	   (title "quinine-malawi")
	   )

	(2 (mefloquine-thailand)
	   (title "mefloquine-thailand")
	   )

	(3 (mefloquine-thailand-mutate)
	   (title "mefloquine-thailand-mutate")
	   )

	(4 (artesunate+mefloquine+thailand)
	   (title "artesunate+mefloquine+thailand")
	   )

	(5 (atovaquone+mefloquine+thailand)
	   (title "atovaquone+mefloquine+thailand")
	   )

	)
  )

;; Set up some big, ugly constants:
(setq
 mab (* m a b)
 ac (* a c)

 GCggamg (* G Cg gamg)
 Hgamh (* H gamh)
 1-H-GCg*gam0 (* (- 1 H (* G Cg)) gam0)
 1-Cg (- 1 Cg)
 gamrG (* gamr G)
 gamrG*1-Cg (* gamrG 1-Cg)
 G+H (+ G H)
 squig/gamg (/ squig gamg)

 ugly0 (+ GCggamg Hgamh 1-H-GCg*gam0 gamrG*1-Cg)
 ugly1 (* gamrG*1-Cg (- 1 (* squig/gamg 1-Cg)))
 ugly2 (+ gam0 (* G+H (- gamh gam0)))
 ugly3 (* 1-Cg 1-Cg squig/gamg)
;; note: change from - given in paper:
 ugly4 (+ (+ Hgamh (* gam0 (- 1 H))) gamrG)
 )

;; derivative vector:
(defun stablize (x) (min (max 0 x) 1))
(compile 'stablize)

(defun f (vals)
  (let* (
	 (y  (elt vals 0))
	 (yr (elt vals 1))
	 (z  (elt vals 2))
	 (zr (elt vals 3))
	 (yv (elt vals 4))
	 (zv (elt vals 5))

;;	 (y  (stablize y))
;;	 (yr (stablize yr))
;;	 (z  (stablize z))
;;	 (zr (stablize zr))
;;	 (yv (stablize yv))
;;	 (zv (stablize zv))

	 (1-yv-zv (- 1 yv zv))
	 (1-y-yr-z-zr (- 1 y yr z zr))
         )

    (list
     ;; dy/dt
     (- (* mab yv 1-y-yr-z-zr) (* y ugly0))
     ;; dyr/dt
     (- (* y ugly1) (* yr ugly2))
     ;; dz/dt
     (- (* mab zv 1-y-yr-z-zr) (* z ugly4))
     ;; dzr/dt
     (- (* gamrG (+ (* y ugly3) z)) (* zr ugly2))
     ;; dyv/dt
     (- (* ac (+ y yr) 1-yv-zv) (* mu yv))
     ;; dzv/dt
     (- (* ac (+ z zr) 1-yv-zv) (* mu zv))
     )
    )
  )
(compile 'f)

;; Now let's run the model:
;; (def points (rk-f #'f ynot start end num :verbose t))
(def points (rk-f #'f ynot start end num))

(mvsq '(times y yr z zr yv zv) (transpose points))
(let ()
  (lines on)
  (plot times (+ y yr))
  (send my-plot :add-plot-item

	(list 'lines '(20 25) '(.4 .4) 'blue)
	(list "Y+Yr" 30 .4)

	(list 'lines '(20 25) '(.3666 .3666) 'red)
	(list "Z+Zr" 30 .3666)

	(list 'lines '(20 25) '(.3333 .3333) 'green)
	(list "Yv" 30 .3333)

	(list 'lines '(20 25) '(.3 .3) 'black)
	(list "Zv" 30 .3)

	(list 'lines times (+ z zr) 'red)
	(list 'lines times yv 'green)
	(list 'lines times zv 'black)
	)
  )

(format t "~{~a	= ~,8f~%~}"
	(combine (weave '(t y yr z zr yv zv) (final points))))

#|
0 - quinine-thailand
1 - quinine-malawi
2 - mefloquine-thailand
3 - mefloquine-thailand-mutate
4 - artesunate+mefloquine+thailand
5 - atovaquone+mefloquine+thailand

5
t	= 40.000000
y	= 0.000000
yr	= 0.000000
z	= 0.199709
zr	= 0.086541
yv	= 0.000000
zv	= 0.021545

4
t	= 40.000000
y	= 0.000000
yr	= 0.000000
z	= 0.139638
zr	= 0.097248
yv	= 0.000000
zv	= 0.017896

3
t	= 40.000000
y	= 0.000000
yr	= 0.000000
z	= 0.199709
zr	= 0.086541
yv	= 0.000000
zv	= 0.021545

2
t	= 40.000000
y	= 0.000000
yr	= 0.000000
z	= 0.199709
zr	= 0.086541
yv	= 0.000000
zv	= 0.021545

1
t	= 20.000000
y	= 0.990609
yr	= 0.000789
z	= 0.000002
zr	= 0.000000
yv	= 0.432660
zv	= 0.000001

0
t	= 40.000000
y	= 0.000007
yr	= 0.000001
z	= 0.218548
zr	= 0.078106
yv	= 0.000001
zv	= 0.022310

(def crud (apply #'bind-rows (split-list '(
 40.000000
 0.000000
 0.000000
 0.199709
 0.086541
 0.000000
 0.021545
 40.000000
 0.000000
 0.000000
 0.139638
 0.097248
 0.000000
 0.017896
 40.000000
 0.000000
 0.000000
 0.199709
 0.086541
 0.000000
 0.021545
 40.000000
 0.000000
 0.000000
 0.199709
 0.086541
 0.000000
 0.021545
 20.000000
 0.990609
 0.000789
 0.000002
 0.000000
 0.432660
 0.000001
 40.000000
 0.000007
 0.000001
 0.218548
 0.078106
 0.000001
 0.022310
) 7)))

;; (html-table (but-cols crud 0) :fmt "~,6f" :cellpadding 5
(setq names (list 
	     "quinine(thai)"
	     "quinine(malawi)"
	     "mefloquine(thai)"
	     "mefloquine-mutate(thai)"
	     "artesunate+mefloquine(thai)"
	     "atovaquone+mefloquine(thai)"
	     ))
(html-table crud :fmt "~,6f" :cellpadding 5
	    :row-names (reverse names)
	    :column-names '(t y yr z zr yv zv)
	    )


|#

#|
(dotimes (i 100)
	 (def points (rk-f #'f ynot start end num))
	 (setq ynot (rest (final points)))
	 (print ynot)
	 )

(def longtime '(
(0.9905963163286087 7.888750518073082E-4 1.4059197912087896E-5 6.236817598355857E-8 0.43265492429302455 6.1602440195763115E-6) 
(0.9905930317067594 7.888724382728057E-4 1.733468329790954E-5 7.370145504629076E-8 0.43265349018542393 7.594364159017502E-6) 
(0.9905893689608142 7.888695293621181E-4 2.0980416257253417E-5 8.631580255810738E-8 0.4326518940659231 9.190591487731273E-6) 
(0.9905853058202218 7.888662915482603E-4 2.5038245307397936E-5 1.003560142375384E-7 0.4326501173420084 1.0967248539663897E-5) 
(0.9905807235722044 7.888626881643021E-4 2.95547457736684E-5 1.15983249106576E-7 0.43264814060836265 1.2944728493176627E-5) 
(0.9905757239342062 7.888586767841896E-4 3.458176292668389E-5 1.3337687774303162E-7 0.43264593905925763 1.5145728966724523E-5) 
(0.9905701259164746 7.88854212220254E-4 4.01769920989265E-5 1.527365400131717E-7 0.43264348912127903 1.7595512541102117E-5) 
(0.9905638794407178 7.888492431330849E-4 4.640465204774892E-5 1.7428443411080076E-7 0.43264076248117006 2.032219630614049E-5) 
(0.9905569368445164 7.888437123266317E-4 5.333621842093609E-5 1.982678644653547E-7 0.43263772751579904 2.335707430098411E-5) 
(0.9905491961291293 7.888375564807732E-4 6.105124020566212E-5 2.2496207711179804E-7 0.4326343497005502 2.6734976331967728E-5) 
(0.9905405791063078 7.888307048775178E-4 6.96382553628335E-5 2.546734146749919E-7 0.43263059012564364 3.049466716977014E-5) 
(0.9905309970665001 7.888230788215174E-4 7.919580424536435E-5 2.8774282734664034E-7 0.4326264055088155 3.467929084239218E-5) 
(0.9905203404835969 7.888145908024367E-4 8.983355795735029E-5 3.2454977969442156E-7 0.4326217478266385 3.933686501193009E-5) 
(0.9905084861468945 7.888051434344971E-4 1.0167357514355394E-4 3.655165977859612E-7 0.43261656364933293 4.4520831057648324E-5) 
(0.9904952725576107 7.887946285013332E-4 1.1485169717456857E-4 4.111133062358303E-7 0.43261079384694334 5.029066618496818E-5) 
(0.9904805454594396 7.887829253895824E-4 1.295191079138252E-4 4.6186300984552035E-7 0.4326043722624224 5.6712564377803784E-5) 
(0.9904642051933631 7.887698993689245E-4 1.4584407295483774E-4 5.183478810451136E-7 0.43259722428061304 6.386019396603959E-5) 
(0.9904460012944833 7.887554014616203E-4 1.640138376370094E-4 5.812158222923512E-7 0.4325892687762063 7.1815540954988E-5) 
(0.9904257023491105 7.887392655451775E-4 1.8423678886724578E-4 6.511878763053753E-7 0.43258041481669257 8.066984652297198E-5) 
(0.9904031056259678 7.88721306368188E-4 2.0674484349918193E-4 7.290664698495115E-7 0.432570560454301 9.052465013535201E-5) 
(0.9903779997144064 7.887013176753934E-4 2.3179609650096782E-4 8.157445839441378E-7 0.43255959204163197 1.0149294996513204E-4) 
(0.9903500432500892 7.886790706730005E-4 2.5967774091593444E-4 9.122159543576574E-7 0.4325473845639034 1.1370049393998935E-4) 
(0.9903189305596485 7.88654310245609E-4 2.9070938175113943E-4 1.0195864143537404E-6 0.43253379788637214 1.272872147067297E-4) 
(0.9902842963540196 7.886267526802298E-4 3.2524666194002396E-4 1.139086510558384E-6 0.43251867641512715 1.4240882624106158E-4) 
(0.9902457664704065 7.885960820527266E-4 3.6368533270407917E-4 1.2720855302726772E-6 0.43250184657026525 1.5923859870466944E-4) 
(0.9902028589326852 7.885619472833968E-4 4.064657287867749E-4 1.420107099269219E-6 0.43248311610738166 1.7796933250971688E-4) 
(0.9901551224454116 7.885239571468944E-4 4.5407783154025744E-4 1.5848465194109488E-6 0.4324622699549245 1.988155517069396E-4) 
(0.990102014720634 7.884816766296183E-4 5.070667990962682E-4 1.7681900434740365E-6 0.43243906936763726 2.2201594341366557E-4) 
(0.9900428864233753 7.88434622058002E-4 5.660391431471739E-4 1.9722362961438125E-6 0.4324132493510877 2.4783606855869434E-4) 
(0.9899770761082514 7.883822549058928E-4 6.316696585957434E-4 2.1993200751697115E-6 0.43238451425290436 2.7657137317219793E-4) 
(0.9899038304531262 7.883239761943531E-4 7.047090328130911E-4 2.452038797092886E-6 0.4323525354054882 3.085505351453557E-4) 
(0.9898223282360771 7.882591194933795E-4 7.859923554464368E-4 2.7332818704524827E-6 0.4323169469634549 3.4413918089369356E-4) 
(0.9897316350133776 7.881869436473674E-4 8.764485215552177E-4 3.0462633162498932E-6 0.432277342267982 3.8374401336411184E-4) 
(0.9896307063665394 7.881066243287653E-4 9.771107034682964E-4 3.394557982630135E-6 0.4322332690757569 4.278173945513371E-4) 
(0.9895183927590695 7.880172446549162E-4 0.0010891279822260063 3.7821417388870436E-6 0.43218422424646447 4.768624314528586E-4) 
(0.9893934220762777 7.879177849350398E-4 0.0012137782368595645 4.213436072292445E-6 0.43212964816182214 5.314386192858809E-4) 
(0.9892543563463593 7.878071114635884E-4 0.0013524824049705928 4.693357552545921E-6 0.43206891886361903 5.921681009829499E-4) 
(0.98909960098404 7.876839637003858E-4 0.001506820353801563 5.227372669818153E-6 0.432001344769804 6.597426060746559E-4) 
(0.9889273962296606 7.875469401939716E-4 0.0016785484588946829 5.8215586048323865E-6 0.4319261568606304 7.349311402500378E-4) 
(0.9887358317284187 7.873944828239932E-4 0.0018696191308645344 6.482670536442787E-6 0.43184249969397265 8.18588501558317E-4) 
(0.9885226954665565 7.872248605130649E-4 0.0020822021252739995 7.218216158697859E-6 0.4317494237529444 9.116647118043265E-4) 
(0.988285564577696 7.870361494257482E-4 0.0023187085451510095 8.036538104024864E-6 0.43164587344254085 0.0010152154443235442) 
(0.988021739144829 7.868262122297534E-4 0.0025818171040919284 8.94690506874291E-6 0.4315306761051 0.0011304135553771744) 
(0.9877282758528811 7.865926744502289E-4 0.0028745033840375366 9.959612462662869E-6 0.43140252842229126 0.0012585618182583244) 
(0.9874018506548653 7.863328995795902E-4 0.003200071681139582 1.108609349996191E-5 0.43125998380147085 0.0014011069827460367) 
(0.987038761697423 7.860439605700086E-4 0.0035621904576133697 1.2339041665864034E-5 0.431101436352377 0.0015596552707912025) 
(0.9866349585198051 7.857226082602376E-4 0.0039649315628600915 1.3732545576814467E-5 0.4309251028853653 0.0017359894384637435) 
(0.9861858894024275 7.853652379267827E-4 0.004412812724751583 1.52822373240214E-5 0.43072900564685024 0.0019320875500329745) 
(0.9856865311942313 7.849678511843509E-4 0.004910844890574648 1.70054553717229E-5 0.43051095064995787 0.0021501435872249694) 
(0.9851313227755384 7.845260148966896E-4 0.005464583816904746 1.8921423178831794E-5 0.4302685052762935 0.002392590050698713) 
(0.9845140898705557 7.8403481622318E-4 0.00608018647399411 2.105144469195847E-5 0.42999897379504015 0.0026621226966388727) 
(0.9838279753220249 7.834888134371305E-4 0.006764472659821723 2.3419117853754978E-5 0.42969937045635187 0.002961727552496001) 
(0.9830654668348872 7.828819816229593E-4 0.007524992881321387 2.605056720998929E-5 0.42936638875285327 0.0032947103415437804) 
(0.9822181022404652 7.822076559152425E-4 0.008370099822706221 2.8974696729386906E-5 0.4289963724758313 0.003664728486594678) 
(0.9812766834794695 7.814584663298081E-4 0.009309029610904233 3.222346354850352E-5 0.4285852770489325 0.004075825723836982) 
(0.9802309421762928 7.806262713294961E-4 0.010351985288503498 3.583217356698514E-5 0.4281286355493099 0.004532469520911211) 
(0.979069630182384 7.797020833049061E-4 0.011510230226088578 3.983979907223223E-5 0.4276215160119963 0.005039591246168451) 
(0.9777802612315566 7.786759913116387E-4 0.012796184714497266 4.4289318617692663E-5 0.42705848062957663 0.005602629184274781) 
(0.9763491305230994 7.77537076848267E-4 0.01422353171379212 4.922807847763424E-5 0.42643353831421765 0.006227574251480901) 
(0.9747611384982537 7.762733262182095E-4 0.015807326486177258 5.4708174664816036E-5 0.42574009727202156 0.006921018330849858) 
(0.9729996637800971 7.748715382521541E-4 0.017564111945484625 6.078685342187273E-5 0.4249709144932541 0.0076902049386705345) 
(0.97104656272318 7.733172275752509E-4 0.019512040897130396 6.752692703208277E-5 0.4241180415002811 0.008543081801870646) 
(0.968881905059112 7.71594527146937E-4 0.02167099712465088 7.49972007251075E-5 0.42317277228814515 0.009488354878308838) 
(0.966483829231518 7.696860888337776E-4 0.02406271909042493 8.327290444786686E-5 0.4221255889884182 0.010535542976179578) 
(0.9638285914733463 7.675729833747705E-4 0.026710927550105398 9.243612134789681E-5 0.42096610529123085 0.011695031904148487) 
(0.9608902901939752 7.652346057418526E-4 0.029641442003000774 1.0257620292362304E-4 0.41968301609581915 0.012978126999807946) 
(0.9576408410229448 7.626485849896501E-4 0.03288229499344163 1.137901572625291E-4 0.4182640472208599 0.014397102189986613) 
(0.9540498240678355 7.5979070503005E-4 0.03646383029382633 1.2618299421747117E-4 0.4166959125104493 0.015965243629688545) 
(0.9500843459113548 7.566348400264744E-4 0.04041878145715661 1.3986800733427332E-4 0.41496427900754673 0.01769688534128714) 
(0.9457092136967894 7.531529079945142E-4 0.04478233690061565 1.5496696788419722E-4 0.4130537392824918 0.01960743360354434) 
(0.9408865725351037 7.49314855165696E-4 0.04959214800809187 1.7161020328552374E-4 0.41094780631490685 0.021713376931251322) 
(0.9355763934852076 7.450886693415001E-4 0.0548883304767831 1.8993652453282042E-4 0.4086289162845542 0.024032276573299455) 
(0.9297358959980856 7.404404444315708E-4 0.060713354715701114 2.1009296692708275E-4 0.40607847057885904 0.02658273393304918) 
(0.9233203401985263 7.353344894181237E-4 0.06711193818748808 2.322342970595339E-4 0.4032768892612617 0.029384327714325992) 
(0.9162828427402738 7.297335090170069E-4 0.07413079900042047 2.565222423120728E-4 0.40020371438795693 0.03245751651797381) 
(0.9085748837896058 7.235988563379166E-4 0.08181834893235591 2.831243892559732E-4 0.39683774693231 0.035823499185022506) 
(0.9001466653255972 7.168908755560865E-4 0.09022425943125488 3.1221269999684236E-4 0.39315723568408417 0.03950402695054143) 
(0.8909476752596602 7.095693441916457E-4 0.09939890701634385 3.439615940397991E-4 0.38914012001472414 0.04352116056685468) 
(0.8809274085809897 7.015940264561932E-4 0.10939268186218729 3.785455479311209E-4 0.3847643334118039 0.04789696638519716) 
(0.8700360888552752 6.929253479635826E-4 0.12025512672643403 4.1613617370516256E-4 0.38000817509258594 0.05265314668567138) 
(0.8582259846243088 6.835251937870367E-4 0.13203397349010773 4.568987477090297E-4 0.3748507449466072 0.057810599928146175) 
(0.845452193846845 6.733578391821103E-4 0.14477393037010422 5.009881875658789E-4 0.36927245810996456 0.0633889120933696) 
(0.8316742387704827 6.623909990907805E-4 0.1585154012163657 5.485444918207597E-4 0.3632556181543759 0.06940577923002764) 
(0.8168573827489612 6.505969915402798E-4 0.17329300723440522 5.996876999633923E-4 0.3567850568405226 0.07587636996620541) 
(0.8009743119653628 6.379539887298505E-4 0.18913403921285332 6.545124633613651E-4 0.34984881938395573 0.08281263846018797) 
(0.7840066459551323 6.244473271157793E-4 0.20605678998148375 7.130823690847202E-4 0.34243888439093695 0.09022260667483779) 
(0.7659467083152333 6.100708297649213E-4 0.22406891982533908 7.754242017487912E-4 0.3345518879816737 0.09810963844434575) 
(0.7467990754306083 5.948280892973053E-4 0.2431658358996539 8.415223824916843E-4 0.3261898278353444 0.10647173647018715) 
(0.7265821047929789 5.787336449440394E-4 0.26332923286378396 9.113138628805791E-4 0.31736070787007886 0.11530089674617587) 
(0.7053292550588895 5.618139823741804E-4 0.28452587298040916 9.8468378640867E-4 0.30807908537982376 0.12458256009098283) 
(0.6830896728074817 5.441082836431764E-4 0.3067065161089673 0.0010614622510288052 0.2983664850513007 0.1342952047918233) 
(0.6599292452916238 5.256688443662041E-4 0.3298055992007285 0.0011414224782529607 0.2882516215814736 0.14441011396144846) 
(0.6359302344337698 5.065611045604035E-4 0.3537410503323552 0.0012242806959928063 0.2777704194412052 0.15489136334669973) 
(0.6111909249748366 4.86863231631265E-4 0.37841488741310686 0.0013096979394762933 0.266965781228367 0.16569604957150977) 
(0.5858243490203319 4.666652320263263E-4 0.40371424414167856 0.0013972839108732417 0.2558871007398788 0.17677478044865905) 
(0.5599568305153104 4.460675837570042E-4 0.4295132463343437 0.0014866028964623573 0.24458950914987534 0.18807242297083318) 
(0.5337254658114688 4.2517942414395187E-4 0.4556751434952777 0.001577181636715304 0.2331328823443607 0.19952910121772677) 
(0.5072754106345442 4.041163467785227E-4 0.48205508956530746 0.0016685188772570234 0.2215806312092359 0.2110814050441512) 
(0.4807568766990628 3.8299789774201375E-4 0.5085034134361726 0.001760096217933607 0.209998326391984 0.2226637615463461) 
(0.45432150266079835 3.619448864970281E-4 0.53486875940441 0.0018513897881715165 0.1984522256151565 0.23420991433404123) 
(0.4281190831706 3.4107663304945357E-4 0.5610016943731335 0.0019418821739318381 0.1870077620802153 0.24565443039571155) 
(0.4022942521364857 3.2050828757829543E-4 0.5867581601809374 0.0020310740364312186 0.1757280743156197 0.2569341682750486) 
(0.3769831053465924 3.00348350148521E-4 0.6120022295899248 0.0021184948859539403 0.1646726491524728 0.26798964351129745) 
(0.35231074935146595 2.8069649512933037E-4 0.6366091864027222 0.0022037124968556344 0.15389612673245492 0.2787662149100317) 
(0.3283889574993836 2.616417931161537E-4 0.6604676156625201 0.0022863406253648593 0.14344732757779585 0.2892150608771036) 
(0.30531451440977053 2.4326138378887575E-4 0.68348107728814 0.0023660447638447096 0.13336852588384365 0.2992939058204215) 
(0.2831679887350231 2.256196271446792E-4 0.7055687648557577 0.0024425458382994567 0.12369498689737121 0.30896749053200057) 
(0.2620137094574933 2.087677226759516E-4 0.7266669956069386 0.002515621815675629 0.11445475482369798 0.3182077641524528) 
(0.24189937642511353 1.9274377536240841E-4 0.7467280734626813 0.0025851074634850794 0.10566869479238271 0.32699386314503714) 
(0.2228568089608394 1.7757324496398292E-4 0.7657200631885583 0.0026508923858348053 0.09735073841458179 0.3353118585872793)
(0.2049030692327332 1.6326971638108386E-4 0.783626378239504 0.0027129176615657336 0.08950830551463203 0.3431543247175437) 
(0.18804139285889626 1.4983592001293258E-4 0.8004433078177193 0.0027711714659921774 0.0821428677542632 0.350519796509671) 
(0.17226305988789542 1.3726491811247754E-4 0.816179870748462 0.002825683874757954 0.07525059589313507 0.3574120988053629) 
(0.15754873277259154 1.2554139515219038E-4 0.8308551280384188 0.0028765213089743517 0.06882307044117274 0.36383965422694015) 
(0.14387030788866195 1.146429806302063E-4 0.8444973514591547 0.0029237807685517946 0.06284800529027579 0.36981474561092054) 
(0.13119240453193923 1.0454155624779552E-4 0.8571416442000857 0.0029675841906652858 0.05730996601959758 0.37535280997124787) 
(0.11947403290659663 9.520450090544274E-5 0.8688289133177978 0.0030080730318955717 0.05219105146854953 0.3804717481957295) 
(0.10867001045694188 8.659584500758556E-5 0.879604285891651 0.0030454032678928883 0.04747152685691051 0.3851912942733416) 
(0.09873227964658653 7.867731207743142E-5 0.8895159190558015 0.0030797408728279233 0.04313039463498926 0.38953244273598897) 
(0.08961091170282913 7.140923746926466E-5 0.8986124452935064 0.003111257882196479 0.03914589947990256 0.3935169649749227) 
(0.08125554237451268 6.475135498582047E-5 0.9069462295239623 0.0031401288409157696 0.03549595495860553 0.39716691824427214) 
(0.07361551689812258 5.8663465276180814E-5 0.9145658052509846 0.0031665281277798375 0.03215851660866275 0.4005043743670858) 
(0.06664120706779197 5.310597540251107E-5 0.9215216197499452 0.003190627403673881 0.029111871255956833 0.4035510335745622) 
(0.06028421207803277 4.804033480569848E-5 0.9278619660474156 0.003212593837255711 0.026334879246323873 0.4063280353355292) 
(0.05449787867768179 4.342936899008592E-5 0.9336337002804301 0.00323258862085199 0.023807156206596094 0.40885575963610477) 
(0.04923746724761766 3.923752766917326E-5 0.9388793509880158 0.0032507659762711478 0.021509210352468142 0.41115372705398084) 
(0.04446073637730028 3.543105423585828E-5 0.943643425384309 0.003267272212978244 0.019422531588294496 0.4132404151499872) 
(0.04012761883068675 3.197809750185231E-5 0.9479640335928841 0.0032822455048608077 0.01752965720413771 0.4151333121035316) 
(0.03620071759202446 2.884876475210733E-5 0.9518814744135369 0.0032958153874032593 0.015814196619066793 0.41684876740451565) 
(0.03264484223171544 2.6015138391202568E-5 0.9554269965077654 0.0033081030369934063 0.014260845176843324 0.4184021385697892) 
(0.02942752683276076 2.3451251633887863E-5 0.9586364879312651 0.0033192209496089252 0.012855365335271247 0.4198076150830857) 
(0.026518524892789972 2.1133044807437263E-5 0.961538823089833 0.003329273495480446 0.011584567070024204 0.42107840474990144) 
(0.023889898894917647 1.9038297693508916E-5 0.9641598769944395 0.003338357089218549 0.010436269005030946 0.4222267162769611) 
(0.02151602862507275 1.7146548137553133E-5 0.9665273536104884 0.003346560397467695 0.009399252654759365 0.4232637386859278) 
(0.01937332616169489 1.54390029958829E-5 0.9686648267063707 0.003353964912614971 0.008463215267511455 0.42419977411149673) 
(0.017440142434671256 1.3898441824996522E-5 0.9705919377728033 0.0033606453672863595 0.007618716722101481 0.4250442894682587) 
(0.01569676531179574 1.250911701577127E-5 0.9723310142923248 0.003366669968649928 0.006857123537145573 0.42580588168499894) 
(0.014125175670592951 1.1256655048414933E-5 0.9739017891887499 0.003372100992544448 0.006170555896367252 0.42649240645112574) 
(0.012708792619303882 1.0127959100592359E-5 0.9753105686497872 0.00337699553882113 0.005551835543777672 0.4271111823873216) 
(0.011432814373149408 9.11111019404235E-6 0.9765829348336764 0.0033814049674463155 0.004994426999981967 0.4276685965928457) 
))
(plot (* 20 (iseq 1 (length longtime))) (mapcar #'first longtime))

(setq ynot (final longtime))
(dotimes (i 10)
	 (def points (rk-f #'f ynot start end num))
	 (setq ynot (rest (final points)))
	 (print ynot)
	 )

|#
