#| - Sun Apr 19 06:07:47 1998

	This is an example file to accompany
@Book{mendenhall-scheaffer-wackerly,
  author = 	"William Mendenhall and Richard L. Scheaffer and
		 Dennis D. Wackerly",
  title = 	"Mathematical Statistics with Applications",
  publisher = 	"Duxbury Press",
  year = 	"1981",
  address = 	"Boston",
  edition = 	"Second",
}
	I used it way back in undergraduate days, 1983, and liked it.

ael
|#


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Chapter 1: What is Statistics?
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(flet ((quote-it(args)
		(format t "~%")
		(dolist (p (butlast args)) (format t "~a~%" p))
		(format t "~20t -- ~a~%" (final args))))
      (mapcar
       (lambda(x) (quote-it x))
       (list
	'("Statistics is a branch of mathematics dealing with the"
	  "collection, analysis, interpretation, and presentation"
	  "of masses of numerical data."
	  "Webster's New Collegiate")
	'("Statistics is the branch of scientific method which"
	  "deals with the data obtained by counting or measuring"
	  "the properties of populations."
	  "Kendall and Stuart")
	))
      (values)
      )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;		Section 1.2: Characterizing a set of
;;				measurements: graphical methods.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(histogram (normal-rand 100))
(let ()
  (plot normal-dens -3 3)
  (send my-plot :paint-real-poly
	(append
	 '((0 0) (-2 0))
	 (mapcar (lambda(x) (list x (normal-dens x))) (rseq -2 0 33))
	 '((0 0))))
  nil
  )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example 1.2, p. 6
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example 1.2, p. 6")
(def ex1.2 (list 5 0 2 40 27 3 0 22 14 0 4 19 38 2 5 16 0 7 42 15 39 0 2 0 29 26 14
	     0 3 27 32 20 3 0 17 35 29 12 16 6))
(histogram ex1.2)
(histo ex1.2)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example 1.3, p. 6
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example 1.3, p. 6")
(def ex1.3
     (/ (list 74 647 190 269 75 32 999 177 241 196 166 70 242 54 336 359 37 109
	      832 406 455 76 203 570 1248)
	100))
(histo ex1.3)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example 1.4, p. 6
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example 1.4, p. 6")
(def ex1.4
     (/ (list -14 -136 81 -22 -2 94 -4 -27 -106 -45 3 -41 -75 -65 -70 0 -50 -41
	      -403 -207 80 -21 -20 2052 -76 127 191 45 18 63)
	10))
(histo ex1.4)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;		Section 1.3: Characterizing a set of
;;				measurements: numerical methods
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example 1.7, p. 10
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example 1.7, p. 10")
(defun unbiased-variance(b) (/ (sum (square (- b (mean b)))) (1- (length b))))
(defun sample-variance(b) (/ (sum (square (- b (mean b)))) (length b)))
(variance ex1.2)
(unbiased-variance ex1.2)
(sample-variance ex1.2)

(defun check-for-normal-bunches(b)
  (let ((mean (mean b))
	(sd (sqrt (sample-variance b))))
    (format t "~%mean: ~,5f~%  sd: ~,5f~%expecting: .68 .95 1~%" mean sd)
    (mapcar
     (lambda(i)
       (/ (count-if
	   (lambda(x) (and (> x (- mean (* i sd))) (< x (+ mean (* i sd)))))
	   b)
	  (length b)))
     (iseq 1 3))))
(check-for-normal-bunches ex1.2)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example 1.8, p. 10
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example 1.8, p. 10")
(check-for-normal-bunches ex1.3)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example 1.9, p. 10
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example 1.9, p. 10")
(check-for-normal-bunches ex1.4)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example 1.10, p. 10
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example 1.10, p. 10")
(def reduced-ex1.4 (select ex1.4 (where ex1.4 205.2 #'/=)))
(check-for-normal-bunches reduced-ex1.4)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example 1.11, p. 11
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example 1.11, p. 11")
(defun range-of-data(x) (- (max x) (min x)))
(pprint 
 (mapcar
  (lambda(x) (list (sqrt (sample-variance x)) (/ (range-of-data x) 4)))
  (list ex1.2 ex1.3 ex1.4 reduced-ex1.4)
  )
 )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Supplementary exercises, Chapter 1
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example 1.15, p. 15
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example 1.15, p. 15")
(def ex1.15 (list 8 10 4 3 8 5 6 8 7 6 7 7 5 11 7))
(/ (range-of-data ex1.15) 4)
(histo ex1.15)
(check-for-normal-bunches ex1.15)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example 1.16, p. 15
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example 1.16, p. 15")
(def ex1.16 (list 16 224 16 80 96 536 400 80 392 576 128 56 656 224 40 32 358
		  384 256 246 328 464 448 716 304 16 72 8 80 72 56 608 108 194
		  136 224 80 16 424 264 156 216 168 184 552 72 184 240 438 120
		  308 32 272 152 328 480 60 208 340 104 72 168 40 152 360 232
		  40 112 112 288 168 352 56 72 64 40 184 264 96 224 168 168 114
		  280 152 208 160 176))
(/ (range-of-data ex1.16) 4)
(histo ex1.16)
(check-for-normal-bunches ex1.16)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example 1.17, p. 15
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example 1.17, p. 15")
(pprint 
 (mapcar
  (lambda(x) (/ (range-of-data x) (sqrt (sample-variance x))))
  (list (list 1 4 2 1 3 3) ex1.15 ex1.16)
  )
 )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Chapter 2: Probability
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example Figure2.1, p. 19
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Uniform Density")
(plot (lambda(x) (uniform-dens x 0 6)) 0 6)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example example2.2, p. 32
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example example2.2, p. 32")
(def b (iseq 1 5))
(def all-subsets (all-subsets b))
(def 2-subs (select all-subsets (where (mapcar #'length all-subsets) 2)))
(def n (length 2-subs))
(/ (count-if (lambda(x) (and (member 1 x) (or (member 4 x) (member 5 x))))
	     2-subs)
   n)
(/ (count-if (lambda(x) (or (member 1 x) (member 2 x))) 2-subs) n)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example example2.3, p. 32
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example example2.3, p. 32")
;; heads 0, tails 1:
(def b '(0 0 0 1 1 1))
(def tosses (tosses 3))
(/ (count-if (lambda(x) (= (sum x) 1)) tosses) (length tosses))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example example2.4, p. 32
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example example2.4, p. 32")
(def tosses (tosses 2 '(1 1 0)))
(/ (count-if (lambda(x) (> (sum x) 0)) tosses) (length tosses))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Section 2.5: the sample-point method
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.8, p. 35
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.8, p. 35")
;; Suppose that 1 is the minority member:
(def b (iseq 1 4))
(def all-subsets (all-subsets b))
(setq 2-subs (select all-subsets (where (mapcar #'length all-subsets) 2)))
(/ (count-if (lambda(x) (member 1 x)) 2-subs) (length 2-subs))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.9, p. 35
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.9, p. 35")
;; Suppose that 1 and 2 are defective:
(def b (iseq 1 6))
(def all-subsets (all-subsets b))
(setq 2-subs (select all-subsets (where (mapcar #'length all-subsets) 2)))
(def n (length 2-subs))
(/ (count-if (lambda(x) (or (member 1 x) (member 2 x))) 2-subs) n)
(/ (count-if (lambda(x) (and (member 1 x) (member 2 x))) 2-subs) n)

;; Now we can suppose that 1 and 2 are actually good, and get the probabilities
;; as just 1 minus the previous probabilities recorded:
(- 1 (/ (count-if (lambda(x) (and (member 1 x) (member 2 x))) 2-subs) n))
(- 1 (/ (count-if (lambda(x) (or (member 1 x) (member 2 x))) 2-subs) n))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.10, p. 35
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.10, p. 35")
(def b (iseq 2))
(setq tosses (tosses 4 b))
(mapcar (lambda(i)(count-if (lambda(x) (= (sum x) i)) tosses)) (iseq 5))
(/ 2 (length tosses))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.11, p. 35
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.11, p. 35")
;; team i is 0, ii is 1:
(def b '(0 1))
(setq tosses (tosses 4 b))
(setq three-is (select-if tosses (lambda(x) (= (sum x) 1))))
(/ (length three-is) (length tosses))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.12, p. 35
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.12, p. 35")
;; station 1 is -1, 2 is 0, 3 is 1:
(def b '(-1 0 1))
(setq tosses (tosses 3 b))
(setq three-is
      (select-if tosses (lambda(x) (and (= (sum x) 0) (= (sum (abs x)) 2)))))
(/ (length three-is) (length tosses))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;		Section 2.6: Tools for use when counting sample points
;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example example2.5, p. 37
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example example2.5, p. 37")
(def b (iseq 1 6))
(setq tosses (tosses 2 b))
(length tosses)
(remove-duplicates (mapcar #'sum tosses))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example example2.8-9, p. 39
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example example2.8-9, p. 39")
(permutations 10 4)
(permutations 4 4)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example example2.10, p. 40
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example example2.10, p. 40")
(/ (partitions 16 2 4 5 5) (partitions 20 6 4 5 5))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example example2.11-12, p. 42
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example example2.11-12, p. 42")
(combinations 5 2)
(setq na (* (combinations 2 1) (combinations 3 1)))
(setq prob (/ na (combinations 5 2)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.14, p. 44
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.14, p. 44")
(permutations 3 3)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.15, p. 44
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.15, p. 44")
(def b (iseq 1 6))
(setq tosses (tosses 2 b))
(/ (count-if (lambda(x) (= 7 (sum x))) tosses) 36)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.16-19, p. 44
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.16-19, p. 44")
;; 16
(* 5 4 2)
(* 5 4 2 8)
;; 17
(* 9 (^ 10 6))
;; 18
(permutations 10 3)
;; 19
(* 3 3 2)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.20, p. 44
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.20, p. 44")
(permutations 5 3)
3/5 ;; !

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.21-22, p. 44
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.21-22, p. 44")
(/ (* (combinations 3 2) (combinations 5 2)) (combinations 8 4))
(/ (* (combinations 4 1) (combinations 12 1)) (combinations 52 2))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.23-24, p. 44
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.23-24, p. 44")
;; 23
(/ 
 (* (partitions 2 2 0) (combinations 7 1) (partitions 6 3 3))
 (partitions 9 3 3 3))
;; 24
(/ 
 (* (partitions 5 5) (partitions 3 3))
 (partitions 8 5 3))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.26-27, p. 48-49
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.26-27, p. 48-49")
;; 26
(def probAnM (/ 24 100))
(def probA (/ 60 100))
(def probM (/ 40 100))
(= (* probA probM) probAnM)
;; 27
;; probability that plumber A did the job:
(def probA .4)
;; probability of dissatisfaction:
(def probD .1)
;; probability of both A and dissatisfaction:
(def probAnD .05)
;; probability that you'll be dissatified, given that you've used A:
(/ probAnD probA)
(- 1 (/ probAnD probA))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Section 2.8: Two laws of probability
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.30, p. 52
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.30, p. 52")
(def probA (/ 2 10))
(def probB (/ 3 10))
(def probAuB (/ 4 10))
(setq probAnB (- (+ probA probB) probAuB))

(defun prob-comp(x) (- 1 x))
(def probAcomp (prob-comp probA))
(def probBcomp (prob-comp probB))
(setq probAcompuBcomp (prob-comp probAnB))
(setq probAnBcomp (- (+ probAcomp probBcomp) probAcompuBcomp))
(- 1 (/ probAnB probB))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.31, p. 52
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.31, p. 52")
(def probA .5)
(def probB .2)
(def probAnB .1)
(setq probAuB (- (+ probA probB) probAnB))

(def probAcomp (prob-comp probA))
(def probBcomp (prob-comp probB))
(setq probAcompuBcomp (prob-comp probAnB))
(setq probAcompnBcomp (- (+ probAcomp probBcomp) probAcompuBcomp))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.32, p. 52
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.32, p. 52")
(def probA .10)
(def probB .15)
(def probAnB .03)
(setq probAuB (- (+ probA probB) probAnB))

(/ probAnB probAuB)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Section 2.9: calculating the probability of an event: the event
;;			composition method
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.33, p. 59
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.33, p. 59")
(def probs '(.4 .6))
(def rates '(.92 .9))
(setq prob (dot probs rates))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.34, p. 59
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.34, p. 59")
(def probA .02)
(def probB .20)
(def probAnB .01)
(def probAuB (- (+ probA probB) probAnB))
(dot (list probAuB (- 1 probAuB)) (list (/ 1 3) (/ 1 10)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.35-36, p. 59
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.35-36, p. 59")
;; 35
(def probA .02)
(^ probA 3)
(^ (- 1 probA) 3)
;; 36
(* probA (^ (- 1 probA) 3))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.37-42, p. 59-60
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.37-42, p. 59-60")
;; 37
;; Suppose A is innocent, B is guilty; then
(def probA .10)
(def probB .95)
(* probA probB)
(* (- 1 probA) probB)
(* probA (- 1 probB))
(- 1 (* (- 1 probB) (- 1 probA)))
;; 38
(^ .75 4)
;; 39
(- 1 (^ .01 3))
;; 40 a
(* 4 (^ .5 4)) ;; there are four different ways in which the passing car will
	       ;; be chosen
;; 40 b
(^ .5 4)
;; 41
(format t "Answer in the book to 2.41 is wrong (~,4f): five people can be used,
rather than four, as if the first four people fail the test we can take a fifth
without actually typing them - what the hell! Correct answer: ~,4f."
	(- 1 (^ .6 4)) (- 1 (^ .6 5)))
;; 42 a
(*
 (/ (* (combinations 2 1) (combinations 4 2)) (combinations 6 3))
 (/ 1 3)
 )
;; 42 b
(/ (* (combinations 2 2) (combinations 4 2)) (combinations 6 4))
;; 42 c
(/ (* (combinations 1 1) (combinations 3 1)) (combinations 4 2))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Section 2.10: Bayes's rule
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                     Example ex2.43-45, p. 61-62
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun bayes-prob(d pd pnd)
  "
Description: (bayes-prob d pd pnd)

	This is a general function for computing Bayes's probabilities.

	We seek P(D/R), and know

	d	- the probability of D
	pd	- the probability of R given D, P(R/D)
	pnd	- the probability of R given not D, P(R/Dbar)
"
  (let* (
	 (probM d)
	 (probF (- 1 probM))
	 (probN/M pd)
	 (probN/F pnd)
	 (probN (dot (list probM probF) (list probN/M probN/F)))
	 )
    (/ (* probM probN/M) probN)
    )
  )
(title "Example ex2.43, p. 61")
(bayes-prob .6 .7 .3)
(title "Example ex2.44, p. 62")
(bayes-prob .01 .9 .1)
(title "Example ex2.45, p. 62")
(bayes-prob .25 .6 .3)
(title "Example ex2.46, p. 62")
;; We want P(A/F):
(bayes-prob .7 .2 .1)
(title "Example ex2.47, p. 62")
;; We want P(A/S):
(bayes-prob (/ 1 3) .1 .05)
(title "Example ex2.48, p. 62")
;; We want P(B/D):
(bayes-prob .1 .03 .05)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;		Section 2.11: Numerical events and random variables
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.49-51, p. 64
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex2.49-51, p. 64")
;; 49
(* '(1 3 3 1) (mapcar (lambda(i) (* (^ .02 i) (^ .98 (- 3 i)))) (iseq 4)))
;; 50
(/ (mapcar
    (lambda(i) (* (combinations 2 i) (combinations 4 (- 3 i)))) (iseq 3))
   (combinations 6 3))
;; 51 - "simply"(!) generalize 42(a):
(mapcar
 (lambda(i) 
   (*
    (/ (* (combinations 2 1) (combinations 4 (- i 2))) (combinations 6 (1- i)))
    (/ 1 (- 6 (1- i)))))
 ;; takes at least 2, no more than 6, to get the job done:
 (iseq 2 6))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Supplementary Exercises, Chapter 2
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex2.53, p. 68
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Supplementary Exercises, Chapter 2, p. 68-70")
;; 53
(def b '(e1 e2 e3 e4))
(setq all-subsets (all-subsets b))
(length all-subsets) ;; = 2^4
;; 54
(factorial 18)
;; 55
(* 4 (/ (combinations 13 5) (combinations 52 5)))
;; 56
(def probA-B .2)
(def probB-A .3)
(def probA+B .1)
(setq prob-none (- 1 probA-B probB-A probA+B))
(setq prob-at-least-one (- 1 prob-none))
(setq probA+B/B (/ probA+B (+ probB-A probA+B)))
;; 57
(list prob-none (+ probB-A probA-B) probA+B)
;; 59
(def table69a
     (list 4692 1532 201 720 6308 3175 121 1050 24316 16650 463 2090 13868 7888
	   426 1060 8531 4224 534 520 9434 4118 931 500 9566 3652 1340 420 8823
	   3082 1997 270 15223 2717 8123 197))
(def matable (matrix '(9 4) table69a))
(def ages '(0-5 5-14 15-24 25-34 35-44 45-54 55-64 65-74 75-up))
(def column-totals (mapcar #'sum (column-list matable)))
(def row-totals (column 1 matable))
(def total (sum row-totals))
(mprint 
 (bind-rows
  '(Age All-types vehicular falls drownings)
  (bind-columns ages matable)
  '(------ ------ ------ ------ ------)
  (combine 'totals column-totals)))
;; (a) (i)
(/ (sum (rest (rest row-totals))) total)
;; (a) (ii)
(/ (sum (column 2 matable)) total)
;; (a) (iii)
(/ (elt (row 3 matable) 1) (elt (row 3 matable) 0))
;; (a) (iv)
(/ (sum (select (column 4 matable) (iseq 4)))
   (- (sum (select (column 1 matable) (iseq 4)))
      (sum (select (column 2 matable) (iseq 4)))))
(format t "~%Part b: No! We don't have the total population breakdown.~%")

;; 60

(def table69b
     (list 149325 128773 20552 118447 100952 17495 63922 49547 14375 54525
	   51405 3120 30878 27821 3057 53887 48976 4911))
(def matable (matrix '(6 3) table69b))
(def ages '(urban -inside --central --fringe -outside rural))
(def column-totals (+ (row 1 matable) (row 6 matable)))
(def row-totals (column 1 matable))
(def total (elt column-totals 0))
(mprint 
 (bind-rows
  '(area total white other)
  '(------ ------ ------ ------)
  (bind-columns ages matable)
  '(------ ------ ------ ------)
  (combine 'totals column-totals)))
;; (a)
(/ (elt column-totals 1) total)
;; (b)
(/ (elt row-totals 2) total)
;; (c)
(/ (elt (row 4 matable) 1) (elt column-totals 1))
;; (d)
(/ (elt (row 4 matable) 1) (elt (row 4 matable) 0))
;; (e)
(/ (elt (row 5 matable) 2) (elt column-totals 2))

;; 61 (a)
(/ 2 (* 12 11))
;; 61 (b)
(* 2 (/ 2 (* 12 11)))
;; 62
(/ 12 (/ (* 12 11) 2))
;; 63
(/ (* (combinations 1 1) (combinations 2 0) (combinations 5 3))
   (combinations 8 4))
;; 64
(/ (* (combinations 1 1) (combinations 6 2))
   (combinations 7 3))
;; 68 - 1 minus the probability that neither gets the flu:
(setq prob-a-does-not-get-flu (+ .4 (* .6 .1)))
(setq prob-b-does-not-get-flu (+ .4 (* .6 .8)))
(- 1 (* prob-a-does-not-get-flu prob-b-does-not-get-flu))
;; 69 (a)
(def tosses (tosses 6 '(-1 1)))
(/ (count-if (lambda(x) (= (sum x) 0)) tosses) (length tosses))
(* (combinations 6 3) (^ .5 6))
;; 69 (b)
(format
 t
 "~%   my answer: ~,g (not that I'm at all certain!)~%their answer: ~,g~%"
 (/ (* (combinations 10 8) (combinations 10 2)) (combinations 20 10))
 (* 27 (^ .5 10)))
;; 70 (a) ;; four directions, and you have to choose the same direction each
;; time:
(/ 4 (^ 4 8))
;; 70 (b) ;; here's my brute force method!
(def tosses (tosses 4 '(-1 1 -10 10)))
(/ (count-if (lambda(x) (= (sum x) 0)) tosses) (length tosses))
(/ 36 (^ 4 4)) ;; the book gives this answer - presumably they have a better
	       ;; method!

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Chapter 3: Discrete random variables and their probability
;;			distributions 
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example example3.1, p. 75
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example example3.1, p. 75")
(/ (* (combinations 3 0) (combinations 3 2)) (combinations 6 2))
(/ (* (combinations 3 1) (combinations 3 1)) (combinations 6 2))

;; For this sort of problem, we create the distribution as on page 76:
(defun prob-dist(&key (n 6) (a 3) (size 2))
  "
;; two groups totalling n people, choosing size of them at random.

;; Examples:
 (prob-dist)
 (prob-dist :a 1)
 (prob-dist :a 5)
"
  (let ((denom (combinations n size))
	;; the other group
	(b (- n a))
	)
    (mapcar
     (lambda(i)
       (let ((j (- size i)))
       (if (or (> i a) (> j b)) 0
	 (/ (* (combinations a i) (combinations b j)) denom)))
       (iseq (1+ size))))))
(defun prob-dist(&key (n 6) (a 3) (size 2))
  "
;; two groups totalling n people, choosing size of them at random.

;; Examples:
 (prob-dist)
 (prob-dist :a 1)
 (prob-dist :a 5)
"
  (let (
	(denom (combinations n size))
	(b (- n a)) ;; the other group
	)
    (mapcar
     (lambda(i)
       (/ (* (combinations a i) (combinations b (- size i))) denom))
     (iseq (1+ size)))))

(prob-dist)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex3.1, p. 77
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex3.1, p. 77")
(list .2 (- (+ .4 .4) .1) .1)

(title "Example ex3.2, p. 77")
(setq
 ;; Here I get a list of
 ;; (C^2_0*C^2_2)/C^4_2 (both on the second try),
 ;; (C^2_1*C^2_2)/C^4_3 (both on either the second or third try), and
 ;; (C^2_2*C^2_2)/C^4_4 (both on the second, third, or fourth try):
 dist (mapcar 
       (lambda(i) (sum (select (prob-dist :n 4 :a 2 :size i) (iseq 2 i))))
       (iseq 2 4))
 ;; Then I remove repeats:
 dist (- dist (combine 0 (butlast dist))))

(title "Example ex3.3, p. 77")
;; We expand out (4/5+1/5)(4/5+1/5) to get the probabilities of open or closed
;; on the series gate.
(sum
 (list
  (* 1/5 9/25)
  (+ (* 1/5 16/25) (* 4/5 9/25))
  (* 4/5 16/25)))

(* 1.0 '(9/125 52/125 64/125))

(title "Example ex3.4, p. 77")
(mapcar (lambda(i) (prob-of-getting-some-right-by-guessing i 3))
	(iseq 0 3))

(title "Example ex3.5a, p. 78")
(setq
 ;; Here I get a list of the probabilities (in descending order for 5, 4, 3,
 ;; and 2:
 ;; (C^1_1*C^4_1)/C^5_2
 ;; (C^1_1*C^3_1*C^1_0)/C^5_2
 ;; (C^1_1*C^2_1*C^2_0)/C^5_2
 ;; (C^1_1*C^1_1*C^3_0)/C^5_2
 dist (/ (mapcar (lambda(i) (combinations i 1)) (iseq 4 1))
	 (combinations 5 2)))
 
(title "Example ex3.5b, p. 78")
;; Sum ranges from 3 to 9.
(def sums (mapcar #'sum (all-pairs (iseq 1 5))))
(def range (sort-data (remove-duplicates sums)))
(pprint (transpose (list range 
			 (/
			  (mapcar (lambda(i) (count i sums)) range)
			  (length sums)
			  )
			 )
		   )
	)				  


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Section 3.3: The Binomial Probability Distribution
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#| - ael - Fri May 1 16:37:10 1998

	The hypergeometric distribution is the appropriate one to use when the
sample size is large relative to the population. (p. 80)

 - lea - |#

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example example3.4, p. 81
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example 3.4, p. 81")
;; "At least one defective" = "one or more defective"
(sum (mapcar (lambda(k) (binomial-pmf k 5 .05)) (iseq 1 5)))

(new-plot)
(title "Binomial Probabilities")
(lines off)
(plot (mapcar (lambda(k) (binomial-pmf k 10 .1)) (iseq 0 10)))
(plot (mapcar (lambda(k) (binomial-pmf k 10 .5)) (iseq 0 10)))
(plot (mapcar (lambda(k) (binomial-pmf k 20 .5)) (iseq 0 20)))

(title "Example 3.5, p. 83")
(+ (binomial-pmf 9 10 .3) (binomial-pmf 10 10 .3))

(title "Example 3.6, p. 83")
;; Either add up,
(sum (mapcar (lambda(k) (binomial-pmf k 20 .05)) (iseq 3 20)))
;; or subtract off:
(- 1 (sum (mapcar (lambda(k) (binomial-pmf k 20 .05)) (iseq 0 2))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                     Exercises 3.6-3.16, p. 84-85
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Exercise 3.6, p. 84")
(binomial-pmf 2 4 .8)
(- 1 (sum (mapcar (lambda(k) (binomial-pmf k 4 .8)) (iseq 0 1))))

(title "Exercise 3.7, p. 84")
(binomial-pmf 14 20 .8)
(sum (mapcar (lambda(k) (binomial-pmf k 20 .8)) (iseq 10 20)))
(sum (mapcar (lambda(k) (binomial-pmf k 20 .8)) (iseq 14 18)))
(sum (mapcar (lambda(k) (binomial-pmf k 20 .8)) (iseq 0 16)))

(title "Exercise 3.8, p. 84")
(sum (mapcar (lambda(k) (binomial-pmf k 15 .2)) (iseq 10 15)))

(title "Exercise 3.9, p. 84")
(binomial-pmf 5 5 .8)
(binomial-pmf 4 5 .6)
(sum (mapcar (lambda(k) (binomial-pmf k 5 .3)) (iseq 0 1)))

(title "Exercise 3.10, p. 85")
(print "Essentially binomial.")
(sum (mapcar (lambda(k) (binomial-pmf k 4 .6)) (iseq 3 4)))

(title "Exercise 3.11, p. 85")
(print "Essentially binomial.")
(setq dist (mapcar (lambda(k) (binomial-pmf k 3 .8)) (iseq 4)))
(- 1 (first dist))

(title "Exercise 3.12, p. 85")
(new-plot)
(title "Binomial Probabilities: n=5")
(lines off)
(plot (mapcar (lambda(k) (binomial-pmf k 5 .1)) (iseq 0 5)))
(plot (mapcar (lambda(k) (binomial-pmf k 5 .5)) (iseq 0 5)))
(plot (mapcar (lambda(k) (binomial-pmf k 5 .9)) (iseq 0 5)))

(title "Exercise 3.13, p. 85")
(new-plot)
(title "Binomial Probabilities: n=20;p=.5")
(lines off)
(plot (mapcar (lambda(k) (binomial-pmf k 20 .5)) (iseq 0 20)))

(title "Exercise 3.14, p. 85")
(binomial-pmf 4 5 .9)
(sum (mapcar (lambda(k) (binomial-pmf k 5 .9)) (iseq 1 5)))

(title "Exercise 3.15, p. 85")
(binomial-pmf 4 4 .99)
(sum (mapcar (lambda(k) (binomial-pmf k 4 .99)) (iseq 3 4)))

(title "Exercise 3.16, p. 85")
(sum (mapcar (lambda(k) (binomial-pmf k 15 .5)) (iseq 10 15)))
(sum (mapcar (lambda(k) (binomial-pmf k 15 .5))
	     (combine (iseq 0 5) (iseq 10 15))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Section 3.4: The Geometric Probability Distribution
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				Exercises 3.17-3.23, p. 87-88
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Exercise 3.17, p. 87")
(geometric-pmf 4 .4)

(title "Exercise 3.18, p. 88")
(geometric-pmf 3 .2)
(- 1 (sum (geometric-pmf (iseq 1 10) .2)))

(title "Exercise 3.20, p. 88")
(- 1 (geometric-pmf 1 .5)) ;; 1/2!

(title "Exercise 3.21, p. 88")
(geometric-pmf 3 .1)
(- 1 (sum (geometric-pmf (iseq 1 2) .1)))

(title "Exercise 3.22, p. 88")
(geometric-pmf 5 .6)
(- 1 (sum (geometric-pmf (iseq 1 4) .6)))

(title "Exercise 3.23, p. 88")
(title "Geometric Probabilities: p=.06")
(lines off)
(plot (geometric-pmf (iseq 1 20) .06))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Section 3.5: The Hypergeometric probability distribution
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Exercises 3.24-3.30, pp. 91-92
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(title "Exercise 3.24, p. 91")
(hypergeometric-pmf 3 10 3 5)

(title "Exercise 3.25, p. 91")
(hypergeometric-pmf 5 10 5 6)

(title "Exercise 3.26, p. 91")
(setq dist (hypergeometric-pmf (iseq 0 3) 6 3 2))
(second dist)
(sum (rest dist))
(sum (select dist (iseq 2)))

(title "Exercise 3.27, p. 91")
(sum (hypergeometric-pmf (iseq 2) 20 6 8))
(print "not outrageously low.")

(title "Exercise 3.28, p. 91")
(def dist (hypergeometric-pmf (iseq 3) 6 3 2))
;; Two different histograms:
(send (plot (iseq 0 3) dist) :range '(0 1) '(-1 0) '(3 1))
(send my-plot :points-to-histogram (iseq 0 3) dist)
;; second:
(histo (combine
	(mapcar
	 (lambda(i) (repeat i (floor (* 50 (select dist i)))))
	 (iseq 3)))
       :my-cutpoints (- (iseq 4) .5))

(title "Exercise 3.29, p. 92")
(histo (hypergeometric-rand 100 6 3 2) :my-cutpoints (- (iseq 4) .5))

(title "Exercise 3.30, p. 92")
(lines off)
(plot (iseq 6 20)
      (mapcar (lambda(n) (hypergeometric-pmf 1 n 3 4)) (iseq 6 20)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Section 3.6: The Poisson probability distribution
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Poisson distribution: lambda=.9")
(draw-color 'blue)
(plot
 (iseq 10) 
 (mapcar (lambda(i) (poisson-pmf i .9)) (iseq 10))
 )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                                 Example ex3.11, p. 94
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex3.11, p. 94")
(poisson-pmf (iseq 0 2) 1)
(- 1 (poisson-pmf 0 1))

(title "Example ex3.12, p. 95")
(^ (poisson-pmf 0 5) 10) ;; "very, very small."


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Exercises 3.31-39, pp. 95-96
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Exercise 3.31, p. 95")
(sum (poisson-pmf (iseq 0 3) 7))
(- 1 (sum (poisson-pmf (iseq 0 1) 7)))
(poisson-pmf 5 7)

(title "Exercise 3.32, p. 95")
(sum (poisson-pmf (iseq 0 4) 4))

(title "Exercise 3.33, p. 95")
(sum (mapcar
      (lambda(i) (* (poisson-pmf i 3) (poisson-pmf (- 3 i) 4)))
      (iseq 0 3)))
	
(title "Exercise 3.34, p. 95")
(sum (poisson-pmf (iseq 0 1) 1.5))
	
(title "Exercise 3.35, p. 95")
(- 1 (sum (poisson-pmf (iseq 0 3) 1)))

(title "Exercise 3.36, p. 96")
(- 1 (binomial-pmf 0 10 (- 1 (sum (poisson-pmf (iseq 0 3) 1)))))

(title "Exercise 3.37, p. 96")
(lines off)
(point-labels (mapcar #'num-to-string (iseq 5)))
(plot (binomial-pmf (iseq 0 4) 20 .05) (poisson-pmf (iseq 0 4) 1))

(title "Exercise 3.38, p. 96")
(- 1 (binomial-pmf 0 100 .03))
(- 1 (poisson-pmf 0 3))

(title "Exercise 3.39, p. 96")
(- 1 (sum (binomial-pmf (iseq 0 3) 30 .2)))
(- 1 (sum (poisson-pmf (iseq 0 3) 6)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Section 3.7: The expected value of a random variable
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(latex-table
 (matrix '(4 3) '(BINOMIAL
		  np npq
		  GEOMETRIC
		  1/p q/p^2
		  HYPERGEOMETRIC
		  "nr/N" "nr(N-r)(N-n)/(N^2(N-1))"
		  POISSON
		  lambda lambda)))
		    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Example ex3.15, p. 102
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Example ex3.15, p. 102")
(- 1 (sum (poisson-pmf (iseq 0 5) 3)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Exercises 3.40-50, p. 104-105
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Exercise 3.40, p. 104")
(setq y (iseq 1 4))
(setq p (* .1 (reverse y)))
(setq mean (sum (* y p)))
(setq mean1/y (sum (* (/ y) p)))
(setq meany^2-1 (- (sum (* (^ y 2) p)) 1))
(setq var (sum (* (^ (- y mean) 2) p)))

(title "Exercise 3.41, p. 104")
(setq y (iseq 1 6))
(setq p (repeat (/ 6) 6))
(setq mean (sum (* y p)))
(setq var (sum (* (^ (- y mean) 2) p)))

(title "Exercise 3.42, p. 104")
(setq y (combine (repeat -4 9) 15 15 5 5))
(setq p (repeat (/ 13) 13))
(setq mean (sum (* y p)))
(setq var (sum (* (^ (- y mean) 2) p)))

(title "Exercise 3.43, p. 104")
(setq mean (* 10 .1))
(setq var (* 10 .1 .9))

(title "Exercise 3.44, p. 104")
(setq mean (+ 20000 (* 30000 (* 10 .1)) (* 15000 (* 10 .9))))

(title "Exercise 3.45, p. 104")
(setq p (+ (* 1/3 (list .9 .1 0)) (* 2/3 (list .81 .18 .01))))
(setq y (list 0 50000 100000))
(setq mean (sum (* p y)))
(setq sd (sqrt (sum (* (^ (- y mean) 2) p))))

(title "Exercise 3.46, p. 104")
(setq p (list .001 .01 .989))
(setq y (list 20000 10000 0))
(setq mean (sum (* p y)))

(title "Exercise 3.47, p. 104")
(setq y (list 2 3 4))
(setq cost (list 12 14 16))
(setq
 dist (mapcar 
       (lambda(i) (sum (select (prob-dist :n 4 :a 2 :size i) (iseq 2 i))))
       (iseq 2 4))
 dist (- dist (combine 0 (butlast dist))))
;; This is the answer given by the book, but it's not correct: for example, in
;; the event that we test the first two and find them good, the actual cost is
;; $4 for the first two tests, then $8 for fixing the last two (which we can
;; deduce are bad).
(sum (* cost dist))
;; The "smart" tester gets away with
(setq cost (list 12 14 12))
(sum (* cost dist))

(title "Exercise 3.48, p. 105")
(setq y (iseq 0 3))
(setq p (hypergeometric-pmf y 6 3 4))
(sum (* y p))
(/ (* 3 4) 6)

(title "Exercise 3.49, p. 105")
(setq n 4)
(setq p .1)
(setq q (- 1 p))
(setq ec (+ (* 3 (+ (* n p q) (square (* n p))))
	    (* n p)
	    2))

(title "Exercise 3.50, p. 105")
(setq lambda 2)
(setq ec (- 50
	    (* 2 lambda)
	    (+ (square lambda) lambda)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;		Exercises, 3.51-3.56, p. 108
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Exercise 3.52, p. 108")
(print "geometric: mean 1/p=1/(1/2)=2")

(title "Exercise 3.53, p. 108")
(print "again, geometric: mean 1/p=1/(4/10)=10/4=2.5. 
One person wouldn't be enough; two people might work with a 40% probability,
and three should certainly be enough. Thus 2.5 seems a reasonable guess.
")

(title "Exercise 3.53, p. 108")
(setq y (iseq 0 4))
;; a
(setq p (binomial-pmf y 4 1/3))
;; b
(sum (select p (iseq 3 4)))
;; c
(sum (* y p))
(* 4 1/3)
;; d
(* 4 1/3 2/3)

(title "Exercise 3.56, p. 108")
(print "poisson is extremely doubtful!")
(print "\sum_0^\infty 100(1/2)^y \lambda^y e^{-\lambda}/y!")


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;		Moment-generating functions
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;		Exercises, 3.57-3.64, p. 113
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(title "Exercise 3.58, p. 113")

#| - ael - Sun May 24 20:27:36 1998

;; The general rules are established in macrules.lsp; I'm adding to them.
(func m(c) (a*(exp c)+b)^n) ;; a is p, b is q, and x is t.
;; note: the variable names have to be different than the following,
;;    x y z m n o p q r s t u v w,
;; because of the definition of variable-p. This m function is the generating
;; function of a binomial with n trials and probability p: I've replaced p
;; and q by a and b, as I wanted to add the special rules to the general
;; simplification rules (defined in file macrules.lsp).
(def
 *simplification-rules*
 (append
  (mapcar
   #'simp-rule
   '((a + b = 1)
     ((- b) + 1 = a)
     ((- a) + 1 = b)))
  *simplification-rules*))

;; derivatives of the generating function, evaluated at 0, give us the
;; moments of the binomial distribution:
(def *variable-substitution* '((c 0)))
(simplifier (diff m c))
;; (N * P)
;; = np
(simplifier (diff-n m c 2))
;; ((N * (Q * P)) + ((N * P) ^ 2))
;; = npq + (np)^2
;; => v(y) = npq

(title "Exercise 3.60, p. 113")
(func m(c) a*(exp c)/(1-(b*(exp c))))
(simplifier (diff m c))
;; (((A ^ 2) - (A * (- B))) / (A ^ 2))
;; = (a*(a+b))/a^2 = 1/a
(simplifier (diff-n m c 2))




