#| - ael - Sat Apr 25 23:09:17 1998

	I'm trying to see what the trouble is with my prototypes. The problem
has been that I'm getting errors of the sort 
I've defined stuff with its own slots, and I've defined sub-stuff with some
overlapping slots.

			Things that I've learned

1) adding a slot (using :add-slot) does not provide it to the instances. In the
terms of the help for defproto, the added slot is for the class variables,
rather than the instance variables.

DEFPROTO                                                          [function-doc]
Syntax (defproto name &optional ivars cvars (parent *object*) doc)
Makes a new object prototype with instance variables IVARS, 'class'
variables CVARS and parents PARENT. PARENT can be a single object or
a list of objects. IVARS and CVARS must be lists.

	(defproto stuff '(a b d f) '(c e) *object*)
	(send stuff :own-slots)
	(send stuff :slot-value 'instance-slots)
	(send stuff :add-slot 'crapola pi)
	(send stuff :own-slots)
	(send stuff :slot-value 'instance-slots)

	(def crap (send stuff :new))
	(send crap :own-slots)
	(send crap :slot-value 'instance-slots)
	(send crap :slot-value 'crapola)
	;; if we give crap a slot with the same name as the slot of stuff, then
	;; crap can modify its slot; but this doesn't affect the value of
	;; stuff's slot, of course:
	(send crap :add-slot 'c pi)
	(send stuff :slot-value 'c) ;; still nil
	(send crap :slot-value 'c)
	;; But crap cannot modify either slots e or crapola:
	;; (send crap :slot-value 'e (exp 1))
	;; Error: object does not own slot - E
	;; Happened in: #<Byte-Code-Closure: #81d2cb8>
	;; (send crap :slot-value 'crapola (exp 1))
	;; Error: object does not own slot - CRAPOLA
	;; Happened in: #<Byte-Code-Closure: #81d2cb8>

 - lea - |#


*object*
(send *object* :own-slots)
(send *object* :slot-value 'proto-name)
(send *object* :slot-value 'instance-slots)

(setf x (send *object* :new))
(send x :own-slots)
(send x :slot-value 'proto-name)
(send x :slot-value 'instance-slots)

(send x :own-slots)
(send x :add-slot 'data (normal-rand 50))
(send x :add-slot 'title)
(send x :own-slots)
(send x :slot-value 'data)
(send x :slot-value 'title)
(send x :slot-value 'title "a data set")
(send x :slot-value 'title)
(send x :slot-value 'proto-name)
(send x :slot-names)

(send x :has-slot 'title)
(send x :has-slot 'x)
(send x :has-slot 'proto-name)
(send x :has-slot 'title :own t)
(send x :has-slot 'proto-name :own t)

;; (send x :slot-value 'proto-name 'new-name)
;; Error: object does not own slot - PROTO-NAME
;; Happened in: #<Byte-Code-Closure: #81d2cb8>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			Top proto stuff:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defproto stuff '(a b d f) '(c e) *object*)
(send stuff :own-slots)
(send stuff :slot-value 'proto-name)
(send stuff :slot-value 'instance-slots)
(send stuff :slot-value 'c pi)
(send stuff :slot-value 'e (exp 1))
(send stuff :add-slot 'crapola)
(send stuff :slot-value 'instance-slots)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			sub-stuff, child proto of stuff:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defproto sub-stuff '(b c) nil stuff)
(send sub-stuff :own-slots)
(send sub-stuff :slot-value 'proto-name)
(send sub-stuff :slot-value 'instance-slots)
(show sub-stuff)
(send sub-stuff :slot-value 'c)

(send sub-stuff :slot-value 'a 'a)
(send sub-stuff :slot-value 'b 'b)
(send sub-stuff :slot-value 'c 'c)
(send sub-stuff :has-slot 'a :own t)
(send sub-stuff :has-slot 'e :own t)
(send sub-stuff :has-slot 'f :own t)

(defmeth sub-stuff :trial (&optional new)
  (when
   new
   (setf (slot-value 'a) new)
   (setf (slot-value 'b) new)
   (setf (slot-value 'c) new)
   (setf (slot-value 'd) new)
   (if (send self :has-slot 'e :own t) (setf (slot-value 'e) new))
   (setf (slot-value 'f) new)
   ))
(send sub-stuff :trial (list 1))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;		crap, instance of sub-stuff:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(def crap (send sub-stuff :new))
(send crap :own-slots)
(send crap :slot-value 'proto-name)
(send crap :slot-value 'instance-slots)
(send crap :slot-value 'f (exp 2))
;; (send crap :slot-value 'e (exp 1))
;; Okay, that one does it. I get the dreaded
;; Error: object does not own slot - E
;; Happened in: #<Byte-Code-Closure: #81d2cb8>


(send crap :trial (list 2))
(send crap :slot-value 'a 'new-name)
(send crap :has-slot 'a :own t)
(show crap)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;		Everything above seems to be working fine.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(plot sin)
(sort-symbols (send my-plot :own-slots))
(send my-plot :slot-value 'proto-name)
(sort-symbols (send my-plot :slot-value 'instance-slots))

(def my-plot (spin-plot (list (rand.u 10) (rand.u 10) (rand.u 10))))
(sort-symbols (send my-plot :own-slots))
(send my-plot :slot-value 'proto-name)
(sort-symbols (send my-plot :slot-value 'instance-slots))

(defmeth graph-proto :ouch () (print "Ouch!"))
(send (plot-lines (rand.u 10) (rand.u 10)) :ouch)



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			trying to screw up a good thing:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(let ((new-slots '(proteins gums)))
  (mapcar
   (lambda(x)
     (mapcar (lambda(y) (send x :add-slot y)) new-slots)
     (send x :slot-value 'instance-slots
	   (combine (send x :slot-value 'instance-slots) new-slots)))
   (list graph-proto))
  nil)
  
(defproto p-proto nil nil graph-proto)
(defproto plastic-proto nil nil scatterplot-proto)

(let ()
  (mapcar
   (lambda(x) (print (sort-symbols (remove-dups x))) (terpri))
   (list 
    (send graph-proto :own-slots)
    (send graph-proto :class-slots)
    
    (send scatterplot-proto :own-slots)
    (send scatterplot-proto :class-slots)
    
    (send p-proto :own-slots)
    (send p-proto :class-slots)

    (send plastic-proto :own-slots)
    (send plastic-proto :class-slots)
    ))
  nil
  )

;; (send plastic-proto :slot-value 'gums 3)
;; results in the usual error
(sort-symbols (send plastic-proto :slot-value 'instance-slots))

(send plastic-proto :become graph-proto)
(sort-symbols (send plastic-proto :slot-value 'instance-slots))

(send plastic-proto :slot-value 'gums 3)
(send plastic-proto :slot-value 'gums)

;; this doesn't work: (send (plot sin) :become graph-proto)

