(defun pattern (n length lenmin divisions x y &key plot (type 'dot))
  "
;; Documentation:
	n
	length
	lenmin
	divisions
	x y
	
;; Examples:
 (def my-plot (plot-points '(1 0) '(0 1) :color 'black :symbol 'dot))
 (title \"4\")
 (pattern 5 .3 .1 4 .5 .5 :plot my-plot :type 'diamond)

 (title \"Serpinski triangles:\")
 (pattern 3 .3 .025 3 .5 .5 :type 'dot4)
 (title \"2\")
 (pattern 10 .3 .05 3 .5 .5 :type 'disk)
 (title \"3\")
 (pattern 3 .3 .01 2 .5 .5 :type 'dot1)
"
  (if (not plot)
      (setq plot (plot-points '(1 0) '(0 1) :color 'black :symbol 'dot)
	    ;; plot (send plot :range '(0 1) '(0 0) '(1 1))
	    ;; plot (send plot :show-window t)
	    ))
  (send plot :add-points (list x) (list y) :symbol type)
  (dotimes (i n)
	   (def arg (* (* 2 pi) (/ (float i) n)))
	   (def rotate (* length (exp (* #c(0 1) arg))))
	   (def xreal (+ x (realpart rotate)))
	   (def ximag (+ y (imagpart rotate)))
	   (send plot :add-points (list xreal) (list ximag) :symbol type)
	   (def newlength (/ length divisions))
	   (if (> length lenmin)
	       (pattern
		n newlength lenmin divisions xreal ximag :plot plot :type type)
	     )
	   )
  (def newlength (/ length divisions))
  (if (> length lenmin)
      (pattern n newlength lenmin divisions x y :plot plot :type type))
  ) 
