#| - Fri Mar 6 08:10:01 1998

	This version of nltsvd is superseded by changes ("improvements", I
hope!) in the design of the algorithm.
|#
(require "tensor")
(require "nonnewt1")
#| - Wed Mar 4 22:54:04 1998

Todo: Search for the word "todo".

	Just thought I'd drop myself a line, to remind tomorrow's Andy about
what today's Andy is up to. There's some success, and some failure.

	I've got the first sv's of a matrix case, but the second one fails
me. I'm going to have to get that fixed first.

	The problem may be in how I'm handling successive rank-one tensors: I'm
reducing the number of Lagrange multipliers associated from the pair for the
two vectors in the matrix case, to one single, and using t-mult. I'm very
suspicious of how I'm using t-mult.

	The results of the first singular tensor don't agree with what is
produced by optimize-rank-one-over-tensor, so I think that we're in trouble
there too, even in the first case. Again I would start by assuming problems
with t-mult.

|#
#| - Thu Mar 5 10:20:54 1998
	Okay, I've got the second SV's to spit out, but I've got to go after
more schmidt stuff than I'd anticipated (I have to increase the number searched
for to the product of all the dimensions, since I'm not using
bi-orthogonality).

	The tensor case is still not working as I'd hoped, but I'm not
surprised. Still some bugs to work out, I'm sure.

	Discovered that optimize-rank-one-over-tensor can also find a minimum.

|#
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Now let's create a function that finds the TSVD in general:
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				nltsvd
;;
(defun nltsvd(A &key verbose (eps 1e-12) (maxits 100))
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			nltsvd Doc:
;;
;; Author: Andy Long
;; Created: Fri Feb 27 10:35:52 1998
;;
;; Description/Arguments: nltsvd
  
;; Arguments: A &key verbose (eps 1e-12) (maxits 100)

;; Returns: the tsvd of a tensor, obtained using newton's method to solve for a
   root of a system of non-linear equations.

	DOESN'T WORK YET, but it's coming!

;; Notes: Stemming from my DESS class at the IMSP, and looking toward a method
   that generalizes for the TSVD (Tensor SVD).

;; See Also: non-linear-system-root

;; Examples:
 (def A #2a((2 4 3)(5 6 2)))
 (def A #2a((2 4)(5 6)))
 (nltsvd A)

 ;; (def A #2a((2 4 -1)(5 6 2)(1 2 1)))
 ;; (nltsvd A :verbose 2)

 (def st1 (vectors-to-tensor '(1 1) '(-1 1) '(-4 6)))
 (def st2 (vectors-to-tensor '(-1 1) '(1 1) '(3 2)))
 (def A (+ st1 st2))
 (send (new tensor (size A) A) :norm)
 (send (new tensor (size st1) st1) :norm)
 (send (new tensor (size st2) st2) :norm)

 (def crap (optimize-rank-one-over-tensor A))
 ;; todo: just discovered that optimize-rank-one-over-tensor can also find a
 ;; minimum! I thought it was going to find a maximum only, oops!
 (t-mult (apply #'vectors-to-tensor (first crap)) A (iseq 3) (iseq 3))

 (nltsvd A :maxits 1000)
"
  (let* (
	 (A (if (tensorp A) (send A :elements) A))
	 (size (size A))

	 (subsets (mapcar #'iseq size))
	 (subsets (+ subsets (combine 0 (butlast (cumsum size)))))

	 (numdims (length size))
	 (numdims-seq (iseq numdims))
	 (numdims-1-seq (iseq (1- numdims)))
	 (numdims-2-seq (iseq (- numdims 2)))

	 ;; The SVD should have at most this many schmidt-tuples
;;todo	 (dim (apply #'* (butlast (sort-data size))))
	 (dim (apply #'* size))

	 ;; We start with just the lagrange multipliers corresponding to the
	 ;; unit length of the vectors: later we'll add one for each singular
	 ;; vector:
	 (lagrange-multipliers numdims)

	 schmidt-tuples sts lambdas
	 order
	 )
    (dotimes
     (i dim)
     (if verbose (print (list "in dotimes" i)))
     (flet (
	    (funcs(z)
		  (if verbose (print "in funcs"))
		  (let* (
			 (uvs
			  (mapcar (lambda(ubunch)(select z ubunch)) subsets))
			 (uvs-tensor (apply #'vectors-to-tensor uvs))
			 (ten (apply #'vectors-to-tensor uvs))
			 (lambda-norms (select-from-end z numdims-seq))
			 (crap
			  (if verbose (print
			   (list 
			    uvs
			    sts
			    (if (/= i 0)
				(mapcar
				 (lambda(st) (- (apply #'* (mapcar #'sum (* uvs st)))))
				 sts))))))
			 (result
			  (combine
			   (-
			    (mapcar
			     (lambda(i)
			       (let ((but-i (remove i numdims-seq)))
				 (t-mult 
				  (apply #'vectors-to-tensor (select uvs but-i))
				  A
				  numdims-1-seq
				  but-i)))
			     numdims-seq)
			    (mapcar (lambda(lam v) (* 2 lam v)) lambda-norms uvs)
			    )
			   (if (= i 0)
			       (mapcar (lambda(x) (- 1 (dot x x))) uvs)
			     (combine
			      (mapcar
			       ;; I'm pretty sure that this is the same as the
			       ;; tensor inner product, but I should probably
			       ;; confirm with a test. todo
			       (lambda(st)
				 #| - Thu Mar 5 09:51:49 1998
				 ;; New mystery: I've checked that check and
				 ;; result give the same result, up to e-16 or
				 ;; so. And yet result causes an error
				 (let (
				       (result
					(apply #'* (mapcar #'sum (* uvs st))))
				       ;; note that I changed the sign, both
				       ;; here and in jack.
				       (check
				        (sum (t* uvs-tensor
						 (apply #'vectors-to-tensor st))))
				       )
				   (print (list 'hi result check))
				   (setq result check)
				   result
				   )
|#
				 (sum (t* uvs-tensor
					  (apply #'vectors-to-tensor st)))
				 )
			       sts)
			      (mapcar (lambda(x) (- 1 (dot x x))) uvs)
			      )
			     )
			   )
			  )
			 )
;;		    (print result)
		    (if verbose (print "leaving funcs"))
		    result
		    ))
	    (jack (z)
		  (if verbose (print "in jack"))
		  (let* (
			 (uvs
			  (mapcar (lambda(ubunch)(select z ubunch)) subsets))
			 (ten (apply #'vectors-to-tensor uvs))
			 (lambda-norms (select-from-end z numdims-seq))

			 ;; jack will be a small "gross" matrix containing the
			 ;; minimum necessary to later use combine-matrices:
			 (jack (+ numdims 1))
			 (jack (make-array (list jack jack)))
			 )
		    ;; The next two take care of the diagonal:
		    (dotimes
		     (i numdims)
		     (setf
		      (aref jack i i)
		      (* -2 (elt lambda-norms i) (id (elt size i))))
		     )
		    (setf
		     (aref jack numdims numdims)
		     (zeros lagrange-multipliers lagrange-multipliers))

		    ;; Now for the a-matrices:
		    (dotimes
		     (i (1- numdims))
		     (let ((keepers (remove i numdims-seq)))
		       (dolist
			(j (iseq (1+ i) (1- numdims)))
			(let ((keepers (remove j keepers)))
			  (if keepers
			      (setf
			       (aref jack i j)
			       (t-mult 
				(apply #'vectors-to-tensor (select uvs keepers))
				A
				numdims-2-seq
				keepers)
			       (aref jack j i)
			       (transpose (aref jack i j))
			       )
			    ;; Otherwise, just matrix case!
			    (let ()
			      (setf (aref jack i j) A)
			      (setf (aref jack j i) (transpose A))
			      )
			    )
			  )
			)
		       )
		     )

		    ;; Now for the lagrange multiplier stuff:
		    (dotimes
		     (i numdims)
		     (let* (
			    (u (elt uvs i))
			    (but-i (remove i numdims-seq))
			    (length-u (length u))
			    (result (zeros length-u numdims))
			    ortho
			    )
		       (setf
			(select result (iseq length-u) i)
			(matrix (list length-u 1) (* u -2))
			ortho (mapcar
			       (lambda(st)
				 (*
				  (elt st i)
				  (sum (* (select st but-i)
					  (select uvs but-i)))))
			       sts)
			(aref jack i numdims) 
			(if ortho (bind-columns
				   (apply #'bind-columns ortho)
				   result)
			  result)
				    
			(aref jack numdims i) (transpose (aref jack i numdims)) 
			)
		       )
		     )
		    (setq jack (apply #'combine-matrices (row-lists jack)))
;;;		    (mprint jack)
		    (if verbose (print "jack's off"))
		    jack
		    )
		  )
	    )
	   (if verbose (print "or not!"))
	   (setq
	    schmidt-tuples
	    (non-linear-system-root
	     #'funcs #'jack
	     (combine 
	      (mapcar
	       #'normalize
	       (mapcar
		#'rand.n
		size
		)
	       )
	      (rand.n lagrange-multipliers)
	      )
	     :verbose verbose :maxits maxits :eps eps
	     )
	    crap (print schmidt-tuples)
	    lambda (sum (select-from-end schmidt-tuples numdims-seq))
	    st (mapcar (lambda(i) (select schmidt-tuples i)) subsets)
	    order (if (< lambda 0) (setf (elt st 1) (- (elt st 1))))
	    sts (append sts (list st))
	    ;; and make sure that lambda itself is positive:
	    lambdas (append lambdas (list (abs lambda)))
	    lagrange-multipliers (+ 1 lagrange-multipliers)
	    )
	   )
     )
    ;; order the singular values from largest to smallest:
    (setq
     order (reverse (order lambdas))
     lambdas (select lambdas order)
     sts (select sts order)
     )

    (if verbose (print "This will come!"))

    (list lambdas sts)
    )
  )
(try-out nltsvd)
