;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;				letters
;;
(defun lettres(&optional with-caps with-all)
  "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;			lettres Doc:
;;
;; Author: Andy Long
;; Created: Mon Feb 9 19:37:41 1998
;;
;; Description: function

	(letters &optional with-caps with-all)

where

	with-caps	- if true, includes capital letters
	with-all	- if true, includes all standard keyboard characters

By default, only the 26 lower case letters are represented, and they should be
represented equally.

;; Notes: This is a program I wrote to help our librarian Therese learn to
 type. We'll see how it works!

;; Examples:
 (lettres)
 (lettres t)
 (lettres t t)
"
  (let* (
	 (chars (mapcar #'code-char
			(cond
			 (with-all (iseq 33 126))
			 (with-caps (combine (iseq 65 90) (iseq 97 122)))
			 (t (iseq 97 122)))))
	 (possible (iseq (length chars)))
	 (lengths (iseq 3 10))
	 (initial-time (GET-INTERNAL-REAL-TIME))
	 reply exit 
	 )
    (format t "~%Dactylographions! Je ecris un mot, et vous repetez:~%")
    (do*
     (
      (time (GET-INTERNAL-REAL-TIME) (GET-INTERNAL-REAL-TIME))
      (length (first (sample lengths 1)) (first (sample lengths 1)))
      (trial (sample possible length t) (sample possible length t))
      (total-letters length (+ total-letters length))
      )
     (exit)
     (setq trial (coerce (select chars trial) 'string))
     (tagbody
      ask
      (format t "~a~%" trial)
      (setq reply (read-line))
      (cond
       ((string= reply trial)
	(format t "~,4f secondes par lettre.~%"
		(/ (/ (- (GET-INTERNAL-REAL-TIME) time) 100) (length trial))
		)
	)
       ((member (string-downcase reply)
		(list "sortie" "exit" "sortir")
		:test 'string=
		)
	(setq exit t)
	(format t "Moyenne: ~,4f secondes par lettre.~%"
		(/ (/ (- (GET-INTERNAL-REAL-TIME) initial-time) 100)
		   total-letters)
		)
	)
       (t 
	(format t "OOPS! Try again:~%")
	(go ask)
	)
       )
      )
     )
    )
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
