(defun compile-menu-item ()
  (let* (
	 (fitm (send *file-menu* :items))
	 (citm (send menu-item-proto :new "Compile" :key #\K
		     :action #'(lambda() (compile-file (open-file-dialog)))))
	 (litm (send menu-item-proto :new "Load-p" :key #\M
		     :action #'(lambda() (load (open-file-dialog) :print t))))
	 (titm (concatenate 'list (list (first fitm) litm citm) (rest fitm)))
	 )
    (mapcar #'(lambda (x) (send *file-menu* :delete-items x)) fitm)
    (mapcar #'(lambda (x) (send *file-menu* :append-items x)) titm)
    )
  )

(defun help-menu-items ()
  (let (
	(hitm (send menu-item-proto :new "Help" :key #\H
		    :action #'help-select))
	(aitm (send menu-item-proto :new "Apropos" :key #\P
		    :action #'apropos-select))
	(citm (send menu-item-proto :new "Complete" :key #\T
		    :action #'complete-select))
	(ditm (send dash-item-proto :new))
	)
    (mapcar #'(lambda (x) (send *command-menu* :append-items x)) 
	    (list ditm hitm aitm citm))
    )
  )

(defun help-select ()
  (find-and-show-string
   (read-line (send (front-window) :selection-stream) nil)))

(defun apropos-select ()
  (hulp-index (find-and-show-substring
   (read-line (send (front-window) :selection-stream) nil))))

(defun complete-select ()
  (find-and-complete-substring
   (read-line (send (front-window) :selection-stream) nil)))
 

(compile-menu-item)
(help-menu-items)
(provide "machulp")