
(defun help-on-aux (proto command)
  (let* (
	 (methods (send proto :own-methods))
	 (where (map-elements #'search (symbol-name command)
			      (mapcar #'symbol-name methods)))
	 (methods (select methods (which where)))
	 )
    (mapcar (lambda(x) (send proto :help x)) methods)
    )
  )
(defmacro help-on (proto command) (eval `(help-on-aux ,proto ',command)))

(mapcar
 (lambda(x) (send dialog-proto :help x))
 (send dialog-proto :own-methods))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	I'd like to add this, but there's no :do-key method!
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmeth dialog-proto :do-key (c m1 m2)
  "
"
  (case c
	(#\h (princ
"
  The following keys are currently defined: typing them while a scatterplot is
active will give the following results:

                        h - help (this)         i - info (send :help command)

			q - remove the plot
			v - shrink the plot     V - grow the plot

")
	 )
	(#\i (send self :help))
	(#\l
 	 (let ((screen-size (screen-size)))
	   (send self :location 0 20)
	   (send self :size (first screen-size) (- (second screen-size) 20))
	   (send self :plot-item)
	   )
	 )
	(#\q (send self :remove))
	(#\v (let((size (send self :size)))
	       (send self :size
		     (floor (* .9 (first size)))
		     (floor (* .9 (second size))))))
	(#\V (let((size (send self :size)))
	       (send self :size
		     (floor (* 1.1 (first size)))
		     (floor (* 1.1 (second size))))))


	;; These are for keypad use:
	(#\C-q (send self :remove)) ;; control characters work too!


	)
  )

