;; ln:
(add-unary-rule 'ln #'(lambda (x) (make-quotient 1 x)))

;; sinc:
(add-unary-rule 'sinc
		#'(lambda (x)
		    (make-if (make-binary '= x 0) 0
			     (make-quotient
			      (make-diff
			       (make-product x (make-unary 'cos x))
			       (make-unary 'sin x))
			      (make-square x)
			      )
			     )
		    )
		)

;; square:
(add-unary-rule 'square #'(lambda(x) (make-product 2 x)))
;; cube:
(add-unary-rule 'cube #'(lambda(x) (make-product 3 (make-square x))))

#|
	The following command adds unary functions which essentially leave a
function alone. For example, I'm going to assume that if the first function is
used in a function definition, then it applies to a constant, and so the
function should return the same thing. E.g.,

(def a (list 1 2))
(diff (func f(x) (first a) * (square x)) x)

returns 

> ((FIRST A) * (2 * X))

It treats a as a constant.
|#
(dolist
 (i (list
     'first 'second 'third 'fourth 'fifth 'sixth 'seventh 'eighth 'ninth 'tenth
     ))
 (eval `(add-unary-rule ',i #'(lambda(x) (make-unary ',i x))))
 )

;; erf:
(add-unary-rule 'erf
		#'(lambda (x)
		    (let ((vlu (/ 2 (sqrt pi))))
		      (make-product
		       vlu
		       (make-unary 'exp (make-unary '- (make-square x)))
		       )
		      )
		    )
		)

;; gamma:
(add-unary-rule
 'gamma
 #'(lambda (x) (make-product (make-unary 'digamma x) (make-unary 'gamma x)))
 )

;; log-gamma:
(add-unary-rule 'log-gamma #'(lambda (x) (make-unary 'digamma x)))

;; digamma:
(add-unary-rule 'digamma #'(lambda (x) (make-unary 'trigamma x)))
;; digamma-general:
(add-unary-rule
 'digamma-general #'(lambda (x) (make-unary 'trigamma-general x)))

;; trigamma: out of luck!
