(message-execute "                                ;; Section  10.2.1")
(message-execute "
(setf x (append (iseq 1 18) (list 30 40)))
(setf y (+ x (* 2 (normal-rand 20))))
(setf w (plot-points x y))
;;ael: added this as plot-points doesn't create such a slot:
(send w :add-slot 'plot-item (list x y))
")
(printall
(setf x (append (iseq 1 18) (list 30 40)))
(setf y (+ x (* 2 (normal-rand 20))))
(setf w (plot-points x y))
(send w :add-slot 'plot-item (list x y))
)

(message-execute "
(send w :add-mouse-mode 'point-moving
      :title \"Point Moving\"
      :cursor 'finger
      :click :do-point-moving)
(defmeth w :do-point-moving (x y a b)
  (let ((p (send self :drag-point x y :draw nil)))
    (if p (send self :set-regression-line))))
")
(printall
(send w :add-mouse-mode 'point-moving
      :title "Point Moving"
      :cursor 'finger
      :click :do-point-moving)
(defmeth w :do-point-moving (x y a b)
  (let ((p (send self :drag-point x y :draw nil)))
    (if p (send self :set-regression-line)))
  )
)
(message-execute "
(defmeth w :set-regression-line ()
  (let ((coefs (send self :calculate-coefficients)))
    (send self :clear-lines :draw nil)
    (send self :abline (select coefs 0) (select coefs 1))))
(defmeth w :calculate-coefficients ()
  (let* ((i (iseq 0 (- (send self :num-points) 1)))
         (x (send self :point-coordinate 0 i))
         (y (send self :point-coordinate 1 i))
         (m (regression-model x y :print nil)))
    (send m :coef-estimates)))
(send w :set-regression-line)
")
(printall
(defmeth w :set-regression-line ()
  (let ((coefs (send self :calculate-coefficients)))
    (send self :clear-lines :draw nil)
    (send self :abline (select coefs 0) (select coefs 1))))
(defmeth w :calculate-coefficients ()
  (let* ((i (iseq 0 (- (send self :num-points) 1)))
         (x (send self :point-coordinate 0 i))
         (y (send self :point-coordinate 1 i))
         (m (regression-model x y :print nil)))
    (send m :coef-estimates)))
(send w :set-regression-line)
)

#|
;; Problems with this: causes an error if you try to use it. I'll try to get
;; back to figure this out some day!

(message-execute "
(send w :mouse-mode 'point-moving)
(defmeth w :calculate-coefficients ()
  (let* ((i (send self :point-showing))
         (x (send self :point-coordinate 0 i))
         (y (send self :point-coordinate 1 i))
         (m (regression-model x y :print nil)))
    (send m :coef-estimates)))
(defmeth w :adjust-screen ()
  (if (send self :needs-adjusting)
      (send self :set-regression-line))
  (call-next-method))
")
(printall
(send w :mouse-mode 'point-moving)
(defmeth w :calculate-coefficients ()
  (let* ((i (send self :point-showing))
         (x (send self :point-coordinate 0 i))
         (y (send self :point-coordinate 1 i))
         (m (regression-model x y :print nil)))
    (send m :coef-estimates)))
(defmeth w :adjust-screen ()
  (if (send self :needs-adjusting)
      (send self :set-regression-line))
  (call-next-method))
)
|#

;;
(message-execute "                                ;; Section  10.2.2")
;;

(message-execute "
(send spin-proto :add-mouse-mode 'hand-rotate
      :title \"Hand Rotate\"
      :cursor 'hand
      :click :do-hand-rotate)
(defmeth spin-proto :canvas-to-sphere (x y rad)
  (let* ((p (send self :canvas-to-scaled x y))
         (x (first p))
         (y (second p))
         (norm-2 (+ (* x x) (* y y)))
         (rad-2 (^ rad 2))
         (z (sqrt (max (- rad-2 norm-2) 0))))
    (if (< norm-2 rad-2)
        (list x y z)
      (let ((r (sqrt (/ norm-2 rad-2))))
        (list (/ x r) (/ y r) (/ z r))))))
")
(printall
(send spin-proto :add-mouse-mode 'hand-rotate
      :title "Hand Rotate"
      :cursor 'hand
      :click :do-hand-rotate)
(defmeth spin-proto :canvas-to-sphere (x y rad)
  (let* ((p (send self :canvas-to-scaled x y))
         (x (first p))
         (y (second p))
         (norm-2 (+ (* x x) (* y y)))
         (rad-2 (^ rad 2))
         (z (sqrt (max (- rad-2 norm-2) 0))))
    (if (< norm-2 rad-2)
        (list x y z)
      (let ((r (sqrt (/ norm-2 rad-2))))
        (list (/ x r) (/ y r) (/ z r))))))
)

(message-execute "
(defmeth spin-proto :do-hand-rotate (x y m1 m2)
  (let* ((m (send self :num-variables))
         (range (send self :scaled-range 0))
         (rad (/ (apply #'- range) 2))
         (oldp (send self :canvas-to-sphere x y rad))
         (p oldp)
         (vars (send self :content-variables))
         (trans (identity-matrix m)))
    (flet ((spin-sphere (x y)
                        (setf oldp p)
                        (setf p (send self :canvas-to-sphere x y rad))
                        (setf (select trans vars vars)
                              (make-rotation oldp p))
                        (when m1
                              (send self :rotation-type trans)
                              (send self :idle-on t))
                        (send self :apply-transformation trans)))
          (send self :idle-on nil)
          (send self :while-button-down #'spin-sphere))))
")
(printall
(defmeth spin-proto :do-hand-rotate (x y m1 m2)
  (let* ((m (send self :num-variables))
         (range (send self :scaled-range 0))
         (rad (/ (apply #'- range) 2))
         (oldp (send self :canvas-to-sphere x y rad))
         (p oldp)
         (vars (send self :content-variables))
         (trans (identity-matrix m)))
    (flet ((spin-sphere (x y)
                        (setf oldp p)
                        (setf p (send self :canvas-to-sphere x y rad))
                        (setf (select trans vars vars)
                              (make-rotation oldp p))
                        (when m1
                              (send self :rotation-type trans)
                              (send self :idle-on t))
                        (send self :apply-transformation trans)))
          (send self :idle-on nil)
          (send self :while-button-down #'spin-sphere))))
)
;;
(message-execute "                                ;; Section  10.2.3")
;;

(message-execute "
(setf p (plot-lines (rseq 0 1 50) (repeat 0 50)))
(send p :y-axis nil)
(send p :add-mouse-mode 'drawing
      :title \"Drawing\"
      :cursor 'finger
      :click :mouse-drawing)
(defmeth p :mouse-drawing (x y m1 m2)
  (flet ((adjust (x y)
                 (let* ((n (send self :num-lines))
                        (reals (send self :canvas-to-real x y))
                        (i (x-index (first reals) n))
                        (y (second reals)))
                   (send self :linestart-coordinate 1 i y)
                   (send self :redraw-content))))
        (adjust x y)
        (send self :while-button-down #'adjust)))
")
(printall
(setf p (plot-lines (rseq 0 1 50) (repeat 0 50)))
(send p :y-axis nil)
(send p :add-mouse-mode 'drawing
      :title "Drawing"
      :cursor 'finger
      :click :mouse-drawing)
(defmeth p :mouse-drawing (x y m1 m2)
  (flet ((adjust (x y)
                 (let* ((n (send self :num-lines))
                        (reals (send self :canvas-to-real x y))
                        (i (x-index (first reals) n))
                        (y (second reals)))
                   (send self :linestart-coordinate 1 i y)
                   (send self :redraw-content))))
        (adjust x y)
        (send self :while-button-down #'adjust)))
)

(message-execute "
(defun x-index (x n)
  (max 0 (min (- n 1) (floor (* n x)))))
(defun interpolate (x a b ya yb)
  (let* ((range (if-else (/= a b) (- b a) 1))
         (p (pmax 0 (pmin 1 (abs (/ (- x a) range))))))
    (+ (* p yb) (* (- 1 p) ya))))
(defmeth p :mouse-drawing (x y m1 m2)
  (let* ((n (send self :num-lines))
         (reals (send self :canvas-to-real x y))
         (old-i (x-index (first reals) n))
         (old-y (second reals)))
    (flet ((adjust (x y)
                   (let* ((reals (send self :canvas-to-real x y))
                          (new-i (x-index (first reals) n))
                          (new-y (second reals))
                          (i (iseq old-i new-i))
                          (yvals (interpolate
                                  i old-i new-i old-y new-y)))
                     (send self :linestart-coordinate 1 i yvals)
                     (send self :redraw-content)
                     (setf old-i new-i)
                     (setf old-y new-y))))
          (adjust x y)
          (send self :while-button-down #'adjust))))
")
(printall
(defun x-index (x n)
  (max 0 (min (- n 1) (floor (* n x)))))
(defun interpolate (x a b ya yb)
  (let* ((range (if-else (/= a b) (- b a) 1))
         (p (pmax 0 (pmin 1 (abs (/ (- x a) range))))))
    (+ (* p yb) (* (- 1 p) ya))))
(defmeth p :mouse-drawing (x y m1 m2)
  (let* ((n (send self :num-lines))
         (reals (send self :canvas-to-real x y))
         (old-i (x-index (first reals) n))
         (old-y (second reals)))
    (flet ((adjust (x y)
                   (let* ((reals (send self :canvas-to-real x y))
                          (new-i (x-index (first reals) n))
                          (new-y (second reals))
                          (i (iseq old-i new-i))
                          (yvals (interpolate
                                  i old-i new-i old-y new-y)))
                     (send self :linestart-coordinate 1 i yvals)
                     (send self :redraw-content)
                     (setf old-i new-i)
                     (setf old-y new-y))))
          (adjust x y)
          (send self :while-button-down #'adjust))))
)

(message-execute "
(defmeth p :lines ()
  (let ((i (iseq (send self :num-lines))))
    (list (send self :linestart-coordinate 0 i)
          (send self :linestart-coordinate 1 i))))
")
(printall
(defmeth p :lines ()
  (let ((i (iseq (send self :num-lines))))
    (list (send self :linestart-coordinate 0 i)
          (send self :linestart-coordinate 1 i))))
)

(message-execute "
That's all for 10.2!
")
