(message-execute "                                ;; Section  10.3.1")
;;
(message-execute "
(defproto button-overlay-proto
  '(location title)
  nil
  graph-overlay-proto)
(defmeth button-overlay-proto :location (&optional new)
  (if new (setf (slot-value 'location) new))
  (slot-value 'location))

(defmeth button-overlay-proto :title (&optional new)
  (if new (setf (slot-value 'title) new))
  (slot-value 'title))
")
(printall
(defproto button-overlay-proto
  '(location title)
  nil
  graph-overlay-proto)
(defmeth button-overlay-proto :location (&optional new)
  (if new (setf (slot-value 'location) new))
  (slot-value 'location))

(defmeth button-overlay-proto :title (&optional new)
  (if new (setf (slot-value 'title) new))
  (slot-value 'title))
)

(message-execute "
(send button-overlay-proto :location '(0 0))
(send button-overlay-proto :title \"Button\")
(defmeth button-overlay-proto :size ()
  (let* ((graph (send self :graph))
         (title (send self :title))
         (text-width (send graph :text-width title))
         (side (send graph :text-ascent))
         (gap (floor (/ side 2)))
         (descent (send graph :text-descent))
         (height (+ side descent (* 2 gap))))
    (list (+ side (* 3 gap) text-width) height)))
")
(printall
(send button-overlay-proto :location '(0 0))
(send button-overlay-proto :title "Button")
(defmeth button-overlay-proto :size ()
  (let* ((graph (send self :graph))
         (title (send self :title))
         (text-width (send graph :text-width title))
         (side (send graph :text-ascent))
         (gap (floor (/ side 2)))
         (descent (send graph :text-descent))
         (height (+ side descent (* 2 gap))))
    (list (+ side (* 3 gap) text-width) height)))
)

(message-execute "
(defmeth button-overlay-proto :button-box ()
  (let* ((graph (send self :graph))
         (loc (send self :location))
         (side (send graph :text-ascent))
         (gap (floor (/ side 2))))
    (list (+ gap (first loc)) (+ gap (second loc)) side side)))
(defmeth button-overlay-proto :title-start ()
  (let* ((graph (send self :graph))
         (loc (send self :location))
         (title (send self :title))
         (side (send graph :text-ascent))
         (gap (floor (/ side 2))))
    (list (+ (* 2 gap) side (first loc))
          (+ gap side (second loc)))))
")
(printall
(defmeth button-overlay-proto :button-box ()
  (let* ((graph (send self :graph))
         (loc (send self :location))
         (side (send graph :text-ascent))
         (gap (floor (/ side 2))))
    (list (+ gap (first loc)) (+ gap (second loc)) side side)))
(defmeth button-overlay-proto :title-start ()
  (let* ((graph (send self :graph))
         (loc (send self :location))
         (title (send self :title))
         (side (send graph :text-ascent))
         (gap (floor (/ side 2))))
    (list (+ (* 2 gap) side (first loc))
          (+ gap side (second loc)))))
)

(message-execute "
(defmeth button-overlay-proto :draw-button (&optional paint)
  (let ((box (send self :button-box))
        (graph (send self :graph)))
    (apply #'send graph :erase-rect box)
    (if paint
        (apply #'send graph :paint-rect box)
      (apply #'send graph :frame-rect box))))
(defmeth button-overlay-proto :draw-title ()
  (let ((graph (send self :graph))
        (title (send self :title))
        (title-xy (send self :title-start)))
    (apply #'send graph :draw-string title title-xy)))
(defmeth button-overlay-proto :redraw ()
  (send self :draw-title)
  (send self :draw-button))
")
(printall
(defmeth button-overlay-proto :draw-button (&optional paint)
  (let ((box (send self :button-box))
        (graph (send self :graph)))
    (apply #'send graph :erase-rect box)
    (if paint
        (apply #'send graph :paint-rect box)
      (apply #'send graph :frame-rect box))))
(defmeth button-overlay-proto :draw-title ()
  (let ((graph (send self :graph))
        (title (send self :title))
        (title-xy (send self :title-start)))
    (apply #'send graph :draw-string title title-xy)))
(defmeth button-overlay-proto :redraw ()
  (send self :draw-title)
  (send self :draw-button))
)

(message-execute "
(defmeth button-overlay-proto :point-in-button (x y)
  (let* ((box (send self :button-box))
         (left (first box))
         (top (second box))
         (side (third box)))
    (and (< left x (+ left side)) (< top y (+ top side)))))
(defmeth button-overlay-proto :do-click (x y m1 m2)
  (let ((graph (send self :graph)))
    (when (send self :point-in-button x y)
          (send self :draw-button t)
          (send self :do-action (list m1 m2))
          (send graph :while-button-down
                #'(lambda (x y) (send self :do-action nil))
                nil)
          (send self :draw-button nil)
          t)))
(defmeth button-overlay-proto :do-action (x) nil)
")
(printall
(defmeth button-overlay-proto :point-in-button (x y)
  (let* ((box (send self :button-box))
         (left (first box))
         (top (second box))
         (side (third box)))
    (and (< left x (+ left side)) (< top y (+ top side)))))
(defmeth button-overlay-proto :do-click (x y m1 m2)
  (let ((graph (send self :graph)))
    (when (send self :point-in-button x y)
          (send self :draw-button t)
          (send self :do-action (list m1 m2))
          (send graph :while-button-down
                #'(lambda (x y) (send self :do-action nil))
                nil)
          (send self :draw-button nil)
          t)))
(defmeth button-overlay-proto :do-action (x) nil)
)

;;---------------------------

(message-execute "
(def hardness
     (list 45 55 61 66 71 71 81 86 53 60 64 68 79 81 56 68 75
           83 88 59 71 80 82 89 51 59 65 74 81 86))
(def tensile-strength
     (list 162 233 232 231 231 237 224 219 203 189 210 210 196
           180 200 173 188 161 119 161 151 165 151 128 161 146
           148 144 134 127))
(def abrasion-loss
     (list 372 206 175 154 136 112  55  45 221 166 164 113  82
           32 228 196 128  97  64 249 219 186 155 114 341 340
           283 267 215 148))
")
(printall
(def hardness
     (list 45 55 61 66 71 71 81 86 53 60 64 68 79 81 56 68 75
           83 88 59 71 80 82 89 51 59 65 74 81 86))
(def tensile-strength
     (list 162 233 232 231 231 237 224 219 203 189 210 210 196
           180 200 173 188 161 119 161 151 165 151 128 161 146
           148 144 134 127))
(def abrasion-loss
     (list 372 206 175 154 136 112  55  45 221 166 164 113  82
           32 228 196 128  97  64 249 219 186 155 114 341 340
           283 267 215 148))
)
(message-execute "
(defmeth spin-proto :rock-plot (&optional (a .15))
  (let* ((angle (send self :angle))
         (k (round (/ a angle))))
    (dotimes (i k) (send self :rotate-2 0 2 angle))
    (dotimes (i (* 2 k)) (send self :rotate-2 0 2 (- angle)))
    (dotimes (i k) (send self :rotate-2 0 2 angle))))
")
(printall
(defmeth spin-proto :rock-plot (&optional (a .15))
  (let* ((angle (send self :angle))
         (k (round (/ a angle))))
    (dotimes (i k) (send self :rotate-2 0 2 angle))
    (dotimes (i (* 2 k)) (send self :rotate-2 0 2 (- angle)))
    (dotimes (i k) (send self :rotate-2 0 2 angle))))
)

(message-execute "
(defproto spin-rock-control-proto () () button-overlay-proto)
(send spin-rock-control-proto :title \"Rock Plot\")
(defmeth spin-rock-control-proto :do-action (first)
  (send (send self :graph) :rock-plot))
;; ael: error:
;; (width (send self :canvas-width))
(defmeth spin-rock-control-proto :resize ()
  (let* ((graph (send self :graph))
         (size (send self :size))
         (width (send graph :canvas-width))
         (height (send graph :canvas-height)))
    (send self :location (- (list width (+ 3 height)) size))))
")
(printall
(defproto spin-rock-control-proto () () button-overlay-proto)
(send spin-rock-control-proto :title "Rock Plot")
(defmeth spin-rock-control-proto :do-action (first)
  (send (send self :graph) :rock-plot))
;; ael: error:
;; (width (send self :canvas-width))
(defmeth spin-rock-control-proto :resize ()
  (let* ((graph (send self :graph))
         (size (send self :size))
         (width (send graph :canvas-width))
         (height (send graph :canvas-height)))
    (send self :location (- (list width (+ 3 height)) size))))
)

(message-execute "
(let ((w (spin-plot
          (list hardness tensile-strength abrasion-loss)))
      (b (send spin-rock-control-proto :new)))
  (send w :add-overlay b)
  (send b :resize)
  (send b :redraw))
")
(printall
(let ((w (spin-plot
          (list hardness tensile-strength abrasion-loss)))
      (b (send spin-rock-control-proto :new)))
  (send w :add-overlay b)
  (send b :resize)
  (send b :redraw))
)
;;
(message-execute "                                ;; Section  10.3.2")
;;

(message-execute "
(defproto twobutton-control-proto () () button-overlay-proto)
(defmeth twobutton-control-proto :size ()
  (let* ((graph (send self :graph))
         (size (call-next-method))
         (side (send graph :text-ascent))
         (gap (floor (/ side 2))))
    (list (+ gap side (first size)) (second size))))
(defmeth twobutton-control-proto :title-start ()
  (let* ((graph (send self :graph))
         (loc (send self :location))
         (title (send self :title))
         (side (send graph :text-ascent))
         (gap (floor (/ side 2))))
    (list (+ (* 3 gap) (* 2 side) (first loc))
          (+ gap side (second loc)))))
")
(printall
(defproto twobutton-control-proto () () button-overlay-proto)
(defmeth twobutton-control-proto :size ()
  (let* ((graph (send self :graph))
         (size (call-next-method))
         (side (send graph :text-ascent))
         (gap (floor (/ side 2))))
    (list (+ gap side (first size)) (second size))))
(defmeth twobutton-control-proto :title-start ()
  (let* ((graph (send self :graph))
         (loc (send self :location))
         (title (send self :title))
         (side (send graph :text-ascent))
         (gap (floor (/ side 2))))
    (list (+ (* 3 gap) (* 2 side) (first loc))
          (+ gap side (second loc)))))
)

(message-execute "
(defmeth twobutton-control-proto :button-box (which)
  (let* ((graph (send self :graph))
         (loc (send self :location))
         (side (send graph :text-ascent))
         (gap (floor (/ side 2)))
         (left (case which
                     (+ (+ gap (first loc)))
                     (- (+ (* 2 gap) side (first loc))))))
    (list left (+ gap (second loc)) side side)))
(defmeth twobutton-control-proto :draw-button (which &optional paint)
  (let ((box (send self :button-box which))
        (graph (send self :graph)))
    (cond (paint (apply #'send graph :paint-rect box))
          (t (apply #'send graph :erase-rect box)
             (apply #'send graph :frame-rect box)))))
")
(printall
(defmeth twobutton-control-proto :button-box (which)
  (let* ((graph (send self :graph))
         (loc (send self :location))
         (side (send graph :text-ascent))
         (gap (floor (/ side 2)))
         (left (case which
                     (+ (+ gap (first loc)))
                     (- (+ (* 2 gap) side (first loc))))))
    (list left (+ gap (second loc)) side side)))
(defmeth twobutton-control-proto :draw-button (which &optional paint)
  (let ((box (send self :button-box which))
        (graph (send self :graph)))
    (cond (paint (apply #'send graph :paint-rect box))
          (t (apply #'send graph :erase-rect box)
             (apply #'send graph :frame-rect box)))))
)

(message-execute "
(defmeth twobutton-control-proto :redraw ()
  (send self :draw-title)
  (send self :draw-button '-)
  (send self :draw-button '+))
(defmeth twobutton-control-proto :point-in-button (x y)
  (let* ((box1 (send self :button-box '-))
         (box2 (send self :button-box '+))
         (left1 (first box1))
         (top (second box1))
         (side (third box1))
         (left2 (first box2)))
    (cond
     ((and (< left1 x (+ left1 side)) (< top y (+ top side)))
      '-)
     ((and (< left2 x (+ left1 side)) (< top y (+ top side)))
      '+))))
")
(printall
(defmeth twobutton-control-proto :redraw ()
  (send self :draw-title)
  (send self :draw-button '-)
  (send self :draw-button '+))
(defmeth twobutton-control-proto :point-in-button (x y)
  (let* ((box1 (send self :button-box '-))
         (box2 (send self :button-box '+))
         (left1 (first box1))
         (top (second box1))
         (side (third box1))
         (left2 (first box2)))
    (cond
     ((and (< left1 x (+ left1 side)) (< top y (+ top side)))
      '-)
     ((and (< left2 x (+ left1 side)) (< top y (+ top side)))
      '+))))
)

(message-execute "
(defmeth twobutton-control-proto :do-click (x y m1 m2)
  (let ((graph (send self :graph))
        (which (send self :point-in-button x y)))
    (when which
          (send self :draw-button which t)
          (send self :do-action which (list m1 m2))
          (send graph :while-button-down
                #'(lambda (x y) 
                    (send self :do-action which nil))
                nil)
          (send self :draw-button which nil)
          t)))
(defmeth twobutton-control-proto :do-action (which mods) nil)
")
(printall
(defmeth twobutton-control-proto :do-click (x y m1 m2)
  (let ((graph (send self :graph))
        (which (send self :point-in-button x y)))
    (when which
          (send self :draw-button which t)
          (send self :do-action which (list m1 m2))
          (send graph :while-button-down
                #'(lambda (x y) 
                    (send self :do-action which nil))
                nil)
          (send self :draw-button which nil)
          t)))
(defmeth twobutton-control-proto :do-action (which mods) nil)
)

;;---------------------------

(message-execute "
(defmeth spin-proto :set-axis-rotation (v)
  (let* ((m (send self :num-variables))
         (v1 (if (= v 0) 1 0))
         (v2 (if (= v 2) 1 2))
         (trans (send self :transformation))
         (cols (column-list
                (if trans trans (identity-matrix m))))
         (x1 (select cols v1))
         (x2 (select cols v2))
         (angle (send self :angle)))
    (send self :rotation-type (make-rotation x1 x2 angle))))
")
(printall
(defmeth spin-proto :set-axis-rotation (v)
  (let* ((m (send self :num-variables))
         (v1 (if (= v 0) 1 0))
         (v2 (if (= v 2) 1 2))
         (trans (send self :transformation))
         (cols (column-list
                (if trans trans (identity-matrix m))))
         (x1 (select cols v1))
         (x2 (select cols v2))
         (angle (send self :angle)))
    (send self :rotation-type (make-rotation x1 x2 angle))))
)

(message-execute "
(defproto spin-rotate-control-proto
  '(v) () twobutton-control-proto)
(defmeth spin-rotate-control-proto :isnew (v &rest args)
  (apply #'call-next-method :v v args))
(defmeth spin-rotate-control-proto :title ()
  (send (send self :graph) :variable-label (slot-value 'v)))
(defmeth spin-rotate-control-proto :do-action (sign mods)
  (let ((graph (send self :graph)))
    (if mods
        (let ((v (slot-value 'v))
              (angle (abs (send graph :angle))))
          (send graph :idle-on (first mods))
          (send graph :angle
                (if (eq sign '+) angle (- angle)))
          (send graph :set-axis-rotation v)))
    (send graph :rotate)))
")
(printall
(defproto spin-rotate-control-proto
  '(v) () twobutton-control-proto)
(defmeth spin-rotate-control-proto :isnew (v &rest args)
  (apply #'call-next-method :v v args))
(defmeth spin-rotate-control-proto :title ()
  (send (send self :graph) :variable-label (slot-value 'v)))
(defmeth spin-rotate-control-proto :do-action (sign mods)
  (let ((graph (send self :graph)))
    (if mods
        (let ((v (slot-value 'v))
              (angle (abs (send graph :angle))))
          (send graph :idle-on (first mods))
          (send graph :angle
                (if (eq sign '+) angle (- angle)))
          (send graph :set-axis-rotation v)))
    (send graph :rotate)))
)

(message-execute "
(flet ((width (c) (first (send c :size))))
      (let* ((w (spin-plot
                 (list hardness tensile-strength abrasion-loss)))
             (c0 (send spin-rotate-control-proto :new 0))
             (c1 (send spin-rotate-control-proto :new 1))
             (c2 (send spin-rotate-control-proto :new 2)))
        (send w :add-overlay c0)
        (send w :add-overlay c1)
        (send w :add-overlay c2)
        (let ((width (max (mapcar #'width (list c0 c1 c2))))
              (height (second (send c0 :size)))
              (margin (send w :margin)))
          (send c1 :location (list 0 height))
          (send c2 :location (list 0 (* 2 height)))
          (send w :margin width 0 0 (fourth margin)))))
")
(printall
(flet ((width (c) (first (send c :size))))
      (let* ((w (spin-plot
                 (list hardness tensile-strength abrasion-loss)))
             (c0 (send spin-rotate-control-proto :new 0))
             (c1 (send spin-rotate-control-proto :new 1))
             (c2 (send spin-rotate-control-proto :new 2)))
        (send w :add-overlay c0)
        (send w :add-overlay c1)
        (send w :add-overlay c2)
        (let ((width (max (mapcar #'width (list c0 c1 c2))))
              (height (second (send c0 :size)))
              (margin (send w :margin)))
          (send c1 :location (list 0 height))
          (send c2 :location (list 0 (* 2 height)))
          (send w :margin width 0 0 (fourth margin)))))
)
(message-execute "
That's all for 10.3!
")
