(message-execute "
;;;; 
                                ;; Section 2.7.1
;;;; 
(defun delete-case (x i)
  (select x (remove i (iseq (length x)))))

(defun f-statistic (m1 m2)
  \"Args: (m1 m2)
Computes the F statistic for testing model m1 within model m2.\"
  (let (
	(ss1 (send m1 :sum-of-squares))
	(df1 (send m1 :df))
	(ss2 (send m2 :sum-of-squares))
	(df2 (send m2 :df))
	)
    (/ (/ (- ss1 ss2) (- df1 df2)) (/ ss2 df2))
    ))
")
(message-execute "
;;;; 
                                ;; Section 2.7.2
;;;; 
(defun f (x) (+ (* 2 x) (^ x 2)))

(plot-function #'f -2 3)

(defun f (x y) (+ (^ x 2) (^ y 2)))

(spin-function #'f -1 1 -1 1)
")
(message-execute "
;;;; 
                                ;; Section 2.7.3
;;;; 
(defun bc (x p)
  (let* (
	 (bcx (if (< (abs p) .0001) (log x) (/ (^ x p) p)))
	 (min (min bcx))
	 (max (max bcx))
	 )
    (/ (- bcx min) (- max min))
    ))

(def precipitation
     (list .77 1.74 .81 1.20 1.95 1.20 .47 1.43 3.37 2.20
	   3.00 3.09 1.51 2.10 .52 1.62 1.31 .32 .59 .81
	   2.81 1.87 1.18 1.35 4.75 2.48 .96 1.89 .90 2.05))

(def x (sort-data precipitation))

(def nq (normal-quant (/ (iseq 1 30) 31)))
")
(message-execute "
(def myplot (plot-points nq (bc x 1)))

(defun change-power (p)
  (send myplot :clear :draw nil)
  (send myplot :add-points nq (bc x p)))

(change-power .5)
")
(message-execute "
(sequence-slider-dialog (rseq -1 2 31) :action #'change-power)
")
(message-execute "
;;;; 
                                ;; Section 2.7.4
;;;; 
(def h (histogram (normal-rand 20)))

(defmeth h :new-sample ()
  (send self :clear :draw nil)
  (send self :add-points (normal-rand 20)))
")
(message-execute "
(dotimes (i 50) (send h :new-sample))
")
(message-execute "
(let ((m (send h :menu))
      (i (send menu-item-proto :new \"New Sample\"
	       :action #'(lambda () (send h :new-sample)))))
  (send m :append-items i))
")
