(message-execute "
;; ==================
             ;; Section  4.3.1: Conditional Evaluation
;; ==================
;; ael: added the let so that it wouldn't generate an error upon evaluation:
(let (choice)
  (case choice
        ((ok delete) (delete-file))
        (cancel (restore-file)))
  )
")
(message-execute "
;; ==================
             ;; Section  4.3.2: Looping
;; ==================
;; ael: had to add these:
(defun improve (guess x) (mean (list guess (/ x guess))))
(defun good-enough-p (guess x)
  (< (abs (- (* guess guess) x)) .001))
;; lea
(defun my-sqrt (x &key print)
  (do ((guess 1 (improve guess x)))
      ((good-enough-p guess x)
       (if print (format t \"Final guess: ~g~%\" guess))
       guess)
      (if print (format t \"Current guess: ~g~%\" guess))))
(my-sqrt 3 :print t)
")
(message-execute "
(defun factorial (n)
  (let ((n-fac 1))
    (dotimes (i n n-fac)
             (setf n-fac (* n-fac (+ i 1))))))
(defun sum-list (x)
  (let ((sum 0))
    (dolist (i x sum)
            (setf sum (+ sum +)))))
")
(message-execute "
(defun factorial (n)
  (let ((i 1)
        (n-fac 1))
    (loop (if (> i n) (return n-fac))
          (setf n-fac (* i n-fac))
          (setf i (+ i 1)))))
")
