(message-execute "
                                ;; Section  4.5.1: Errors

;; ael: these would all generate errors, so I've pithed them:
;; (error \"An error has occurred.\")
;; (error \"Bad argument type - ~a\" 3)
;; (unwind-protect (do-dialog) (close-dialog))
")
(message-execute "
                          ;; Section  4.5.2: Code-Writing Support

(documentation 'mean 'function)
(documentation 'pi 'variable)
(documentation 'complex 'type)
")
(message-execute "
*features*
#+color (print 'add-color)
#-color (print 'fake-color)
#+(and windows (not color)) (print 'fake-color)
")
(message-execute "
                          ;; Section  4.5.3: Debugging Tools

#|
;; ael: the following code requires a high degree of interaction. It is
;; included within the comment below, so that if you would like to try it out,
;; you'll be able to.
(defun f(x) (break) x)
(f 3) ;; causes a break: you type 
(continue)
(defun f(x) (/ x 0))
(debug)
(f 3) ;; causes an error: you type 
(baktrace)
;; while in the break-loop.
(f 3)
(clean-up)
(top-level)
#|
")
(message-execute "
;; Tracing:

(trace f)
(untrace f)
(defun factorial (n)
  (if (= n 0) 1 (* (factorial (- n 1)) n)))
(trace factorial)
(factorial 6)
(untrace factorial)
(factorial 6)
")
(message-execute "
#|
;; ael: the stepper also requires much interaction:
(step '(+ 1 2 (* 3 (/ 2 4))))
;; type :h to the stepper for a list of allowable stepper commands.
#|
")
(message-execute "
                          ;; Section  4.5.4: Timing

(time (mean (iseq 1 1000)))
")
(message-execute "
                          ;; Section  4.5.5: Defsetf

;; ael: needed this stuff from 3.10:
(defun make-sum (a1 a2)
  (cond
   ((numberp a1) (if (= a1 0) a2 (list '+ a1 a2)))
   ((numberp a2) (if (= a2 0) a1 (list '+ a1 a2)))
   (t (list '+ a1 a2))
   ))
(defun addend (e) (second e))
(defun augend (e) (third e))
;; lea

(defun set-addend (sum new)
  (setf (select sum 1) new)
  new)
(defsetf addend set-addend)
(setf s (make-sum 1 3))
(setf (addend s) 2)
s
")
(message-execute "
                          ;; Section  4.5.6: Special Variables

(defvar x (list 1 2 3) \"A simple data set\")
;; N.B.: if x was previously defined, the preceding statement will not change
;; its value. 
x
;; Here's one that's probably available!
(defvar xys (list 1 2 3) \"A simple data set\")
xys

;; ael: don't want to define this, in case it screws up later calculations:
;; (defconstant e (exp 1))
;; (setf e 3)
;; generates an error: can't assign to a constant
")
