(message-execute "
                                ;; Section 8.6

(defproto bitmap-edit-proto
  '(bitmap h v) nil graph-window-proto)
(defmeth bitmap-edit-proto :isnew (width height)
  (call-next-method)
  (setf (slot-value 'bitmap)
        (make-array (list height width) :initial-element 0)))
(defmeth bitmap-edit-proto :bitmap () (slot-value 'bitmap))
(defmeth bitmap-edit-proto :v () (slot-value 'v))
(defmeth bitmap-edit-proto :h () (slot-value 'h))
(defmeth bitmap-edit-proto :resize ()
  (let ((m (array-dimension (send self :bitmap) 0))
        (n (array-dimension (send self :bitmap) 1))
        (height (send self :canvas-height))        
        (width (send self :canvas-width)))
    (setf (slot-value 'v)
          (coerce (floor (* (Iseq 0 m) (/ height m)))
                  'vector))
    (setf (slot-value 'h)
          (coerce (floor (* (Iseq 0 n) (/ width n)))
                  'vector))))
")
(message-execute "
(defmeth bitmap-edit-proto :draw-pixel (i j)
  (let* ((b (send self :bitmap))
         (v (send self :v))
         (h (send self :h))
         (left (aref h j))
         (right (aref h (+ j 1)))
         (top (aref v i))
         (bottom (aref v (+ i 1))))
    (send self (if (= 1 (aref b i j)) :paint-rect :erase-rect)
          left top (- right left) (- bottom top))))
(defmeth bitmap-edit-proto :redraw ()
  (let* ((b (send self :bitmap))
         (m (array-dimension b 0))
         (n (array-dimension b 1))
         (width (send self :canvas-width))
         (height (send self :canvas-height)))
    (send self :start-buffering)
    (send self :erase-rect 0 0 width height)
    (dotimes (i m)
             (dotimes (j n)
                      (send self :draw-pixel i j)))
    (send self :buffer-to-screen)))
")
(message-execute "
(defmeth bitmap-edit-proto :set-pixel (x y)
  (let* ((b (send self :bitmap))
         (m (array-dimension b 0))
         (n (array-dimension b 1))
         (width (send self :canvas-width))
         (height (send self :canvas-height))
         (i (min (floor (* y (/ m height))) (- m 1)))
         (j (min (floor (* x (/ n width))) (- n 1))))
    (setf (aref b i j) (if (= (aref b i j) 1) 0 1))
    (send self :draw-pixel i j)))
(defmeth bitmap-edit-proto :do-click (x y m1 m2)
  (send self :set-pixel x y))
")
(message-execute "
(setf w (send bitmap-edit-proto :new 16 16))
")
(setf w (send bitmap-edit-proto :new 16 16))
(message-execute "
(defmeth bitmap-edit-proto :name-bitmap ()
  (let ((str (get-string-dialog \"Symbol for the bitmap:\")))
    (if str
        (let ((name (with-input-from-string (s str) (read s))))
          (setf (symbol-value name) (send self :bitmap))))))
(defmeth bitmap-edit-proto :bitmap-as-cursor (yes)
  (if yes (make-cursor 'temp-cursor (send self :bitmap)))
  (send self :cursor (if yes 'temp-cursor 'arrow)))
(setf bitmenu (send menu-proto :new \"Bitmap\"))
(setf name-item
      (send menu-item-proto :new \"Name Bitmap...\"
            :action #'(lambda () (send w :name-bitmap))))
(setf cursor-item
      (send menu-item-proto :new \"Use as Cursor\"
            :action
            #'(lambda ()
                (let ((mark (send cursor-item :mark)))
                  (send w :bitmap-as-cursor (not mark))
                  (send cursor-item :mark (not mark))))))
")
(message-execute "
;; ael added these: pretty stale without them!
(send bitmenu :append-items name-item cursor-item)
(send w :menu bitmenu)
")
