(tutorial-dialog (combine 
(list "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                             Defining functions: func
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Let's define the function f, where f(x)=x^3-2*x+3, using func:

        (func f(x) x^3-2*x+3) ; f(x)=x^3-2*x+3

")
(list "
;;        Okay, it's defined! (I actually sent that command above to xlisp-stat,
;; including the semi-colon: the semicolon acts as a comment, and anything
;; following it on a line is ignored by xlisp-stat.)

;;        One odd note: you cannot, repeat CANNOT, use \"t\" as a variable
;; in xlispstat: it means \"true\", and much as I'd like to change that, I don't
;; really know how, and it would wreak havoc throughout the rest of xlispstat.

;;        This is really easy to forget: try not to!
")
(list "
;;        You can create several functions, and then combine them using func;
;; but you must be sure to do so in the proper fashion, as demonstrated below:

        (title \"Creating new functions\")
        (func f(x) 4*x)
        (func g(x) x^2)
        (func h(x) (f x) - (g x))
        (func k(x) (f (g x)))
        (plot f g h k -1 1)

;; Notice that we use (f x), rather than f(x), etc.
")
(list "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                             2-d func stuff
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;        You can plot 2-d functions, which are also defined with \"func\": for
;; example,

        (func ff(x y) cos(x) + sin(y))
")
(list "
;;        Okay, I've taken care of defining it, using the func command: now to
;; plot it. Note the use of these plotting functions, like (title \"...\") and
;; (spin-domain -pi pi -pi pi) (which sets the part of the xy-plane of interest):

        (new-plot)
        (spin-points 20)
        (spin-axes nil)
        (title \"f(x y) = cos(x) + sin(y)\")
        (spin-domain -pi pi -pi pi)
        (plot ff)
")
(list "
;;         If you're the lazy sort, and just want to use an expression
;; (like x ^ 2) but don't want to bother defining a function, then you can use
;; the braces: for example

        (title \"Braces define functions of x\")
        (plot {x^2})

;; will plot the function f(x)=x^2, without requiring you to define it.

;;        Notice that you must use the variable x in your definition (the
;; braces assume it).
")

) :title "functions")
