;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; tutorials Doc:    Creation Date:2/29/96        Author: Andy Long
;;
;;
(defun tutorials ()
  "
;; Description/Arguments:

       (tutorials)
  
   Offers a choice of tutorials to help the novice get started.

;; See Also: tutorial
"
  (let* (
	 (programs '(
		     "student"
		     "func"
		     "plot"
		     "diff"
		     "calc"
		     "tangent"
		     "deriv"
		     "multplot"
		     "roots"
		     "integrat"
		     "2-d-func"
		     "data"
		     "taylor"
		     "moreinfo"
		     "diffeq"
		     "linalg"
		     "mac-help"
		     "mo-carlo"
		     "parametr"
		     "complex"
;;		     "program"
		     ))
	 (choice (choose-item-dialog "tutorial choices" programs))
	 )
    (read-char) ;; why do I seem to need this?
    (if choice
	(load
	 (strcat *andy-default-path* "tutorials" separator
		 (nth choice programs) ".lsp") 
	 :print t)
      )
    )
  "Good luck!"
  )
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun tutorials ()
  "
;; Description/Arguments:

       (tutorials)
  
   Offers a choice of tutorials to help the novice get started.

;; See Also: tutorial
"
  (let* (
	 (work-dir (cwd))
	 choice
	 )
    (print (set-working-directory
	    (strcat *default-path* "calculus" separator "tutorials" separator)
	    ))
    (setq choice (open-file-dialog))
    (print work-dir)
    (print work-dir)
    (read-char) ;; why do I seem to need this?
    (if choice
	(load
	 (strcat *andy-default-path* "tutorials" separator choice)
	 :print t)
      )
    (set-working-directory work-dir)
    )
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; tutorials2 Doc:    Creation Date:2/29/96        Author: Andy Long
;;
;;
(defun tutorials2 ()
  "
;; Description/Arguments:

       (tutorials)
  
   Offers a choice of tutorials to help the novice get started.

;; See Also: tutorial
"
  (let (
	choice
	(programs '(
		    "moreinfo"
		    "student"
		    "func"
		    "plot"
		    "diff"
		    "calc"
		    "tangent"
		    "deriv"
		    "multplot"
		    "roots"
		    "integrat"
		    "2-d-func"
		    "data"
		    "taylor"
		    "diffeq"
		    "diffeq"
		    "linalg"
		    "mac-help"
		    "mo-carlo"
		    "parametr"
		    "complex"
		    "program"
		    "fourier"
		    "OOP"
		    "book"
		    "animate"
		    "pca-svd"
		    "glim"
		    ))
	)
    (princ "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                              Name your poison:

 1. Student Primer - the tour!          15. Differential equations
 2. Defining functions: func            16. Linear Algebra
 3. Plotting functions: plot            17. Macintosh Help
 4. Derivatives: diff                   18. Monte-carlo integration
 5. Calc: A calculator                  19. Parametric/polar plots
 6. Tangent lines/curves/surfaces       20. Complex Numbers
 7. Derivative plots                    21. Programming
 8. Plotting several functions          22. Fourier series
 9. Roots                               23. Object-oriented programming
10. Integration                         24. Luke's Book (generic xlisp-stat)
11. Functions of two variables          25. Animation
12. Discrete data sets                  26. pca versus svd
13. Taylor series                       27. generalized linear models
14. Differential equations
;;                        0. for more information....
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
type a number, then hit return: ")
    (setq choice (read (make-string-input-stream (eval (read-line)))))
    (if (and (numberp choice) (< choice (length programs)) (>= choice 0))
	(load (strcat *andy-default-path* "tutorial" separator 
		      (select programs choice) ".lsp") :print t)
      (let ()(format t "Sorry: can't help you there!~%")(abort)))
    )
  )
;;
