(tutorial-dialog (combine 
(list "
; Hi folks,

; Calculus with Xlispstat is a project begun at Ripon College, Ripon, WI, USA, to
; aid (and with the aid of) calculus students. I call it 'Ripon Good Math'
; (RGM). It provides many important advantages to anyone using xlispstat,
; however, including

;     more natural (infix) function definition; 
;     easy plotting of functions, matrices, vectors, and lists; 
;     expression simplification; 
;     postscript files; 
;     hidden-surface generation; 
;     fortran to lisp code translation, so that a wide body of code can be easily
;          ported to xlispstat; 
;     a tcl/tk interface, which works pretty well under UNIX; 

; and more. 
")
(list "
; I've actually programmed many examples from several books: I understand by
; actually trying out examples, so I make these available to you.
;     Luke Tierney, Lispstat, Wiley, 1990, ISBN: 0-471-50916-7 (all - I've
;          rewritten what is publically available to make it more accessible.
;          Use the (book) command to access it.)
;     Draper and Smith, Applied Linear Regression (almost all) 
;     Kaplan and Glass, Understanding Non-Linear Dynamics, Springer-Verlag,
;          1995 (some) 
;     Gil Strang, Introduction to Applied Mathematics, Wellesley-Cambridge
;          Press, 1986 (some) 
;     Lawrence Perko, Differential Equations and Dynamical Systems,
;          Springer-Verlag, New York, 1991 (some) 
;     A favorite subset of the files that Peter Norvig provided with his book
;          Code from Paradigms of Artificial Intelligence Programming,
;          Copyright (c) 1991 by Peter Norvig. 
;     Mendenhall Scheaffer and Wackerly, Mathematical Statistics with
;          Applications, Duxbury Press, 1981 (some) 
;     Minor bits from Snedecor and Cochrane, 'Applied Regression Analysis', 
;          6th edition 
;     Wayne W. Daniel's Biostatistics: a Foundation for Analysis in the 
;          Health Sciences
;     Hosmer and Lemeshow, Logistic Regression (some) 
; Check the examples sub-directory of the calculus directory for the files."
)
(list "
; The code is freely available, and has been tested for UNIX (under Sun Solaris
; and linux), the Mac, and Windoze. I've stolen a lot of good ideas from the
; usual contributors to the xlispstat discussion group, and thank them for their
; hard work. My posts since Ripon have also provided much 'oomph' to this
; on-going project: thanks to Loyola and the IMSP of Benin, West Africa.

; I'm not smart enough to use all the packages, provides and requires, however,
; so I just compile and load everything in, save a new environment, and always
; run from within that.  Saves loading time, but makes for a big application (it
; used to be a monster, but nowadays lots of applications are pushing several
; megs big).
")
(list "

;                             Andy Long 
;                         Fearless Programmer 
;                         1228 McIntyre Drive
;                           Ann Arbor, MI 
;                              48105
;                     email: aelon@sph.umich.edu 
;                        Phone: 734-764-0195
")
) :title "Intro")

