(tutorial-dialog (combine 
(list "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                             Tangent lines
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;        What does the tangent line approximation to f at x=-.5 look like at
;; x=1? Use the tangent command:

        (title \"Tangent line plot\")
        (func f(x) x^3-2*x+3) ; f(x)=x^3-2*x+3
        (tangent f -.5 1)
")
(list "
;;        What luck! It's right on! Notice that you can zoom in or out on the
;; tangent point (or any point) with your mouse button. That's an especially cool
;; little trick for looking at this type of plot, but, as noted earlier, it is a
;; general feature of the plot command.
")

(list "
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;                             Taylor Series
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;        The Taylor series of a function can be obtained, as a generalization of
;; the tangent.

        (title \"Taylor series\")
        (taylor f ft 2 -1)
        (plot f ft -2 0)

;; This will compute the quadratic (degree 2) Taylor series approximation
;; function (we'll call it ft) to f at -1.
")
(list "
;;        Diffplot allows you to have a look at the tangent plane to a 2-d
;; function: here it is at (1,1) for a function

        (spin-points 20)
        (func ff(x y) cos(x) + sin(y))
        (title \"cos(x) + sin(y) and tangent plane\")
        (diffplot ff -pi/2 pi/2 -pi/2 pi/2 1 1)

;; (Note that it is the addition of the last two values that indicates to
;; diffplot that you want the tangent plane.)
")
) :title "Tangents")
