(old-readtable)

;;########################################################################
;; ViSta - The Visual Statistics System
;; Copyright (c) 1991-96 by Forrest W. Young
;; Version 4.22 Beta, January 8th, 1996 
;; For further information contact the author at forrest@unc.edu
;; Modified for X11 by Anthony J. Rossini (rossini@stat.sc.edu)
;; This file contains initialization code
;;########################################################################
;;ViSta runs under the Lisp-Stat statistical computing environment.
;;This is the file to load ViSta once Lisp-Stat is running.  
;;ViSta works on Macintosh microcomputers, and on IBM compatibles under the
;;32-bit version of MS-Windows. This version has been modified to work on
;;Unix machines under X11, but has not yet been extensively tested. It also 
;;runs but has not been tested on 16-bit MS-Windows and on the Power-Mac. 
;;########################################################################

(defun strcat (&rest args) (apply #'concatenate 'string args))

(let* ((separator #+macintosh ":"
		  #+msdos "\\"
		  #+X11 "/")
       ;; CHANGE:  the following line should be the home location of
       ;; Vista, i.e. it should be $CurrentDir/vista-4.22a
;;ael       #+X11(working-directory "/apps/xlispstat/vista/vista-4.22a")
       #+X11(working-directory (strcat *andy-default-path* "vista"))
;; ael
;;;       #-X11(working-directory (get-working-directory))
       #+msdos (working-directory (strcat working-directory separator))
       #+X11(working-directory (strcat working-directory separator)))
  (setf *startup-dir* (get-working-directory))
  (setf *vista-dir-name*   (strcat working-directory "vista"    separator))
  (setf *data-dir-name*    (strcat *vista-dir-name*  "data"     separator))
  (setf *help-dir-name*    (strcat *vista-dir-name*  "help"     separator))
  (setf *guide-dir-name*   (strcat *vista-dir-name*  "guidance" separator))
  (setf *example-dir-name* (strcat *vista-dir-name*  "example"  separator)))

#+macintosh(defun memory-message ()
  (let* ((8bit-screen-mbytes (/ (* 8 (apply #'* (screen-size))) 8192000))
         (total (ceiling (+ 3.5 8bit-screen-mbytes)))
         (total (+ 2 total))
         )
    (message-dialog (format nil 
"MEMORY REQUIREMENTS:

ViSta needs at least ~d MBytes, plus ~3,1f more for
a 16-bit screen, or ~3,1f more for a 24-bit screen.

Increase memory partition size if ViSta crashes.
(This message disappears if ViSta quits correctly)."
            total 8bit-screen-mbytes (* 2 8bit-screen-mbytes)))))

(setf memory-message t)
(setf config-vistaxls nil)

(load (strcat *vista-dir-name* "prefload"))

#+msdos (when config-vistaxls 
              (let ((oldbreak *breakenable*)
                    (f (open (strcat *vista-dir-name* 
                                     "prefload.lsp") 
                             :direction :output)))
                (setq *breakenable* nil)
                (unwind-protect
		    (princ `(setf ask-load-vista ,ask-load-vista) f)
		  (princ "(setf memory-message nil)" f))
                (setq *breakenable* oldbreak)
                (close f))
              (load "config"))

#+macintosh(when memory-message (memory-message))

#+macintosh(defun repeat-command ()
	     "Repeats previous command.  Written by Frederic Udina."
	     (send *listener* :paste-string (string-downcase (format nil "~s" -)))
	     (send *listener* :show-window))

#+macintosh(defun add-repeat-to-menu ()
	     ;; Next statement prevents error if calling the repeat function before
	     ;; - is defined by the first read
	     (setq - nil)
	     (send *command-menu*
		   :append-items
		   (send menu-item-proto
			 :new "Repeat Command"
			 :action 'repeat-command
			 :key #\')))

#+macintosh(add-repeat-to-menu)

(defun load-vista ()
  (let ((yesno t))
    (when ask-load-vista
          (setf yesno 
		(ok-or-cancel-dialog (format nil
					     "XLisp-Stat has been loaded.~%Proceed to Load ViSta as well?"))))
    (when yesno
          (let ((oldbreak *breakenable*)
                (f (open (strcat *vista-dir-name* "prefload.lsp") 
                         :direction :output)))
            (setq *breakenable* nil)
            (unwind-protect
		(princ `(setf ask-load-vista ,ask-load-vista) f)
	      (princ "(setf memory-message t)" f))
            (setq *breakenable* oldbreak)
            (close f))
          (expand 85)
          (when (not (load (strcat *vista-dir-name* "vista")
                           :if-does-not-exist nil))
                (message-dialog 
                 (format nil "ERROR: ViSta was not found.
~%It was sought in directory: ~%~a~%You must restructure your files~%so that ViSta is in that directory." *vista-dir-name*) t)))))

(provide "statinit")
(when (not config-vistaxls) (load-vista))
