;;########################################################################
;; anovamob.lsp
;; Copyright (c) 1993-94 by Forrest W. Young
;; contains code for anova visualization.
;; leverage and residual plots are not completed.
;;########################################################################

(require "vista")

(defmeth anova-model-object-proto :visualize ()
  (if (not (eq current-object self)) (setcm self))
  (let* ((my-data (send self :data-object))
         (nway (send self :nway-model))
         (bp nil)          (dnl nil) (lp nil) (rp nil)
         (nways (send my-data :nways))
         (ways (send my-data :ways))
         (sources (send my-data :source-names))
         (design (combine "Overall" sources))
         (data (combine (send self :data)))
         (grouped-data (send my-data :grouped-data 0))
         (labels (send my-data :level-names))
         )
    (setf bp (boxplot grouped-data 
                      :location location11
                      :show nil
                      :size (+ 
                           #+macintosh'(17 0)
                           #+msdos    '( 8 0) 
                           (* '(2 1) graph-size))
                      :boxes nil :diamonds t :mean-line t
                      :variable-labels (first labels)))
    (send bp :y-axis t t (third (send bp :y-axis)))
    (send bp :variable-label 1 (first (send my-data :variables)))
    (send bp :show-window)
    (defmeth bp :close ()
      (send bp  :remove)
      (send pp  :remove)
      (send dnl :remove)
      (send lp  :remove)
      (send rp  :remove)) 


    (setf dnl (name-list design
                         :show nil
                         :go-away nil
                         :location location13
                         :title "Sources"))
    (send dnl :show-window)
    (send dnl :size (- (first namelist-size) msdos-fiddle)
          (- (second namelist-size) msdos-fiddle))
    (defmeth dnl :close ()
      (send bp :close))

    (defmeth dnl :do-select-click (&rest args)
      (apply #'call-next-method args)
      (when (send self :selection)
            (let* ((sel (first (send self :selection)))
                   (num (send self :num-points))
                   (ways (send my-data :ways))
                   (nways (send my-data :nways)))
              (cond
                ((= sel 0) 
                 (send current-model :profile-labels nil)
                 (send bp :new-plot (combine (send my-data :data))
                       :variable-labels (list (send my-data :name)))
                 (send pp :clear)
                 (send pp :variable-label 0 "")
                 (send pp :redraw))
                ( t
                  (when (<= sel nways)
                        (send current-model :profile-labels 
                              (nth (1- sel) (send my-data :classes))))
                  (send bp :new-plot (send my-data :grouped-data (1- sel))
                        :variable-labels 
                        (nth (1- sel) (send my-data :level-names)))
                  (send pp :new-plot 
                        (send my-data :grouped-data (1- sel)) sel))))))

    (setf lp (leverage-plot (send nway :fit-values) (send nway :y)
                            :location location21
                            :size graph-size
                            :go-away nil
                            :show nil
                            :reg-line t
                            :mean-line t))
    (send lp :y-axis t t (third (send bp :y-axis)))
    (send lp :variable-label 1 (first (send my-data :variables)))
    (send lp :variable-label 0 
          (strcat "Predicted " (first (send my-data :variables))))
    (send lp :show-window)
    (defmeth lp :close ()
      (send bp :close))

    (setf rp (send nway :plot-bayes-residuals 
                   :location location22 :size graph-size 
                   :go-away nil :show nil))
    (send rp :y-axis t t (third (send rp :y-axis)))
    (send rp :variable-label 1 "Bayes Residuals")
    (send rp :range 0 (first (send lp :range 0)) (second (send rp :range 0)))
    (send rp :x-axis t t (third (send lp :x-axis)))
    (send rp :variable-label 0 
          (strcat "Predicted " (first (send my-data :variables))))
    (defmeth rp :close ()
      (send bp :close))
    (send rp :show-window)

    (setf pp (plot-points (1+ (* 2 (iseq (length grouped-data))))
                          (mapcar #'mean grouped-data)
                          :location location23
                          :go-away nil :title "Profile Plot" :show nil
                   ;       :size (list (- (first namelist-size) msdos-fiddle)
                   ;              (- (second namelist-size) msdos-fiddle))
                          ))

    (send pp :size (- (first namelist-size) msdos-fiddle)
          (- (second namelist-size) msdos-fiddle))
    (send pp :range 0 0 (* 2 (length grouped-data)))
    (send pp :range 1 (first (send bp :range 1)) 
          (second (send bp :range 1)))
    (send pp :x-axis t t 0)
    (send pp :variable-label 0 (second design))
    (send pp :variable-label 1 (strcat (first (send my-data :variables))
                                      " LS Means"))
    (send pp :y-axis t t (third (send bp :y-axis)))
    (send pp :add-lines (1+ (* 2 (iseq (length grouped-data))))
                          (mapcar #'mean grouped-data))
    (send current-model :profile-labels (first (send my-data :classes)))
    (defmeth pp :close ()
      (send bp :close))
    (send pp :show-window)
                          
    (defmeth pp :new-plot (grouped-data sel)
      (let* ((x (1+ (* 2 (iseq (length grouped-data)))))
             (y (mapcar #'mean grouped-data))
             (y1 nil)
             (nways (send my-data :nways))
             (knt nways)
             (nlevels (send my-data :nclasses))
             (inow nil)
             (ilevels nil)
             (jlevels nil))
        (send current-model :line-labels nil)
        (send current-model :line-xs nil)
        (send current-model :line-ys nil)
        (send pp :start-buffering)
        (send pp :clear)
        (send pp :variable-label 0 "Overall")
        (send pp :range 0 0 0)
        (cond ((<= sel nways)
               (send pp :add-points x y)
               (send current-model :profile-labels 
                     (nth (1- sel) (send my-data :classes)))
               (send pp :add-lines x y)
               (send pp :variable-label 0 (nth (1- sel) (send my-data :ways)))
               (send pp :range 0 0 (* 2 (length grouped-data))))
          (t (dotimes (i (- nways 1))
                      (dolist (j (iseq (1+ i) (- nways 1)))
                              (setf knt (1+ knt))
                              (when (= knt sel)
                                    (send pp :variable-label 0 
                                          (nth j (send my-data :ways)))
                                    (send current-model :profile-labels 
                                          (nth j (send my-data :classes)))
                                    (setf inow i)
                                    (setf ilevels (nth i nlevels))
                                    (setf jlevels (nth j nlevels)))))
             (setf x (1+ (* 2 (iseq jlevels))))
             (dotimes (i ilevels)
                      (setf y1 (select y (iseq (* i jlevels) 
                                            (+ (* i jlevels) (1- jlevels)))))
                      (send pp :add-points x y1)
                      (send pp :add-lines  x y1)
                      (send current-model :line-labels
                            (add-element-to-list 
                             (send current-model :line-labels) 
                             (nth i (nth inow (send my-data :classes)))))
                      (send current-model :line-xs
                            (add-element-to-list (send current-model :line-xs)
                                                 (first (last x))))
                      (send current-model :line-ys
                            (add-element-to-list (send current-model :line-ys)
                                                 (first (last y1))))
                      )
             (send pp :range 0 0 (* 2 (length x)))))
        (send pp :buffer-to-screen)
        ))

    (defmeth pp :redraw ()
      (send self :start-buffering)
      (call-next-method)
      (when (> (send self :num-points) 0) (send self :label-x-axis))
      (send self :buffer-to-screen))
    
    (defmeth pp :label-x-axis ()
      (let* ((labels (send current-model :profile-labels))
             (line-labels (send current-model :line-labels))
             (h (send self :canvas-height))
             (x (send self :point-canvas-coordinate 0 (iseq (length labels))))
             (o (first (send self :content-origin)))) 
        (dotimes (i (length labels))
                 (send self :draw-line (+ o (nth i x)) (- h 45) 
                       (+ o (nth i x)) (- h 40))
                 (send self :draw-text (select labels i) 
                       (+ o (nth i x)) (- h 25) 1 0))
        (when (send current-model :line-labels)
              (dotimes (i (length line-labels))
                       (send self :add-line-label
                             (nth i (send current-model :line-labels))
                             (nth i (send current-model :line-xs))
                             (nth i (send current-model :line-ys)))))
        ))

    (defmeth pp :add-line-label (label x y)
      (let* ((xyc (send self :real-to-canvas x y)))
        (send self :draw-text label (+ 5 (first xyc))
              (+ 3 (second xyc)) 0 0)))
    (error-message "WARNING: Leverage Plot and Bayes Residual Plot are not yet completely functional.")
    ))

(defmeth regression-model-proto :plot-bayes-residuals 
  (&key x-values (show t) location size (go-away t))
"Message args: (&optional x-values)
Opens a window with a plot of the standardized residuals and two standard
error bars for the posterior distribution of the actual deviations from the
line. See Chaloner and Brant. If X-VALUES are not supplied  the fitted values
are used. The plot can be linked to other plots with the link-views function.
Returns a plot object."
  (let* ((r (/ (send self :residuals) (send self :sigma-hat)))
         (d (* 2 (sqrt (send self :leverages))))
         (low (- r d))
         (high (+ r d))
         (x-values (if x-values x-values (send self :fit-values)))
         (p (plot-points x-values r :title "Bayes Residual Plot"
                         :point-labels (send self :case-labels)
                         :show nil
                         :go-away go-away
                         :location location
                         :size size)))
    (map 'list #'(lambda (a b c d) (send p :plotline a b c d nil))
               x-values low x-values high)
    (send p :abline 0 0)
    (send p :adjust-to-data)
    (when show (send p :show-window))
    p))

;;************************************************************************
;; leverage-plot-proto
;;************************************************************************

(defun leverage-plot 
  (xdata ydata &key reg-line mean-line (title "Leverage Plot") 
     nice-x-range nice-y-range
     (variable-labels (list "Predicted Values" "Values"))  
     point-labels location size (go-away t) (show t))
"Args (xdata ydata &key (title Leverage Plot) reg-line point-labels  variable-labels location size (go-away t) (show t))
XDATA and YDATA are sequences which have to be the same length. Makes a leverage plot of the two sequences.  When REG-LINE is t a regression line with confidence envelope is to be added to the plot.  When MEAN-LINE is t a line is drawn at the mean of YDATA.  Range and tick-marks for x and y are determined by get-nice-range unless NICE-RANGE-X and NICE-RANGE-Y (lists of min, max, num tick marks) are specified. Remaining arguments are the same as for scatterplots. Function written by Forrest Young."
  (send leverage-plot-proto :new xdata ydata 
        :reg-line reg-line :mean-line mean-line
        :nice-x-range nice-x-range :nice-y-range nice-y-range
        :title title :point-labels point-labels
        :variable-labels variable-labels :location location 
        :size size :go-away go-away :show show))

(defun lplot (xdata ydata &rest args)
  (apply #'leverage-plot xdata ydata args))

(defproto leverage-plot-proto '(xdata ydata reg-line) () scatterplot-proto)

(defmeth leverage-plot-proto :xdata (&optional (list nil set))
"Args: (&optional list)
Sets or returns the plot data for the x-axis."
  (if set (setf (slot-value 'xdata) list))
  (slot-value 'xdata))

(defmeth leverage-plot-proto :ydata (&optional (sequence nil set))
"Args: (&optional sequence)
Sets or returns the plot data for the y-axis."
  (if set (setf (slot-value 'ydata) sequence))
  (slot-value 'ydata))

(defmeth leverage-plot-proto :reg-line (&optional (logical nil set))
"Args: (&optional list)
Sets or returns t or nil for whether there is a regression line."
  (if set (setf (slot-value 'reg-line) logical))
  (slot-value 'reg-line))

(defmeth leverage-plot-proto :isnew 
  (xdata ydata &key reg-line mean-line nice-x-range nice-y-range title 
         variable-labels point-labels location size go-away show)
  (call-next-method 2 :title title 
                    :location location :size size :go-away go-away :show nil)
  (send (send self :menu) :title "LevPlot")
  (send self :new-plot xdata ydata
        :variable-labels variable-labels
        :point-labels point-labels
        :reg-line reg-line
        :mean-line mean-line
        :nice-x-range nice-x-range
        :nice-y-range nice-y-range)
  (when show (send self :show-window))
  self)

(defmeth leverage-plot-proto :new-plot 
  (xdata ydata &key variable-labels point-labels reg-line mean-line
         nice-x-range nice-y-range)
  (send self :start-buffering)
  (send self :clear)
  (send self :xdata xdata)
  (send self :ydata ydata)
  (let ((x-range nice-x-range)
        (y-range nice-y-range))
    (when (not x-range)
          (setf x-range (get-nice-range (min xdata) (max xdata) 4)))
    (send self :range 0 (nth 0 x-range) (nth 1 x-range))
    (send self :x-axis t t (nth 2 x-range))
    (when (not y-range)
          (setf y-range (get-nice-range (min ydata) (max ydata) 4)))
    (send self :range 1 (nth 0 y-range) (nth 1 y-range))
    (send self :y-axis t t (nth 2 y-range)))
  (send self :add-points xdata ydata)
  (when (and reg-line (> (length (remove-duplicates xdata)) 1))
        (let* ((ab (send (regression-model xdata ydata :print nil) 
                         :coef-estimates))
               (a (first ab))
               (b (second ab)))
          (send self :add-lines 
                (list (/ (- (min ydata) a) b) (/ (- (max ydata) a) b))
                (list (min ydata) (max ydata)))))
  (when mean-line (send self :abline (mean ydata) 0))
  (when (not variable-labels) (setf variable-labels (list "" "")))
  (when (not (first  variable-labels)) (setf (first  variable-labels) ""))
  (when (not (second variable-labels)) (setf (second variable-labels) ""))
  (send self :variable-label 0 (first variable-labels))
  (send self :variable-label 1 (second variable-labels))
  (send self :redraw)
  (send self :buffer-to-screen)
  )