;;######################################################################## 
;; ViSta.lsp
;; Copyright (c) 1991-96 by Forrest W. Young 
;; Version 4.22 Beta, January 8th, 1996 
;; For further information contact the author at forrest@unc.edu 
;; Modified for X11 by Anthony J. Rossini (rossini@stat.sc.edu)
;; This file contains initialization code and hardware-specific code
;;######################################################################## 

#-xlisp-plus(error "ViSta requires XLisp-Plus and version 3.37 (or later) of XLisp-Stat.") 
#-dialogs(error "ViSta requires the XLisp-Stat Dialogs feature.") 
#-windows(error "ViSta requires the XLisp-Stat Windowing sub-system.") 
;;AJR: 960315
;;#+X11(error "This version of ViSta does not yet work under Unix. Contact Tony Rossini (rossini@stat.sc.edu) for current information.") 


(provide "vista")
(setf version-number " 4.")
(setf release-number "22 Beta")
(setf release-date "January 8th, 1996") 
#-X11 (setf X11-version "")
#+X11 
(setf X11-version (format nil "~%X11 modifications 960620 by A.J. Rossini"))
#+X11 (setf release-number (strcat release-number "-X11"))

;; define window sizes, locations and offsets. 

#+macintosh (setf menu-bar-height 38)
#+macintosh (setf window-decoration-width 18) 
#+macintosh (setf window-decoration-height 18) 
#+macintosh (setf size-width-fiddle 0)
#+macintosh (setf size-height-fiddle 0)

#+msdos(setf menu-bar-height 0)
#+msdos(setf window-decoration-width 8)
#+msdos(setf window-decoration-height 8) 
#+msdos(setf size-width-fiddle 0)
#+msdos(setf size-height-fiddle 0);0
#+msdos(setf msdos-fiddle 15);15
#-msdos(setf msdos-fiddle 0)

;; The following window sizes, locations and offsets work for a 
;; DEC 3100 with 19" monochrome screen (1024x864 resolution) using Motif. 
;; For other screens and windowing systems these numbers may have to be 
;; fiddled with to get spreadplot tileing right. 

;;#+X11 (setf menu-bar-height 0)
;;#+X11 (setf window-decoration-width 0)
;;#+X11 (setf window-decoration-height 0)
;;#+X11 (setf size-width-fiddle 22)
;;#+X11 (setf size-height-fiddle 70)

;; For a SS20 (Solaris 2.4), with 20" color monitor, this seems to
;; work, and it isn't too shabby on a DX4-100 Notebook, running Linux
;; and X, either.

#+X11 (setf menu-bar-height 0)
#+X11 (setf window-decoration-width 0)
#+X11 (setf window-decoration-height 0)
#+X11 (setf size-width-fiddle 50)
#+X11 (setf size-height-fiddle 50)

(setf screen-size (* 2 (floor (/ (screen-size) 2)))) 
#+msdos (setf screen-size (list (select screen-size 0) 
(- (select screen-size 1) 58)));56 54

;(setf screen-size (list 640 480)) for report figures only

(defun spreadplot-sizes (size)
  (setf screen-size size)
  (setf row-pixels (select screen-size 1)) 
  (setf graph-size (floor (/ (- row-pixels
				menu-bar-height)
			     2))) 
  (setf med-graph-width (floor (/ (first screen-size)
				  2))) 
  (setf med-graph-height graph-size)
  (setf wide-graph-width (first screen-size)) 
  (setf wide-graph-height graph-size)
  (setf location11 (list 1 menu-bar-height)) 
  (setf location12
        (list (+ graph-size window-decoration-width) menu-bar-height)) 
  (setf location13
        (list (* 2 (+ graph-size window-decoration-width)) menu-bar-height)) 
  (setf location21
        (list 1 (+ graph-size menu-bar-height window-decoration-height))) 
  (setf location22
        (list (+ graph-size window-decoration-width) 
              (+ graph-size menu-bar-height window-decoration-height))) 
  (setf location23
        (list (* 2 (+ graph-size window-decoration-width)) 
              (+ graph-size menu-bar-height window-decoration-height))) 
  (setf graph-size
        (list (- graph-size size-width-fiddle)
              (- graph-size size-height-fiddle)))
  (setf med-graph-size
        (list (- med-graph-width size-width-fiddle) 
              (- med-graph-height size-height-fiddle))) 
  (setf wide-graph-size
        (list (- wide-graph-width size-width-fiddle) 
              (- wide-graph-height size-height-fiddle))) 

  (setf full-graph-size
        (list (- wide-graph-width size-width-fiddle 9) 
              (- (* 2 wide-graph-height) size-height-fiddle 10))) 

#+macintosh(setf full-graph-size (+ full-graph-size (list (- 9) 28))) 

  (setf namelist-size 
        (list (- (select screen-size 0)
		 (select location23 0)
		 8 
                 (- msdos-fiddle)) 
              (select graph-size 1)))
  (setf long-namelist-length 
        (* 2 (+ 10 (- (select namelist-size 1)
		      msdos-fiddle))))
#+msdos (setf long-namelist-length (+ long-namelist-length 3))
#+macintosh (setf long-namelist-length (- long-namelist-length 2))
  (setf (select graph-size 1) (- (select graph-size 1) msdos-fiddle))
  )

(spreadplot-sizes screen-size)

;; AJR: all of the next three "+macintosh" components were -msdos
;; things.  960315
#+macintosh (setf var-obs-window-size (list 100 196)) 
#+msdos     (setf var-obs-window-size (list 125 193)) 
#+X11       (setf var-obs-window-size (list 300 400))
#+macintosh (setf obs-window-location (list 505 40)) 
#+msdos     (setf obs-window-location (list 508 0))   ;483 0)) 
#+X11       (setf obs-window-location (list 300 300))
#+macintosh (setf var-window-location (list 505 258))
#+msdos     (setf var-window-location (list 508 221)) ;483 221)) 
#+X11       (setf var-window-location (list 300 500))

;; $$$$$ Added 100 to all X11 values above  TAC $$$$$

(when (> (first screen-size)
         (+ 5 (first var-window-location) (* 2 (first var-obs-window-size)))) 
      (setf (first var-window-location)
            (+ 5 (first var-window-location) (first var-obs-window-size))) 
      (setf (second var-window-location) (second obs-window-location)) 
      (setf (second var-obs-window-size) 414)
      )

(setf about (strcat "ViSta: The Visual Statistics System 

Copyright (c) 1991-1995 by Forrest W. Young
Version " version-number release-number " (" release-date ")"X11-version"

Current documentation and code can be
obtained from http://forrest.psych.unc.edu")) 

#+msdos(defun about-vista ()
         (setf *copyright*
               (send dialog-proto :new 
                     (list (send text-item-proto :new about)) 
                     :title "About ViSta"
                     :location '(10 10)
                     :size '(320 140)
                     )))
#+macintosh (defun about-vista ()
	      (setf *copyright*
		    (send dialog-proto :new 
			  (list (send text-item-proto :new about)) 
			  :title "About ViSta")))

#+X11 (defun about-vista ()
	(setf *copyright*
	      (send dialog-proto :new 
		    (list (send text-item-proto :new about)) 
		    :title "About ViSta")))

#+msdos(about-vista)
#+macintosh(send *listener* :flush-window)
#-msdos(princ about)
#-msdos(terpri)
#-msdos(terpri)
(load (strcat *vista-dir-name* "vismenus")) 
(load (strcat *vista-dir-name* "iconobj1")) 
(load (strcat *vista-dir-name* "iconobj2")) 
(load (strcat *vista-dir-name* "workmap1")) 
(load (strcat *vista-dir-name* "workmap2")) 
(load (strcat *vista-dir-name* "workmap3")) 
(load (strcat *vista-dir-name* "systmobj")) 
(load (strcat *vista-dir-name* "dataobj1")) 
(load (strcat *vista-dir-name* "dataobj2")) 
(load (strcat *vista-dir-name* "dataobj3")) 
(load (strcat *vista-dir-name* "dashobj1")) 
(load (strcat *vista-dir-name* "dashobj2")) 
(load (strcat *vista-dir-name* "dashobj3")) 
(load (strcat *vista-dir-name* "modelobj")) 
(load (strcat *vista-dir-name* "tranobj1")) 
(load (strcat *vista-dir-name* "tranobj2")) 
(load (strcat *vista-dir-name* "function")) 
(load (strcat *vista-dir-name* "statfunc")) 
(load (strcat *vista-dir-name* "generic")) 

(setf *desktop* (desktop))
(setf *workmap* *desktop*)
(send *workmap* :toolbar nil)
(setf *toolbox* (toolbox))
(send (select (send *toolbox* :icon-list) 0) :icon-state "normal") 
(send *workmap* :gui t)

#+msdos (send *workmap* :location 4 158) 
#+msdos (send *workmap* :size 500 280)

#+X11 (send *workmap* :location 50 200)
#+X11 (send *workmap* :size 600 330) ;; (- (second full-graph-size) 24)) ;280) 

;; $$$$$ Added 100 to first value & 50 to second value for X11  TAC $$$$$

(send *workmap* :num-data-menu-items
(length (send (eval *data-menu*) :items))) 
(send *workmap* :num-model-menu-items
(length (send (eval *model-menu*) :items))) 

;; define global variables

(setf current-data nil)
(setf current-model nil)
(setf current-transf nil)
(setf current-object nil)
(setf previous-data nil)
(setf *guidemap*	nil)
(setf *expertmap* nil)

(setf v-options '((0)))

;;create system object
(setf *vista* (vista-system))
;; AJR, -msdos -> +macintosh, etc, and added X11 960315
#+macintosh (send *vista* :guide-window-location '(257 20)) 
#+msdos     (send *vista* :guide-window-location '(258 158)) 
#+X11       (send *vista* :guide-window-location '(250 200)) ;;'(200 500)) 
#+macintosh (send *vista* :guide-window-size '(243 280)) 
#+msdos     (send *vista* :guide-window-size '(246 280)) 
#+X11       (send *vista* :guide-window-size '(400 500)) 
        (setf *var-window* (send *vista* :var-window-object)) 
        (setf *obs-window* (send *vista* :obs-window-object)) 
        (apply #'send *var-window* :size var-obs-window-size) 
        (apply #'send *obs-window* :size var-obs-window-size) 

;;(send *obs-window* :show-window)
;;(send *var-window* :show-window)

#+macintosh(send *listener* :hide-window) 
#+macintosh(send *listener* :flush-window) 
#+macintosh(apply #'send *listener* :size '(490 112)) 
(setf *text-window-size*
      (list 490 (max 112 (min 280 (- (second screen-size) 326))))) 
(setf *text-window-location* (list 10 (min 322 (- row-pixels 138)))) 
#+macintosh(apply #'send *listener* :location *text-window-location*) 

#+macintosh (send *apple-menu* :append-items 
                  (send menu-item-proto :new "About ViSta" :action 
                        #'(lambda () (about-vista))))

(defun make-long-menus ()
  (send *vista* :long-menus t)
  (send *data-menu* :append-items (send dash-item-proto :new)) 
  (send *model-menu* :append-items (send dash-item-proto :new)) 
  (send *workmap* :num-data-menu-items
        (1+ (send *workmap* :num-data-menu-items))) 
  (send *workmap* :num-model-menu-items
        (1+ (send *workmap* :num-model-menu-items))) 
  )

(send *vista* :long-menus nil)
(load (strcat *vista-dir-name* "prefs")) 
(when ask-load-vista (send *vista* :show-load-vista t)) 

#+macintosh (send *listener* :title "LispStat") 
#+macintosh (send *listener* :flush-window) 
#+msdos(msdos-file-menu)
#+msdos(send *copyright* :close)
#-msdos(princ about)
#-msdos(terpri)

(defun simulate-data () (error-message "Data simulation is not yet implemented.")) 

(defun error-message (string &optional error)
  (let* ((numchar (length string))
         (numlines (ceiling numchar 50))
         (message (format nil "ViSta Warning Message:~%")) 
         (start 0)
         (finish nil))
    (when error (setf message (format nil "ViSta Error Message - Computations Interrupted.~%"))) 
    (setf string (strcat " " string))
    (dotimes (i numlines)
             (setf start (position #\  string :start (* i 50))) 
             (setf finish (position #\  string :start
                                    (min numchar (* (1+ i) 50))))
             (when (not finish) (setf finish (1+ numchar))) 
             (setf message (strcat message 
                           (format nil "~%~a" (subseq string start finish))))
             (when (> finish numchar)  (return)))
    (message-dialog message)))

#| - ael - Tue May 5 23:18:47 1998
It was a dirty trick to redefine error so that old errors would get burned...

(defun error (str)
  (error-message str t)
  (top-level))
 - lea - |#

(defun error (&rest str)
  (error-message (apply #'format nil (first str) (rest str)) t)
  (top-level))

