#
#		evenp
#
proc evenp {n} {
    set tmp1 [expr $n * 1.0 / 2]
    set tmp2 [expr floor([expr $n * 1.0 / 2])]
    if {$tmp1 == $tmp2} {
	return 1
    } else {
	return 0
    }
}
#
#		oddp
#
proc oddp {n} {
    expr 1 - [evenp $n]
}
#
#		stringEqual
#
proc stringEqual {s1 s2} {
    return [shiftTest [string compare $s1 $s2]]
}
#
#		shiftTest
#
proc shiftTest value {
    # proc shiftTest turns the -1, 0, 1 variable into a proper binary variable, \
	    where 0 becomes true, and the others false:
    expr 1-abs($value)
}
#
#		saveTexttoFile
#
proc saveTexttoFile {w file {overwrite ""} {start 1.0} {end end}} {
    # saves the text in an input widget to a file, oddly enough.
    if {$file != ""} {
	set new 1
	if {$overwrite == ""} {set tmp 1} else {set tmp 0}
	while {[file exists $file] && \
		[expr $new == 1] && \
		$tmp} {
	    set new \
		    [tk_dialog .tk_dialog {File Exists!} \
		    "File $file exists: overwrite?" {} 0 Yes Rename Cancel\
		    ]
	    if {$new == 1} {
		set file [genericEntry "" "Filename in which to save text:"]
		if {$file == ""} {return}
	    } elseif {$new == 2} {
		return
	    }
	}
	set f [open $file w]
	puts $f [$w get $start $end]
	close $f
    }
}
proc saveStringtoFile {w file {overwrite ""}} {
    # saves a string to a file.
    if {$file != ""} {
	set new 1
	if {$overwrite == ""} {set tmp 1} else {set tmp 0}
	while {[file exists $file] && \
		[expr $new == 1] && \
		$tmp} {
	    set new \
		    [tk_dialog .tk_dialog {File Exists!} \
		    "File $file exists: overwrite?" {} 0 Yes Rename Cancel\
		    ]
	    if {$new == 1} {
		set file [genericEntry "" "Filename in which to save text:"]
		if {$file == ""} {return}
	    } elseif {$new == 2} {
		return
	    }
	}
	set f [open $file w]
	puts $f $w
	close $f
    }
}
#
#		importFile:
#
proc importFile {w {append ""}} {
    set file [chooseFile "."]
    if {$file != ""} {
	if {$append == ""} {$w delete 1.0 end}
	set f [open $file]
	while {![eof $f]} {$w insert end [read $f 1000]}
	close $f
    }
}
#
#		chooseFile
#
proc chooseFile {dir} {
    # choose a file from a directory:
    global chooseFileVar  chooseFileDir chooseWin listBox
    set chooseFileVar ""
    set chooseFileDir $dir
    set chooseWin .chooseFile

    # create the generic list box containing the file listing:
    set listBox [genericListBox [exec ls -a $chooseFileDir] \
	    $chooseWin "Choose File:"]
    
    # Set up bindings for the window:
    bind $chooseWin <Double-Button-1> {
	foreach i [selection get] {chooser $i}
    }
    
    # The procedure below is invoked to open a browser on a given file;  if \
	    the file is a directory then another instance of this program is \
	    invoked; if the file is a regular file then the file name is \
	    returned, and the window is destroyed.
    proc chooser {file} {
	global chooseFileDir chooseFileVar chooseWin listBox

	if {[string compare $chooseFileDir "."] != 0} {
	    set file $chooseFileDir/$file
	}
	if [file isdirectory $file] {
	    set chooseFileDir $file
	    $listBox delete 0 [$listBox size]
	    foreach i [exec ls -a $chooseFileDir] {
		$listBox insert end $i
	    }
	} elseif [file isfile $file] {
	    set chooseFileVar $file
	    destroy $chooseWin
	} else {
	    genericMessageBox "\"$file\" isn't a directory or regular file"
	}
    }
    # tkwait puts any function relying on this on hold, until the window is \
	    destroyed.
    focus $chooseWin
    tkwait window $chooseWin
    return $chooseFileVar
}
#
#		stripEnds
#
proc stripEnds {command} {
    # we're going to eliminate the carriage returns: \n's and \newline's
    while {[regsub "\n" $command "" stuff] || \
	    [regsub "\newline" $stuff "" stuff]} {
	set command $stuff
    }
    return $command
}
#
#		strcat
#
proc strcat {a} {
    # \
	    this fake of strcat strips off carriage returns, then pastes the \
	    strings together. It's not ideal, but does the job I need it \
	    to do RIGHT NOW! Could be improved, but will be once I understand \
	    things better....
    stripEnds [format "\"%s\"" $a]
}
#
#		repCount
#
proc repCount {substr str} {
    # Repetition Count procedure counts the number of repetitions of \
	    a substring in string, so that
    # repCount "s" "aeshhs sks" \
	    yields
    # 4
    set tmp $str
    set inc 0
    set foundit [string first $substr $tmp]

    while {[expr $foundit != -1]} {
	set tmp [stringTrimLeft $substr $tmp]
	set inc [expr $inc+1]
	set foundit [string first $substr $tmp]
    }
    return $inc
}
#
#		stringTrimLeft
#
proc stringTrimLeft {substr str} {
    # String trim left procedure, so that
    # stringTrimLeft "s" "aeshhs sks" \
	    yields
    # hhs sks \
	    for example.
    set substrlength [string length $substr]
    set foundit [string first $substr $str]
    if [expr $foundit == -1] {
	return $str
    } else {
	return [string range $str [expr $foundit+$substrlength] \
		[expr [string length $str]+1]]
    }
}
#
#		stringTrimRight
#
proc stringTrimRight {substr str} {
    # String trim right procedure, so that
    # stringTrimRight "s" "aeshhs sks lllk" \
	    yields:
    # aeshhs sk \
	    for example.
    set foundit [string last $substr $str]
    if [expr $foundit == -1] {
	return $str
    } else {
	return [string range $str 0 [expr $foundit-1]]
    }
}
#
#		stringSnipOutMatchedPairs
#
proc stringSnipOutMatchedPairs {substr1 substr2 str} {
    # Snip out morsels bounded by two substrings, so that
    # stringSnipOutMatchedPairs "#|" "|#" \
	    "#| (plot sin) |# (plot cos) #| (plot tan |#" \
	    yields
    # (plot cos) \
	    for example.
    set tmp $str
    set substr2length [string length $substr2]

    set found1 [string first $substr1 $tmp]
    set found2 [string first $substr2 $tmp]
    while {[expr $found1 != -1] && [expr $found2 != -1]} {
	set firstpart [string range $tmp 0 [expr $found1-1]]
	set otherpart \
		[string range $tmp \
		[expr $found2+$substr2length] \
		[expr [string length $tmp]-1]]
	set tmp $firstpart$otherpart
	set found1 [string first $substr1 $tmp]
	set found2 [string first $substr2 $tmp]
    }
    return $tmp
}
#
#		genericMessageBox
#
proc genericMessageBox {message {name "A Message for you:"} \
	{font *-Courier-Bold-R-Normal-*-120-*}} {
    # a generic message box

    set w .label
    catch {destroy $w}
    toplevel $w
    wm title $w $name
    wm iconname $w $name

    label $w.msg -font $font -wraplength 4i -justify left -text $message
    pack $w.msg -side top
    
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    button $w.buttons.dismiss -text Dismiss -command "destroy $w"
    pack $w.buttons.dismiss -side left -expand 1
    bind $w <Return> "$w.buttons.dismiss invoke"
    focus $w
}
#
#		genericListBox
#
proc genericListBox {HLinitialized {name .genericListBox} {title ""}} {
    # genericListBox returns the name of the listbox created.

    set w $name
    catch {destroy $w}
    toplevel $w
    wm title $w $title
    wm iconname $w $title
    wm minsize $w 1 1

    # create three frames:
    set frame $w.genericListBox
    set frame1 [join [list $frame "1"] ""]
    set frame2 [join [list $frame "2"] ""]
    set frame3 [join [list $frame "3"] ""]
    foreach frame [list $frame1 $frame2 $frame3] {
	frame $frame
	pack $frame -side top -fill x
    }

    # create the listbox and buttons that fill the three frames:
    scrollbar $frame1.scroll_y -orient vertical -command "$frame1.list yview" \
	    -relief sunken -borderwidth 2
    scrollbar $frame2.scroll_x -orient horizontal -command "$frame1.list xview" \
	    -relief sunken -borderwidth 2
    listbox $frame1.list \
	    -yscroll "$frame1.scroll_y set" \
	    -xscroll "$frame2.scroll_x set" \
	    -relief sunken -width 40 -height 12 -setgrid yes

    # initialize the listbox:
    foreach i $HLinitialized {
	$frame1.list insert end $i
    }
    button $frame3.cancel -text done -command "destroy $w"

    # pack it all in:
    pack $frame1.scroll_y -in $frame1 -side right -fill y
    pack $frame1.list -in $frame1 -expand yes -fill both
    pack $frame2.scroll_x -in $frame2 -side bottom -fill x
    pack $frame3.cancel -in $frame3 -expand yes -fill x -side bottom

    # returns the name of the listbox:
    return $frame1.list
}
#
#		genericEntry
#
proc genericEntry {init {name "Entry Widget"} {label ""} \
	{font *-Courier-Bold-R-Normal-*-120-*}} {
    # a generic entry widget
    global ge_init

    set ge_init $init
    set w .ge_entry
    catch {destroy $w}
    toplevel $w
    wm title $w $name
    wm iconname $w $name
    
    label $w.msg -font $font -wraplength 5i -justify left -text $label
    pack $w.msg -side top
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m

    button $w.buttons.ok -text OK -command "destroy $w"
    button $w.buttons.dismiss -text Dismiss \
	    -command "set ge_init \"\";destroy $w"
    pack $w.buttons.ok $w.buttons.dismiss -side left -expand 1

    entry $w.e1 -font $font -relief sunken -textvariable ge_init
    bind $w.e1 <Return> "$w.buttons.ok invoke"

    pack $w.e1 -side top -pady 5 -padx 10 -fill x

    focus $w.e1
    tkwait window $w
    return $ge_init
}
#
#######################################################################
#
#	from search.tcl
#
# textSearch --
# Search for all instances of a given string in a text widget and
# apply a given tag to each instance found.
#
# Arguments:
# w -		The window in which to search.  Must be a text widget.
# string -	The string to search for.  The search is done using
#		exact matching only;  no special characters.
# tag -		Tag to apply to each instance of a matching string.
proc textSearch {w string tag} {
    $w tag remove search 0.0 end
    if {$string == ""} {
	return
    }
    set cur 1.0
    # ael: I had to add length: the -count length option doesn't seem to \
	    work as advertised...
    set length [string length $string]
    # lea
    while 1 {
	set cur [$w search -count length $string $cur end]
	if {$cur == ""} {
	    break
	}
	$w tag add $tag $cur "$cur + $length char"
	set cur [$w index "$cur + $length char"]
    }
}
#
# textToggle --
# This procedure is invoked repeatedly to invoke two commands at
# periodic intervals.  It normally reschedules itself after each
# execution but if an error occurs (e.g. because the window was
# deleted) then it doesn't reschedule itself.
#
# Arguments:
# cmd1 -	Command to execute when procedure is called.
# sleep1 -	Ms to sleep after executing cmd1 before executing cmd2.
# cmd2 -	Command to execute in the *next* invocation of this
#		procedure.
# sleep2 -	Ms to sleep after executing cmd2 before executing cmd1 again.
proc textToggle {cmd1 sleep1 cmd2 sleep2} {
    catch {
	eval $cmd1
	after $sleep1 [list textToggle $cmd2 $sleep2 $cmd1 $sleep1]
    }
}
#
#	-- using these for the superfluous "highlight search"
#
proc genericHighlightSearch {searchString windows \
	{font *-Courier-Bold-R-Normal-*-120-*} {name "Neon Search:"}} {

    set label "
    The highlight (or neon) search allows you to highlight all occurrences of a string in the input and output windows. This is an exact search: case matters."

    set w .entry1
    catch {destroy $w}
    toplevel $w
    wm title $w $name
    wm iconname $w $name
    
    label $w.msg -font $font -wraplength 5i -justify left -text $label
    pack $w.msg -side top
    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    button $w.buttons.dismiss -text Dismiss \
	    -command "foreach win [list $windows] \
	    {textSearch \$win \"\" search}; \
	    destroy $w"
    button $w.buttons.ok -text Highlight \
	    -command "foreach win [list $windows] \
	    {textSearch \$win \$searchString search}"
    pack $w.buttons.dismiss $w.buttons.ok -side left -expand 1
    entry $w.e1 -relief sunken -textvariable searchString
    pack $w.e1 -side top -pady 5 -padx 10 -fill x

    bind $w.e1 <Return> "$w.buttons.ok invoke"
    focus $w.e1
}
proc setupNeon {windows} {
    if {[winfo depth .] > 1} {
	set color #ce5555
    } else {
	set color black
    }
    foreach win $windows {
	textToggle "$win tag configure search -background \
		$color -foreground white" 800 "$win tag configure \
		search -background {} -foreground {}" 200
    }
}
#
#######################################################################
#
#			From the tclhelp file: (modified)
#
#######################################################################
set searchCase -nocase
proc SearchPanel {searchString win {font *-Courier-Bold-R-Normal-*-120-*}} {
    global searchCase

    set w .search
    catch {destroy $w}
    toplevel $w
    wm title $w "Search"
    wm iconname $w "Search"
    wm minsize $w 1 1

    frame $w.topframe
    pack $w.topframe -side top -fill x

    button $w.topframe.quit -text "Dismiss" \
	    -command "$win tag remove sel 1.0 end; destroy $w"
    button $w.topframe.back -text "Backwards" \
	    -command "PerformSearch $win 0 \[$w.entry get\]"
    button $w.topframe.search -text "Forwards" \
	    -command "PerformSearch $win 1 \[$w.entry get\]"
    checkbutton $w.topframe.case -text "Exact" -variable searchCase

    pack $w.topframe.quit -side left
    pack $w.topframe.back -side left
    pack $w.topframe.search -side left
    pack $w.topframe.case -side left

    frame $w.frame
    pack $w.frame -side top -fill x

    label $w.label -text "Search for"
    pack $w.label -side left

    entry $w.entry -font $font -relief sunken -textvariable searchString
    pack $w.entry -side left -fill x -expand y

    bind $w.entry <Return> "PerformSearch $win 1 \[$w.entry get\]"

    # Allow input without Button1 press.
    focus $w.entry
    update idletasks
}
# Actually perform the search:
proc PerformSearch {w direction {string ""}} {
    global searchCase
    if {$searchCase == 0} {set case -nocase} else {set case -exact}

    set index [lindex [$w tag ranges sel] 0]
    if {$index==""} {
	set index insert
    }
    if {$string==""} {
	set string [$w tag ranges sel]
	if {$string!=""} {
	    set string [eval $w get $string]
	} else {
	    return
	}
    }
    if {$direction} {
	set index [$w search -forwards $case $string "$index + 1 char"]
    } else {
	set index [$w search -backwards $case $string "$index - 1 char"]
    }
    if {$index==""} {
	tk_dialog .searcherror "Error in Search" \
		"String \"$string\" not found" error 0 "O.K."
	return
    }
    set index2 [$w index "$index + [string length $string] char"]
    $w tag remove sel 1.0 end
    $w tag add sel $index $index2
    $w see $index
}


#
#	From taputils.tcl: 
#
# some functions which should be part of Tcl, but aren't
#
# Tom Phelps (phelps@cs.Berkeley.EDU)
#
proc lfirst {l} {return [lindex $l 0]}
proc lsecond {l} {return [lindex $l 1]}
proc lthird {l} {return [lindex $l 2]}
proc lfourth {l} {return [lindex $l 3]}
proc lfifth {l} {return [lindex $l 4]}
proc lsixth {l} {return [lindex $l 5]}
proc lseventh {l} {return [lindex $l 6]}

proc lrest {l} {return [lrange $l 1 end]}

proc llast {l} {
    set end [llength $l]
    if {!$end} {return ""}
    return [lindex $l [expr $end-1]]
}

proc setappend {l e} {
    return "[lfilter $e $l] $e"
}

proc lfilter {p l} {
    set l2 ""
    foreach i $l {
	if ![string match $p $i] "lappend l2 [list $i]"
    }
    return $l2
}

proc lassoc {l k} {
    foreach i $l {
	if {[lindex $i 0]==$k} {return [lindex $i 1]}
    }
}

# like lassoc, but search on second element, returns first
proc lbssoc {l k} {
    foreach i $l {
	if {[lindex $i 1]==$k} {return [lindex $i 0]}
    }
}

proc lreverse {l} {
    set l2 ""
    for {set i [expr [llength $l]-1]} {$i>=0} {incr i -1} {
	lappend l2 [lindex $l $i]
    }
    return $l2
}
